SWIG (Simplified Wrapper and Interface Generator)

See the CHANGES.current file for changes in the current version.
See the RELEASENOTES file for a summary of changes in each release.
Issue # numbers mentioned below can be found on Github. For more details, add
the issue number to the end of the URL: https://github.com/swig/swig/issues/

Version 4.4.0 (20 Oct 2025)
===========================

2025-10-19: phetdam
            [Python] #3286 Update docs for using setuptools instead of distutils. Improve
            docs for the -M family of options for dependency file generation.

2025-10-15: pertusus
            Fix some -Wstrict-prototypes warnings.

2025-10-02: wsfulton
            [Python] #3189 Modify StopIteration implementation for it to work across
            multiple modules.

2025-10-02: wsfulton
            [Python] Fix out typemaps for PyObject * to correctly handle NULL return.

            NULL is used as the return value for indicating that a Python exception
            has been raised. Previously C Python API code could have been called,
            but now execution is immediately returned to the Python interpreter.

2025-09-01: AnnaAraslanova
            [Python] #3254 Bug fix - mark modules as no-gil compatible only when -nogil
            flag is used.

2025-08-27: olly
	    [PHP] Fix unused label warnings (-Wunused-label in GCC and clang).

2025-08-18: greyshepherd-star
            [C#] #3248 Fix potential null poiner deref calling equals method in std::list.

2025-08-13: olly, jim-easterbrook
	    [Python] #2786 Fix handling of "default" typemap applied to method which
	    takes a single argument when "-builtin" option is used.

2025-08-13: crusaderky
            [Python] #3235 Free-threaded race condition fix in SWIG_TypeQuery.

2025-08-11: erezgeva
            #3238 Add typecheck typemaps for adding in overloading support to the
            (size_t LENGTH, char *STRING) and (char *STRING, size_t LENGTH) family of
            multi-argument typemaps.

2025-08-11: erezgeva, wsfulton
            [D] #3236 Add missing use of 'din' typemap in constructors.

2025-08-11: QuantamHD
            [Tcl] #3246 Fix memory leak in constant registration.

2025-08-08: crusaderky
            [Python] #3230 SWIG_AsArgcArgv memory fixes and thread-safety fixes for
            free-threading Python.

2025-08-01: erezgeva
            [D] #3234 Ensure 'dtype' multi-argument typemaps are being correctly used.

2025-07-28: erezgeva
            #2937 Add missing support for (size_t LENGTH, char *STRING) multi-argument typemaps.

2025-07-23: jim-easterbrook
            [Python] #3218 Added weakref support to builtin wrappers.

2025-07-18: crusaderky
            [Python] #3215 Added -nogil flag to mark modules as free-threading compatible.

2025-07-18: jim-easterbrook
            [Python] #3219 Python builtin heap types buffer support via the
            "python:bf_getbuffer" and "python:bf_releasebuffer" features improvement.
            Add workarounds/fixes for python-3.9 and earlier and ignore when using
            the limited API for versions prior to python-3.11 instead of generating
            code that won't compile.

2025-07-09: timfel
            [Python] #3217 Fix undefined behaviour in SwigPyObject_richcompare and
            SwigPyObject_compare.

2025-07-04: wsfulton
            [Python] #3260 Remove unused, out of date SWIG_Python_TypeError method.
            This support function designed for typemaps stopped being used within SWIG
            typemaps 20 years ago. Any users still relying on it have a few options
            which are outlined in #3260.

2025-06-27: wsfulton
            [Python] Raise an AttributeError instead of TypeError when there are internal
            and unexpected coding errors around member variable wrappers.

2025-06-27: jim-easterbrook
            [Python] #3206 Fix seg fault or return without exception error when attempting
            to delete (del) a wrapped member variable (builtin wrappers). This will now
            raise an AttributeError.

2025-06-27: ianlancetaylor
            [Go] Use unsafe for Go strings rather than byte arrays.
            Update minimum Go supported version to 1.20.

2025-06-23: jschueller
            [Python] #3184 #3196 Support multi-phase module initialization.

2025-06-23: wsfulton
            Fix numerous unused variable warnings (-Wunused-variable in gcc).

2025-06-20: wsfulton
            [Python] #3196 Heap types are now generated by default instead of static types
            for the builtin wrappers. Defining SWIG_HEAPTYPES to use heap types
            is no longer required.

2025-06-18: wsfulton
            [Python] #3196 Add support for -builtin and heap types turned on with
            -DSWIG_HEAPTYPES. This is an important step towards supporting a number of
            modern Python wrapper features including Py_LIMITED_API (Stable ABI compliance),
            and sharing types between interpreters.

2025-06-17: olly
	    #3197 Improve parsing of expressions related to functions calls
	    and/or member access.  For example, the following no longer give
	    parse errors:  `g().d()`, `g().D`, `a::b.c()`, `x::y.z`, `(f(1) <
	    g(2))`, `sizeof f(a,b)`

2025-06-11: wsfulton
            Remove pyname_compat.i file providing legacy names which changed in
            swig-1.3.37 and script Tools/pyname_patch.py which helped rename
            uses in user interface files.

2025-06-09: tvlEIVA
	    [Javascript] #3138 Use SetNativeDataProperty() instead of
	    SetAccessor() which fixes compatibility with recent v8 versions.

2025-06-09: olly
	    The $function variable in %exception/feature:except typemaps is
	    no longer recognised.  It was marked as deprecated in 2008.
	    Use $action (added in 2001) instead which has exactly the same
	    value.

	    SWIG/D has an unrelated $function variable which is substituted in
	    %pragma(d) wrapperloaderbindcommand - this is still supported.

2025-06-09: olly
	    [Python] #3162 Fix wrapping of a bool const& parameter with a
	    default value.  Regression introduced in SWIG 4.3.0.

2025-06-09: olly
	    [Tcl] #2887 Fix -external-runtime to generate a header which works
	    with Tcl 8.x.  Regression introduced in SWIG 4.2.1.  As a bonus
	    the generated header no longer requires the user to include tcl.h
	    and various standard C library headers before including it.

2025-05-28: olly
	    #3186 Fix parse error for C++14 forward declaration of function with
	    auto return type and no trailing return type.

2025-05-19: jschueller
            [Python] #3059 Use new buffer protocol for PY_LIMITED_API for python-3.11
            and later since this is when it was added to the stable ABI, noting that
            the old buffer protocol was removed in python-3.13.

2025-05-16: wsfulton
            #3179 Fix a regression using -kwargs since swig-4.1 in template expansion of
            function parameter values.

2025-05-13: wsfulton
            Fix undefined behaviour in directorout typemaps for void * and const char *& if
            the same wrapped function is called more than once. Note that using returning
            pointers in directors is still full of traps and not recommended. As such,
            warning SWIGWARN_TYPEMAP_DIRECTOROUT_PTR (473) continues to be issued.

2025-05-11: wsfulton
            [Python] Move the SwigPyObject, SwigPyPacked, SwigVarLink (renamed from
            swigvarlink) support Python types to the SWIG runtime module (currently called
            swig_runtime_data5).

            Note that these affect the Python runtime implementation, so the recently bumped
            SWIG_RUNTIME_VERSION to 5 for all scripting languages will now include this change.

2025-05-10: jschueller, wsfulton
            [Python] #2881 #3061 #3160 DeprecationWarning fixes when using 'python -Walways'
            or if using one of the types being warned about:

              DeprecationWarning: builtin type SwigPyPacked has no __module__ attribute
              DeprecationWarning: builtin type SwigPyObject has no __module__ attribute
              DeprecationWarning: builtin type swigvarlink has no __module__ attribute

            The warning was present if code was generated without using -builtin in 4.3.x.
            The warning was only present if using the Python limited API in 4.2.1 and earlier.

2025-04-30: wsfulton
            [Python] #3134 Fix maximum size of strings being marshalled from C/C++
            into Python. This has been changed from INT_MAX to PY_SSIZE_T_MAX in line
            with the Python C API maximum string length handling change in python-2.5.

            Similarly for the number of elements in the Python STL container wrappers.

2025-04-29: r-barnes, wsfulton
            #3027 Remove generation of empty dynamic exception specifications - throw(),
            which are deprecated in c++11. This was only when using the director feature.
            A new macro SWIG_NOEXCEPT is used which ensures that throw() or noexcept is
            used for the appropriate C++ standard that the compiler is compiling for.

2025-04-28: jschueller, henryiii
            [Python] #2967 Use __spec__.parent as the first approach to obtaining
            a module's package name when importing the low-level C/C++ module as the
            previous approach looking for __package__ is due to be removed in python-3.15.
            __package__ is now used as a fallback if __spec__.parent fails.

2025-04-28: jschueller, henryiii
            [Python] #3066 #3159 Add ht_token slot for python-3.14 support.

2025-04-18: akorobka
            #103 Thread safety bugfix in the runtime type system.

            Replaces the casting linked list with a list of arrays that does not get
            modified at runtime. The content of the cast arrays is sorted during the
            initialization so that subsequent lookups can use binary search over the
            entries obtaining O(log n) performance.

            Bump SWIG_RUNTIME_VERSION to 5 due to associated changes in runtime type
            system.

	    *** POTENTIAL INCOMPATIBILITY ***

2025-04-17: klausspanderen
            [Python] #3137 Add support for free threading Python (aka no-gil) where the
            GIL can be disabled.

2025-04-02: wsfulton
            [Java] #3156 Support JDK 21 and std::list. Fixes removeFirst() and removeLast()
            incompatibilities with methods of the same name in the base class,
            AbstractSequentialList, which were added in JDK 21 with a different
            return type. The addFirst() and addLast() methods were also added, all part
            of JEP-431 Sequenced Collections, see https://openjdk.org/jeps/431.

            If these 4 methods are needed, as SWIG previously generated them, then add
            the following to your interface file after %include <std_list.i>:

              %extend std::list {
                void removeLast() { $self->pop_back(); }
                void removeFirst() { $self->pop_front(); }
                void addLast(const T &value) { $self->push_back(value); }
                void addFirst(const T &value) { $self->push_front(value); }
              }

            But note that this will give javac compiler errors when using JDK 21 and
            later for removeFirst() and removeLast().

2025-04-02: wsfulton
            [Java] Fix javac -Xlint warning [this-escape] - JDK 21

            [this-escape] possible 'this' escape before subclass is fully initialized

            Add @WarningSuppressions("this-escape") annotation to all director
            constructors as the warning is a false positive. Similarly for
            std::list, std::vector, std::set, std::unordered_set constructors.

2025-04-02: wsfulton
            [Java] Fix javac -Xlint warnings:

            - [cast] redundant cast in std::unordered_map wrappers put method
            - [rawtypes] found raw type in std::list constructor wrapper

2025-04-02: olly
	    #3152 Remove typemaps for `signed wchar_t` and `unsigned wchar_t`
	    in C++ mode.  These types aren't specified by the C++ standard and
	    give an error with modern versions of GCC, clang or MSVC.  Older
	    GCC and clang did allow them (tested with GCC 8 and clang 8), but
	    our typemap code used `UWCHAR_MAX` which doesn't seem to have ever
	    been defined by any compiler.

2025-04-01: olly
	    [MzScheme/Racket] #920 #2830 Remove support for MzScheme/Racket.
	    It's a long time since SWIG's support was actively maintained and
	    a major overhaul would be needed to support Racket 8, for which
	    nobody has stepped forward in over 3 years.

2025-03-03: olly
	    [Guile] The typemaps in ports.i now generate code which compiles
	    even if the wrapper is compiled with in a strict standards
	    conformance mode such as -std=c11.

2025-02-28: olly
	    #3127 Fix bad generated code in some cases when a constant
	    expression is split over multiple lines and used as part of a type.
	    This manifested in cases where SWIG's parser gets the expression
	    text by skipping to the matching closing parenthesis and grabbing
	    the skipped program text.

2025-02-19: wsfulton
            Add support for $n special variable expansion in the names of typemap
            local variables, such as:

              %typemap(in) int MYINT (int $1_temp) { ... }

            $1_temp is typically expanded to arg1_temp, arg2_temp etc depending on
            which argument the typemap is applied to.

2025-02-05: wsfulton
            #3075 Regression fix when using -keyword, kwargs or compactdefaultargs
            option. Restore generating a non-const cast to the default value when
            wrapping const pointer default arguments.

2024-12-07: arbrauns
	    [Lua] #3083 Fix "unsigned long long" being interpreted as "signed
	    long long".

2024-11-22: wsfulton
            Use new <errno.h> fragment for including this header when needed instead
            of either always including it or relying on it being included elsewhere.
            Fixes the removal of errno.h when defining PY_LIMITED_API for python-3.11
            and later.

2024-11-09: wsfulton
            #3064 Perform repeated typedef lookups instead of a single typedef
            lookup on the type being applied in %apply when looking for a family
            of typemaps to apply.

2024-11-01: wsfulton
            Fix internal error handling parameters that are typedefs to references
            when using the compactdefaultargs feature.

2024-10-30: wsfulton
            #1851 Fix handling of parameters with default arguments that are
            initializer lists when using -keyword or the compactdefaultargs option.

2024-10-25: olly
	    [Guile] Allow wrapping anything with a `varout` typemap as a
	    constant.

2024-10-24: olly
	    [Perl] https://sourceforge.net/p/swig/bugs/1134/ Ensure C++
	    local variables get destroyed before throwing a Perl exception.

2024-10-22: olly
	    #3034 SWIG's testsuite is now free of SWIG warnings for all target
	    languages and the SWIG -Werror option is now enabled automatically
	    to ensure this doesn't regress.

2024-10-22: olly
	    #2998 Drop support for specifying SWIG's internal type string
	    representation in interface files.  This "secret developer feature"
	    was only documented in developer documentation, and had no test
	    coverage.

	    It allowed specifying an SWIG internal syntax type string, e.g.:

	      `p.a(10).p.f(int, p.f(int).int)` foo(int, int (*x)(int));

	    In the unlikely event that anyone was using this, we recommend you
	    use the standard C/C++ type syntax instead, which will work with
	    previous SWIG releases too, e.g.:

	      (*(*foo(int, int (*)(int)))[10])(int, int (*)(int));

	    The C/C++ syntax has the major advantage of being the same syntax
	    that C/C++ compilers use.

Version 4.3.1 (15 Apr 2025)
===========================

2025-04-10: jschueller, wsfulton
            [Python] #3067 Fix compile errors regression using external runtime and
            Py_LIMITED_API.

2025-03-31: alatina
	    [Octave] #3149 Fix to compile with Octave 10.0

2025-01-27: StefanBattmer
	    [Python] #2889 Fix regression when using directors and threads
	    but not using limited API.

2024-11-21: olly
	    [Java] #3070 Fix regression wrapping enum values which don't fit
	    in a Java signed int.

2024-10-27: olly
	    #3058 Fix precedence of casts, which should have the same high
	    precedence as unary plus and minus, but actually had a lower
	    precedence than anything else.  This could lead to the wrong type
	    being deduced in obscure cases, but also prevented SWIG deducing a
	    type for expressions such as (0)*1+2 which SWIG parses as a cast
	    and then fixes up afterwards.  A bug fixed in 4.3.0 made this
	    latter problem manifest more often (previously type deduction
	    happened to work for (0)*1+2 due to an internal field not getting
	    cleared properly).

Version 4.3.0 (20 Oct 2024)
===========================

2024-10-20: wsfulton
            #3051 Fix seg fault passing invalid unicode values when expecting a
            std::string type - fix for python-3.13.

2024-10-19: olly
	    [Ruby] Documentation comments now use `true` and `false` for bool
	    parameter default values, instead of `True` and `False` (which are
	    the Python names and wrong for Ruby!)

2024-10-16: wsfulton
            #874 Add nested classes to the parse tree dumped out by -xml.

2024-10-16: wsfulton
            #2213 Documentation for the XML output options of SWIG's parse tree has
            been added to the Extending chapter.

2024-10-09: wsfulton
            Remove -xmllang option used with -xml, which had no effect on the output.

2024-10-06: wsfulton
            [PHP] #2907 Fix returning NULL from functions with output
            parameters.

            Ensures OUTPUT and INOUT typemaps are handled consistently wrt
            return type.

            Added:
              void SWIG_Php_AppendOutput(zval *target, zval *o, int is_void);

            The t_output_helper function is deprecated. Replace t_output_helper
            in typemaps with SWIG_AppendOutput which calls SWIG_Php_AppendOutput
            appropriately setting the is_void parameter using the $isvoid special
            variable. If t_output_helper is currently being used and a completely
            backwards compatible (but technically incorrect) solution is required,
            then use SWIG_Php_AppendOutput and pass 1 instead of $isvoid for the
            is_void parameter.

            The t_output_helper fragment is also deprecated and is no longer
            needed as the SWIG_Php_AppendOutput function is now always
            generated.

2024-10-05: wsfulton
            [Ruby] Removed backwards compatible output_helper fragment and
            macro.

            Use SWIG_AppendOutput instead of output_helper (does not require
            the output_helper fragment).

	    *** POTENTIAL INCOMPATIBILITY ***

2024-10-05: wsfulton
            [Ruby] #2907 Fix returning NULL from functions with output
            parameters.

            Ensures OUTPUT and INOUT typemaps are handled consistently wrt
            return type.

            New declaration of SWIG_Ruby_AppendOutput is now:

              SWIG_Ruby_AppendOutput(VALUE target, VALUE o, int is_void);

            The 3rd parameter is new and the new $isvoid special variable
            should be passed to it, indicating whether or not the wrapped
            function returns void. If SWIG_Python_AppendOutput is currently being
            used and a completely backwards compatible (but technically incorrect)
            solution is required, then pass 1 for the is_void parameter.

            Also consider replacing with:

              SWIG_AppendOutput(VALUE target, VALUE o);

            which calls SWIG_Ruby_AppendOutput with same parameters but adding
            $isvoid for final parameter.

	    *** POTENTIAL INCOMPATIBILITY ***

2024-09-29: clintonstimpson
            [Python] #2350 Switch implementation from static types to heap
            types using PyType_FromSpec() introduced in Python 3.

            This currently only applies to the default code generation and is
            not available for the -builtin code generation.

2024-09-29: wsfulton
            [Python] Single line docstring comments are stripped of leading and
            trailing whitespace.

2024-09-29: olly
	    SWIG can now handle arbitrary expressions as a subscript (i.e. in
	    `[`...`]`).  We don't actually need to parse expressions in this
	    context so we can just skip to the matching closing square bracket.

2024-09-29: olly
	    C++11 auto variables for which SWIG can't parse the initialiser
	    now give a warning and are ignored rather than SWIG exiting with a
	    parse error.

2024-09-26: olly
	    SWIG now recognises --version as an alias for -version (it has
	    supported --help as an alias for -help since 2006).

2024-09-25: wsfulton
            [MzScheme/Racket] #920 #2830 MzScheme/Racket Deprecation notice.

            This language module no longer works with modern Racket versions
            (Racket 8 and later) due to the introduction of a different C API.
            We are thus putting out a plea for a Racket maintainer to step
            forward and rewrite the MzScheme module for Racket 8, otherwise it
            will be removed in swig-4.4.

2024-09-25: olly
	    SWIG can now handle arbitrary expressions in the parameter list of
	    a method call.  We don't actually need to parse expressions in this
	    context so we can just skip to the matching closing parenthesis.

2024-09-25: olly
	    Add support for C99 _Bool.  SWIG now treats _Bool as an alias for
	    the bool keyword when in C mode.

2024-09-23: olly
	    #3031 Improve support for C++11 trailing return types.  SWIG now
	    supports const references, const and non-const rvalue references,
	    and enum types with an explicit `enum`, `enum class` or `enum
	    struct`.

2024-09-22: wsfulton
            #3023 The binary executables in the Windows distribution are now
            64-bit now instead of 32-bit. Any 32-bit Windows OS users will need
            to build their own version using instructions in Windows.html or
            the "Getting Started Guide" for Windows on the Wiki at
            https://github.com/swig/swig/wiki/Getting-Started#windows.

2024-09-21: wsfulton
            #2879 Don't show warning SWIGWARN_LANG_SMARTPTR_MISSING (520) if
            class is ignored.

2024-09-21: olly
	    SWIG was ignoring `final` if specified after `noexcept`.

2024-09-20: olly
	    [Javascript] Fix problems with v8 support.  The tests and examples
	    now work, and configure can now successfully probe for v8 without
	    assistance on Debian and Ubuntu.

2024-09-19: wsfulton
            #2866 Fix incorrect variable setters being generated when wrapping
            reference member variables. A setter is no longer generated if the
            type of the reference member variable is non-assignable.

2024-09-18: olly
	    Fix parse error for a misplaced Doxygen comment which is the only
	    thing in a class/struct.

2024-09-18: olly
	    Fix parse error for %include/#include in a class/struct followed
	    by a member declaration.

2024-09-16: olly
	    #2995 SWIG now has generic handling for converting integer and
	    boolean literal values for use in target language code, replacing
	    code to do with in many of the target language backends.  This is
	    mainly an internal clean-up but it does fix a bug in the code it
	    replaces when wrapping code such as this:

	      typedef enum { T = (bool)1 } b;

	    With suitable enum wrapping settings, SWIG could incorrect wrap T
	    with value 0 in C#, D and Java.

	    Such cases now work correctly for D, but for C# and Java SWIG now
	    generates invalid C#/Java code because the C++ enum initialiser
	    expression isn't valid for initialising a C#/Java enum - this is
	    really an improvement over generating code which compiled but used
	    the wrong value!

	    If you are affected by this, use %csconstvalue/%javaconstvalue to
	    specify the value of such enumerators as a suitable C#/Java
	    expression.

2024-09-16: olly
	    #2560 Document complex.i in the manual.

2024-09-15: FredBonThermo
	    [C#] #2835 Support -doxygen option for converting doxygen comments
	    to XML formatted C# comments.

2024-09-14: wsfulton
            #2987 C++ reference errors when passing in a 'NULL' change of
            behaviour.  Most languages now use "NullReferenceError" in the
            error message where they previously used "ValueError". Also
            exception changes:

            Guile:    "swig-null-reference-error" instead of "swig-value-error"
            MzScheme: "swig-null-reference-error" instead of "swig-value-error"
            PHP:      TypeError instead of ValueError
            Python:   Consistently raises TypeError instead of a mix of
                      ValueError and TypeError.
            Ruby:     Consistently raises NullReferenceError instead of a mix
                      of ArgumentError and NullReferenceErrorError.

            The consistent raising of a TypeError instead of ValueError for
            Python ensures that incorrectly passing 'None' into a C++ reference
            argument will correctly convert the error into a NotImplemented
            error for the rich comparisons implementations per PEP 207.

	    *** POTENTIAL INCOMPATIBILITY ***

2024-09-13: vadz
	    [C] #2086 Add support for C as a target language.  This support is
	    currently experimental.

2024-09-12: olly
	    Remove remains of %nestedworkaround and the nestedworkaround
	    feature it uses, which were deprecated over 10 years ago in SWIG
	    3.0.0.  Since then uses of these have done nothing except emit a
	    warning.

2024-09-11: wsfulton
            [C#, Java] #1188 Add the %interface_additional macro to the family
            of %interface macros for adding additional interfaces for the
            %generated interface to extend/derive from.

2024-09-11: olly
	    #197 #675 #1677 #2047 Fix incorrect inclusion of "enum " when
	    qualifying C++11 "enum class" enumerator names.

2024-09-11: olly
	    [Perl] #630 Fix wrapping of C++11 enum class when -const command
	    line option is specified.

2024-09-07: wsfulton
            #2875 Fix swig-4.1.0 regression using the %interface family of
            macros for multiple inheritance and common bases.

2024-09-06: olly
	    [Python] Stop documenting to define SWIG_FILE_WITH_INIT - this does
	    not actually do anything (and apparently never has!)

2024-09-05: wsfulton
            #2845 Fix duplicate friend wrappers for friend declarations in
            nested classes.

2024-09-03: olly
	    #3010 Improve handling of zero bytes in input files.  This is
	    certainly a corner case, but GCC and clang both accept zero bytes
	    at least in comments, and SWIG's current handling is to ignore
	    the zero byte and all following characters up to and including the
	    next newline, so for example if a // comment contains a zero byte
	    SWIG would quietly ignore the next line.

2024-08-30: olly
	    #2996 Fix generic string literal handling to handle embedded zero
	    bytes.  This allows such strings to work for C# (with %csconst), D
	    (with %dmanifestconst), Go and Java (with %javaconst).  For other
	    target languages SWIG-generated wrappers still truncate such string
	    literals at a zero byte (which is probably the best we can do for
	    target languages where the native string can't contain zero bytes).

2024-08-23: wsfulton
            [Java] #2991 Document solutions for mismatch in C++ access
            specifiers and Java access modifiers in an inheritance hierarchy.

2024-08-19: wsfulton
	    [Python] #2993 Add missing std::filesystem namespace to
	    std_filesystem.i.

2024-08-17: olly
	    #904 #1907 #2579 Fix string literal and character literal wrapping
	    bugs.

2024-08-15: olly
	    Fix parsing of octal string escapes.  We now stop when the next
	    character is digit 8 or 9, and stop after 3 octal digits even if
	    the next character is an octal digit.

2024-08-15: olly
	    SWIG now gives an error for digits 8 and 9 in octal constants -
	    previously these were quietly accepted resulting in a bogus value.
	    C++11 binary constants are now treated similarly - only digits 0
	    and 1 were allowed before, but trying to use other digits now gives
	    a clearer error.

2024-08-12: olly
	    #657 Allow unmatched ' and " in #error and #warning.

2024-08-09: wsfulton
	    [Java] #409 Add the constantsmodifiers pragma so that the
	    visibility for the Java constants interface can be changed from
	    public to default.

2024-08-02: vadz
	    [Python] #2966 Fix overloaded Doxygen comments. Sometimes the
	    Doxygen comments were not combined into one Pydoc comment.

2024-08-01: olly
	    Fix wrapping of string constants containing bytes 0-8, 11, 12 or
	    14-31 followed by a digit '0' to '7'.  We were emitting these bytes
	    as a one or two character octal escape sequence which when
	    interpreted would include the following character.

2024-07-27: olly
	    #2087 Fix parsing of `noexcept` on a function pointer type used
	    as the type of a function parameter.  We currently generate
	    invalid C++ code if we try to wrap the function parameter, but
	    at least the user can `%ignore` the parameter or the whole
	    function, whereas the parse error was hard to work around.

2024-07-26: olly
	    Support parsing `noexcept(X)` in expressions, including deducing
	    its type (which is always `bool`).

2024-07-21: wsfulton
	    [Python] Add missing slot for init in struct _specialization_cache
            needed for python-3.13 builtin wrappers.

2024-07-21: shadchin
	    [Python] #2968 Add missing tp_versions_used slot needed for
	    python-3.13.

2024-07-19: olly
	    -Wallkw now includes keywords for Javascript.

2024-07-19: vadz
	    [Javascript] #2940 Names of object properties can be keywords in
	    Javascript so don't auto-rename them to have a leading underscore.

2024-07-18: olly
	    #1917 Stop removing `f` and `F` suffixes from float literals.
	    This was resulting in incorrect generated C# and Java code.  For
	    some cases such as `#define CONSTANT 1.0f` this was a regression
	    introduced in 4.2.0 when we started more correctly wrapping these
	    as `float` rather than `double`.

2024-07-15: vadz
            #2941 Suppress warning WARN_PARSE_USING_UNDEF for ignored using
            declarations.

2024-07-03: wsfulton
            #2860 Enhance Windows.html documentation for the popular Visual C++
            compiler recommending users to correctly set the __cplusplus macro
            in order to benefit from modern standards based features that SWIG
            provides.

2024-07-02: erezgeva
	    [Python, Ruby] #2870 Change the thread safety options for the
            director code that manages C++ director pointer ownership. Please
            define SWIG_THREADS to turn on thread safety. For Python, this can
            also be done via the threads module option or -threads.
            Implementation now includes a C++11 std::mutex option as priority
            over WIN32 and pthread mutexes. See director_guard.swg for further
            implementation details.

2024-06-28: vadz
            #2935 Fix instantiation of specialized template where the primary
            template is a forward class template declaration.

2024-06-16: wsfulton
            #2927 Don't ignore overloaded friend functions that are also
            declared constexpr.

2024-06-15: wsfulton
            [Python] Removed deprecated pytuplehlp.swg file and t_output_helper.
            Use SWIG_AppendOutput as a direct replacement for t_output_helper.

	    *** POTENTIAL INCOMPATIBILITY ***

2024-06-15: vadz
            [Python] #2907 Fix returning null from functions with output
            parameters.  Ensures OUTPUT and INOUT typemaps are handled
            consistently wrt return type.

            New declaration of SWIG_Python_AppendOutput is now:

              SWIG_Python_AppendOutput(PyObject* result, PyObject* obj, int is_void);

            The 3rd parameter is new and the new $isvoid special variable
            should be passed to it, indicating whether or not the wrapped
            function returns void. If SWIG_Python_AppendOutput is currently being
            used and a completely backwards compatible (but technically incorrect)
            solution is required, then pass 1 for the is_void parameter.

            Also consider replacing with:

              SWIG_AppendOutput(PyObject* result, PyObject* obj);

            which calls SWIG_Python_AppendOutput with same parameters but adding $isvoid
            for final parameter.

	    *** POTENTIAL INCOMPATIBILITY ***

2024-06-15: wsfulton
            #2907 Add $isvoid special variable which expands to 1 if the
            wrapped function has a void return, otherwise expands to 0.

2024-06-14: jschueller
	    #2863 Support Python 3.13 (currently in prerelease).

2024-06-13: erezgeva
            #2609 Fix Java typemap (const char *STRING, size_t LENGTH) to
            marshall as Java String instead of Java byte[]. If the old
            behaviour is required, replace with typemap (const void *BYTES,
            size_t LENGTH).

            Add multi-argument typemaps to most languages:

              (const char *STRING, size_t LENGTH)

            All languages now use a target language string type for this
            typemap.

            New multi-argument typemaps have been added to most target
            languages for use with C raw data (cdata):

              (const void *BYTES, size_t LENGTH) to

            Statically typed languages use a byte array for this typemap, while
            scripting languages remain using a string.

	    *** POTENTIAL INCOMPATIBILITY ***

            * Raw C data: Go uses byte array and int64 for size.
            Users can use the (const char *STRING, size_t LENGTH) typemaps for
            strings.

2024-06-06: olly
	    Support alignof(T) for arbitrary type T, and deduce the type of
	    alignof(T) as size_t.

2024-06-06: olly
	    #2919 Support parsing `sizeof(X)` for any expression or type X by
	    skipping balanced parentheses.  We don't need to actually parse X
	    since the type of sizeof is always size_t.

2024-06-05: leakec
            #2873 Fix -fvirtual and using declarations for inheriting base
            class methods corner case.

2024-05-31: wsfulton
            [C#, D, Java, Javascript, Lua] Fix %nspace and %nspacemove for
            nested classes and enums in a class. For example:

              %nspace Space::OuterClass80;
              namespace Space {
                struct OuterClass80 {
                  struct InnerClass80 {
                    struct BottomClass80 {};
                  };
                  enum InnerEnum80 { ie80a, ie80b };
                };
              }

            Previously the following were additionally required for some
            languages:

              %nspace Space::OuterClass80::InnerClass80;
              %nspace Space::OuterClass80::InnerClass80::Bottom80;

            Now the appropriate nspace setting is taken from the outer class.

            A new warning has also been introduced to check and correct
            conflicting nspace usage, for example if the following is
            additionally added:

              %nspacemove(AnotherSpace) Space::OuterClass80::InnerClass80;

            The following warning appears as an inner class can't be moved
            outside of the outer class:

              Warning 406: Ignoring nspace setting (AnotherSpace) for 'Space::OuterClass80::InnerClass80',
              Warning 406: as it conflicts with the nspace setting (Space) for outer class 'Space::OuterClass80'.

2024-05-31: wsfulton
            [C#, D, Java, Javascript, Lua] #2782 Enhance the nspace feature
            with %nspacemove for moving a class or enum into a differently
            named %target language equivalent of a namespace.

2024-05-31: binaire10
	    [Ruby] #2906 Fix SWIG wrappers for std::map and std::vector to
	    work with Ruby's "select".

2024-05-30: olly
	    #2914 Handle alternative operator names in C++ preprocessor
	    expressions.  Handle full set of alternative operator names in
	    C++ expressions (previously only "and", "or" and "not" were
	    understood).

2024-05-15: olly
	    #2868 Support C++17 fold expressions.

2024-05-15: olly
	    #2876 Report error if parser stack depth exceeded.  Previously SWIG
	    would quietly exit with status 0 in this situation.

2024-04-12: pfusik
            [Javascript] #2869 Fix JavaScript _wrap_getCPtr on 64-bit Windows

2024-04-12: wsfulton
            [Javascript, MzScheme, Python, Ruby] #202 Remove the vast majority
            of the /*@SWIG:...*/ locator strings in the generated wrappers for
            these 4 languages to help with reproducible builds.

2024-04-08: thewtex
            [Python] #2856 Include stdlib.h for more recent Python Stable ABI

2024-03-28: olly
	    Fix preprocessor to handle C-style comment ending **/ in macro
	    argument.

2024-03-27: wsfulton
            [Python] #2844 Fix for using more than one std::string_view type in
            a method.

2024-03-27: wsfulton
            [R] #2847 Add missing std::vector<long> and std::vector<long long>
            typemaps which were missing depending on whether or not
            SWIGWORDSIZE64 was defined.

2024-03-25: wsfulton
            [Python] #2826 Stricter stable ABI conformance.
            1. Use Py_DecRef and Py_IncRef when Py_LIMITED_API is defined
               instead of macro equivalents, such as Py_INCREF.
            2. Don't use PyUnicode_GetLength from python-3.7 and later.
            3. Use PyObject_Free instead of deprecated equivalents.

2024-03-25: olly
	    #2848 Fix elision of comma before ##__VA_ARGS__ which we document
	    as supported but seems to have not worked since before 2009.

2024-03-11: wsfulton
            [C#] #2829 Improve handling and documentation of missing enum base
            type information.

2024-03-07: wsfulton
            [Ocaml] Fix SWIGTYPE MOVE 'in' typemap to fix compilation error.

2024-03-07: wsfulton
            Add SWIGTYPE MOVE 'typecheck' typemaps to remove warning 472
            (SWIGWARN_TYPEMAP_TYPECHECK_UNDEF).

2024-03-06: wsfulton
            Add support for std::unique_ptr & typemaps. Non-const inputs
            implement move semantics from proxy class to C++ layer, otherwise
            const inputs and all reference returns behave like any other lvalue
            reference to a class.

2024-03-06: wsfulton
            [Javascript, MzScheme, Octave] Support NULL being passed into char*
            typemaps.

2024-03-06: christophe-calmejane,wsfulton
            #2650 Add support for movable std::unique_ptr by adding in
            std::unique_ptr && input typemaps. The std::unique && output
            typemaps do not support move semantics by default and behave like
            lvalue references.

2024-03-06: wsfulton
            Add missing use of move constructor instead of copy constructor
            when passing movable types by value. This was previously
            implemented only for parameters passed to a global function or
            static member function and is now extended to parameters passed to
            member methods as well as constructors.

2024-03-01: olly
	    [Java] #2819 Suppress Java removal warnings for uses of
	    System.runFinalization().  SWIG will need to stop relying on
	    finalize methods, but we know that and meanwhile these warnings
	    make the testsuite output noisy.  Fix use of deprecated form
	    of Runtime.exec() in the doxygen example.

2024-02-28: wsfulton
            #1754 Fix compilation errors in generated code when instantiating a
            templated static method within a template (non-static methods and
            constructors were always okay). For example:

              template <typename T> class X {
                template <class InputIterator>
                  static void fn(InputIterator first, InputIterator last) {
                    ...
                  }
              };
              class SimpleIterator { ... };

              %extend X<int> {
                %template(fn) fn<SimpleIterator>;
              }

Version 4.2.1 (24 Feb 2024)
===========================

2024-02-23: wsfulton
            #2814 Correctly ignore duplicate template instantiation (when the
            duplicate contains typedef'd template parameters).

2024-02-22: erezgeva
            [Ruby, Octave, R] #2284 Fix segfault shrinking STL containers.

2024-02-22: simark
	    Fix -Wundef warning about testing the value of __cplusplus when
	    compiling SWIG-generated C code.  Warning introduced by a change in
	    SWIG 4.2.0.

2024-02-21: olly
	    #2808 [PHP] Fix memory leak when getting or setting a PHP
	    attribute which wraps a C++ member variable.  Bug introduced in
	    SWIG 4.1.0.

2024-02-18: wsfulton
            #2745 Fix for wrapping STL containers that are static member variables
            or global variables (most scripting languages). Previously a copy of the
            STL container was made into a target language container when reading the
            variable. Changes, such as adjusting an element or adding/erasing
            elements, were made to the copy of the container rather the actual
            underlying C++ container. Also applies to const reference STL static
            members.

            If you really need the old behaviour, add in the typemap that used
            to provide it. For example, for std::list< int > and
            const std::list< int >&, use:

              %typemap(varout,noblock=1,fragment="SWIG_" "Traits" "_" {std::list< int >})
                  std::list< int >, const std::list< int >&  {
                $result = swig::from(static_cast< std::list< int > >($1));
              }

	    *** POTENTIAL INCOMPATIBILITY ***

2024-02-15: olly
	    Improve type deduction for enum values in expressions.

2024-02-15: rlaboiss
	    #2799 [Octave] Add support for Octave 9.0; fix warnings about use
	    of deprecated Octave APIs with Octave 7 and later.

2024-02-14: olly
	    SWIG now warns and ignores if %constant is used with an implicit
	    type which SWIG can't deduce.

2024-02-13: olly
	    Fix type deduction for certain cases involving C-style casts, or
	    which are syntactically like a C-style cast applied to an unary
	    operator, such as: (7)*6

2024-02-13: olly
	    #2796 Fix handling of enum initialised by expression including a
	    cast to a typedef-ed type.  Regression introduced in 4.2.0.

2024-02-09: wsfulton
            #2794 Fix SwigType_isvariadic assertion to add support for variadic
            templated functions in a template.

2024-02-08: wsfulton
            #2761 [Tcl] Fix assert in SWIG_Tcl_ConvertPtrFromString().

2024-02-03: wsfulton
            #1897 [C#, Java] Fix crash handling enums with same name in different
            namespaces.

2024-02-01: wsfulton
            #2781 Correctly report line number warnings/errors for base classes that
            are templates.

2024-01-31: olly
	    Fix assertion failure and segfault trying to use %constant to
	    deduce the type of a "float _Complex" constant.

2024-01-31: jim-easterbrook
            #2771 [Python] builtin fixes to handle NULL values passed to slots using
            functype: ssizeobjargproc and ternaryfunc.

2024-01-31: olly
	    [Java] #2766 Fix segfault trying to wrap a constant whose type is unknown
	    to SWIG with "%javaconst(1);" enabled.

2024-01-31: wsfulton
            #2768 Fix seg fault handling upcasting when using %shared_ptr on some
            templates.

2024-01-31: olly
	    #2783 Fix incorrectly deduced type for function call.  Regression
	    introduced in 4.2.0.

2024-01-27: wsfulton
            [Python] Fix compilation error when wrapping two or more classes that
            have the same friend operator overload when the classes are in a namespace.

2024-01-15: wsfulton
            https://sourceforge.net/p/swig/bugs/960/
            https://sourceforge.net/p/swig/bugs/807/
            Fix so that friend operators within a namespace can be correctly ignored
            or renamed.

2024-01-15: wsfulton
            Wrap friend functions that are defined or declared within a namespace.
            Previously unqualified friend definitions/declarations in a namespace were
            ignored.

            The visibility of unqualified friend functions in C++ is somewhat quirky
            and the documentation has been enhanced to aid wrapping of friends.

2024-01-12: wsfulton
            #2749 Fix seg fault handling friend constructor/destructor declarations.

2024-01-12: olly
	    [Ruby, Tcl] #2751 Fix -external-runtime output to define
	    SWIG_snprintf (bug introduced in 4.2.0).

2024-01-12: olly
	    Improve preprocessor warning for use of an undefined function-like
	    macro. SWIG now warns:

	    Warning 202: Could not evaluate expression 'MY_VERSION_AT_LEAST(1,2,3)'
	    Warning 202: Use of undefined function-like macro

	    instead of:

	    Warning 202: Could not evaluate expression 'MY_VERSION_AT_LEAST(1,2,3)'
	    Warning 202: Syntax error: expected operator

2024-01-11: PaulObermeier
	    [Tcl] Improve support for Tcl 9.0.  All examples and tests now pass
	    with Tcl 9.0.b1.

2024-01-06: wsfulton
            [Python] #2744 Regression fix - add in missing SwigPyIterator_T fragment for
            SwigPyIteratorClosed_T when using %import on an instantiated std::map.

Version 4.2.0 (30 Dec 2023)
===========================

2023-12-24: degasus
	    [Python] #2494 Fix integer overflow / undefined behavior for python
            castmode on sizeof(long)==8 platforms for implicit conversions around
            edge cases of LONG_MAX and ULONG_MAX, for example:

              void as_l(long x); // C interface

            Usage from Python:

              lmaxd = math.nextafter(float(2**63), 0.0) # LONG_MAX == 2**63-1
              # Now below correctly raises a TypeError due to the overflow
              as_l(math.nextafter(lmaxd, float('inf')))

2023-12-21: olly
	    [PHP] `%feature("php:allowdynamicproperties", 0) Foo;` is now handled as
	    the feature being off to match other boolean features.  Previously
	    any value set was treated as on.

2023-12-20: treitmayr
            [Ruby] #2033 Fix missing checks for negative numbers when passing numbers
            to unsigned long/unsigned long long C types.

2023-12-20: crhilton
            [C#] #2722 Add support the "cs:defaultargs" feature.

            This adds a way to wrap C++ functions that have default arguments
            with an equivalent C# function with default arguments, instead of
            generating an overloaded C# method for each defaulted argument.

2023-12-20: vadz, vadimcn, wangito33, wsfulton, clintonstimpson
            [Python] #1613 #1687 #1727 #2190 #2727 #2428 Add support for the Python stable
            ABI using default Python options. Code is generated that compiles when
            setting the C macro Py_LIMITED_API to 0x03040000 (at C/C++ compile time).
            Note that the -builtin, -fast (used by -O) options are not supported.

2023-12-20: wsfulton
            [Python] More efficient input string marshalling for Python 3.

            Previously a copy of a string was made while converting from a Python 3
            string to a char * or std::string. This copy is no longer needed making
            string marshalling more efficient. Does not apply to the stable ABI
            targetting Python < 3.10 where a copy is still required where the stable
            ABI does not provide PyUnicode_AsUTF8AndSize.

2023-12-20: wsfulton
            #2190 Replace SWIG_Python_str_AsChar with SWIG_PyUnicode_AsUTF8AndSize.

            SWIG_Python_str_AsChar has undefined behaviour when Py_LIMITED_API is defined
            as it returns a pointer to a string in a PyBytes object that no longer exists.

            SWIG_PyUnicode_AsUTF8AndSize is an efficient replacement, but requires a
            different API and the caller to decrement the refcount on the intermediate
            PyObject in the Py_LIMITED_API < 0x030A0000 implementation. The alternative
            would have required copying the returned char * string as was done in a
            previous implementation requiring a call to the defunct SWIG_Python_str_DelForPy3
            function.

	    *** POTENTIAL INCOMPATIBILITY ***

2023-12-14: PaulObermeier
	    [Tcl] #2730 Rename SWIG's Tcl_GetBoolFromObj() since Tcl 8.7 (TIP 618)
	    introduces a function with the same name.

	    [Tcl] #2729 Use Tcl_GetString() instead of Tcl_GetStringFromObj(..., NULL)
	    for compatibility with Tcl 9.

2023-12-03: olly
	    [Ocaml] Remove -suffix command line option which has emitted a
	    deprecation warning since SWIG 3.0.4 - if you want to specify
	    a different filename extension for generated C++ files use -cppext
	    instead, which works for all SWIG target language backends.

2023-12-01: saiarcot895
            [Python] #2413 Prevent potential multi-threading crash; gracefully exit running
            daemon threads on main thread exit.

2023-11-24: wsfulton
            Add support for parsing C++20 constexpr destructors.

2023-11-19: olly
	    Fix handling of constant expressions containing < and > to not
	    drop parentheses around the subexpression as doing so can change
	    its value in some cases.

2023-11-18: yasamoka, jmarrec
            [Python] #2639 Add std_filesystem.i for wrapping std::filesystem::path
            with pathlib.Path.

2023-11-17: chrstphrchvz
	    [Tcl] #2711 Fix -Wmissing-braces warning in generated code.

2023-11-17: chrstphrchvz
	    [Tcl] #2710 Stop using Tcl's CONST macro.  It's no longer needed
	    and is set to be deprecated in Tcl 8.7, and removed in Tcl 9.0.

2023-11-08: wsfulton
            [C#] Replace empty() method with IsEmpty property for std::vector, std::list, std::map
            containers for consistency across all containers.

            The empty() method is actually still wrapped, but as a private proxy method. For backwards
            compatibility, the method can be made public again using %csmethodmodifiers for all
            vectors as follows:

              %extend std::vector {
                %csmethodmodifiers empty() const "public"
              }
              %include "std_vector.i"

            or alternatively for each individual %template instantiation as follows:

              %csmethodmodifiers std::vector<double>::empty() const "public"
              %template(VectorDouble) std::vector<double>;


	    *** POTENTIAL INCOMPATIBILITY ***

2023-11-08: wsfulton
            [C#] Add std_unordered_set.i for wrapping std::std_unordered_set, implementing
            C# System.Collections.Generic.ISet<>.

2023-11-09: olly
	    #2591 SWIG now supports command line options -std=cXX and
	    -std=c++XX to specify the C/C++ standards version.  The only effect
	    of these options is to set appropriate values for __STDC_VERSION__
	    and __cplusplus respectively, which is useful if you're wrapping
	    headers which have preprocessor checks based on their values.

2023-11-09: olly
	    SWIG now defines __STDC__ to 1 to match the behaviour of ISO C/C++
	    compilers - previously it had an empty value.

	    *** POTENTIAL INCOMPATIBILITY ***

2023-11-09: olly
	    When -c++ is used, SWIG now defines __cplusplus to be 199711L (the
	    value for C++98) by default - previously its value was set to
	    __cplusplus.

	    *** POTENTIAL INCOMPATIBILITY ***

2023-11-08: emmenlau
            #2480 [C#] Add std_unordered_map.i for wrapping std::std_unordered_map, implementing
            C# System.Collections.Generic.IDictionary<>.

2023-11-06: wsfulton
            [D, Java] Add the dbegin option to the %module directive for generating code at
            the beginning of every D file. Similarly javabegin for Java. This enables one
            to add a common comment at the start of each D/Java file.

2023-11-06: wsfulton
            [C#] #2681 Support nullable reference types. A generic C# option to the
            %module directive allows one to add in any code at the beginning of every
            C# file. This can add the #nullable enable preprocessor directive at the beginning
            of every C# file in order to enable nullable reference types as follows:

              %module(csbegin="#nullable enable\n") mymodule

2023-10-21: wsfulton
            [Python] #1783 Don't swallow all exceptions into a NotImplemented return
            when wrapping operators which are marked with %pythonmaybecall. Corrects the
            implementation of PEP 207.

2023-10-18: wsfulton
            [C#, D] #902 Use the C++11 enum base, that is, the underlying enum
            type.

            For C#, it is used as the underlying type in the generated C# enum.
            For D, it is used as the enum base type in the generated D enum.

2023-10-16: wsfulton
            #2687 Another using declarations fix for inheritance hierarchies more than
            two deep and the using declarations are overloaded. Using declarations
            from a base class' base were not available for use in the target
            language when the using declaration was before a method declaration.

2023-10-11: wsfulton
            [C#, D, Go, Guile, Java, Javascript, Lua, Ocaml, R, Racket] #1680
            carrays.i library modified to use size_t instead of int for the functions
            provided by %array_functions and %array_class.

            If the old types are required for backwards compatibility, use %apply to
            restore the old types as follows:

              %include "carrays.i"
              %apply int { size_t nelements, size_t index }
              ... %array_functions and %array_class ...
              %clear size_t nelements, size_t index; # To be safe in case used elsewhere

	    *** POTENTIAL INCOMPATIBILITY ***

2023-10-11: olly
	    [PHP] #2685 Fix testcase director_finalizer to work with PHP 8.3.

2023-10-06: wsfulton
            #2307 std::vector::capacity and std::vector::reserve signature changes.

            Java api changes from:
              public long capacity() { ... }
              public void reserve(long n) { ... }
            to:
              public int capacity() { ... }
              public void reserve(int n) { ... }
            to fit in with the usual Java convention of using int for container
            indexing and sizing.

            The original api for std::vector::reserve can be also be made available via
            %extend to add in an overloaded method as follows:

              %include <std_vector.i>
              %extend std::vector {
                void reserve(jlong n) throw (std::length_error, std::out_of_range) {
                  if (n < 0)
                    throw std::out_of_range("vector reserve size must be positive");
                  self->reserve(n);
                }
              }

            This change is partially driven by the need to seamlessly support the full
            64-bit range for size_t generically, apart from the customisations for the
            STL containers, by using:

              %apply unsigned long long { size_t };
              %apply const unsigned long long & { const size_t & };

	    *** POTENTIAL INCOMPATIBILITY ***

2023-10-05: wsfulton
            [C#] #2379 Defining SWIGWORDSIZE64 now applies the (unsigned)
            long long typemaps to (unsigned) long for a better match on systems
            where long is 64-bits. A new "Type mapping" section has been added into
            the CSharp.html documentation covering this and marshalling of primitive
            types. C (unsigned) long handling remains as is by default, that is,
            marshall as 32-bit.

            The INPUT[], OUTPUT[], INOUT[], FIXED[] typemaps for long and unsigned long
            in arrays_csharp.i can now be used and compiled on 64-bit platforms where
            sizeof(long) != sizeof(int). Requires SWIGWORDSIZE64 to be defined.

2023-09-27: wsfulton
            [Java] #646 #649 Defining SWIGWORDSIZE64 now applies the (unsigned)
            long long typemaps to (unsigned) long for a better match on systems
            where long is 64-bits.

2023-09-18: christophe-calmejane
            #2631 C++17 std::map fix for values that are not default constructible.
            Enhancements for all target languages except Python and Ruby.

2023-09-14: mmomtchev
            #2675 #2676 Temporary variable zero initialisation in the wrappers for
            consistency with handling pointers.

2023-09-11: emmenlau
            #2394 Add support to preprocessor for true and false. Note that this
            is for C++ not C.

2023-09-11: wsfulton
            [R] #2605 Complete transition to rtypecheck typemaps from hard coded
            logic. Also see entry dated 2022-10-28 for swig-4.1.1. The rtypecheck
            typemaps implement typechecking in R for each function parameter using
            functions such as is.numeric, is.character, is.logical, is.null etc.

2023-09-09: wsfulton
            https://sourceforge.net/p/swig/bugs/919/

            Fix incorrect variable setters being generated when wrapping arrays.
            A setter is no longer generated if the type of the array members
            are non-assignable.

2023-09-09: wsfulton
            Non-assignable detection fixes when wrapping const member variables.
            Const member variables such as the following are non-assignable by
            by default:

              char * const x;
              const int x;
              const int x[1];

            but not:

              const char * x;

            Variable setters are not generated when wrapping these non-assignable
            variables and classes containing such non-assignable variables.

2023-09-07: wsfulton
            Non-assignable detection fixes when wrapping rvalue reference variables.
            Rvalue reference variables such as the following are non-assignable by
            by default:

              X &&v;

            Variable setters are not generated when wrapping these non-assignable
            variables and classes containing such non-assignable variables.

2023-09-06: wsfulton
            Non-assignable detection fixes when wrapping reference variables.
            Reference variables such as the following are non-assignable by
            by default:

              int &v;

            Variable setters are not generated when wrapping these non-assignable
            variables and classes containing such non-assignable variables.

2023-09-06: wsfulton
            Assignment operator detection fixes when wrapping static member
            variables.

2023-09-06: wsfulton
            #1416 Implicit assignment operator detection fixes.

            A class that does not have an explicit assignment operator does not
            have an implicit assignment operator if a member variable is not
            assignable. Similarly should one of the base classes also not be
            assignable. Detection of these scenarios has been fixed so that when
            wrapping a variable that is not assignable, a variable setter is not
            generated in order to avoid a compiler error.

            Template instantiation via %template is required in order for this to
            work for templates that are not assignable.

2023-09-03: wsfulton
            https://sourceforge.net/p/swig/bugs/1006/
            Fix incorrect variable setters being generated when the type of the
            variable is not assignable, due to variable type inheriting a private
            assignment operator further up the inheritance chain (further up than
            the immediate base).

2023-09-03: wsfulton
            [Guile, Ocaml, Perl] Don't attempt to generate a setter when wrapping
            variables which have a private assignment operator as assignment is not
            possible. This now matches the behaviour of all the other target languages.

2023-09-02: wsfulton
            Fix problems wrapping deleted destructors. Derived classes are not
            constructible, so don't attempt to generate default constructor or
            copy constructor wrappers.

              struct StackOnly1 {
                // Only constructible on the stack
                ~StackOnly1() = delete;
              };
              struct StackOnlyDerived1 : StackOnly1 {
                // this class is not constructible due to deleted base destructor
              };

2023-09-02: wsfulton
            Fix %copyctor feature when used on classes with deleted copy constructors.
            A default constructor wrapper was sometimes incorrectly generated.

2023-09-02: wsfulton
            #1644 Fix wrapping types passed by value where the type has a deleted
            default constructor.

2023-08-16: shadchin
            [Python] #2665 Fix missing-field-initializers warning to provide support
            for python-3.12.

2023-08-09: olly
	    [Ruby] Remove -feature command line option which has been
	    deprecated since SWIG 1.3.32 in 2007.  Use -initname instead.

2023-08-06: wsfulton
            Add support for using declarations to introduce templated member
            methods and for inheriting templated constructors, such as:

              struct Base {
                // templated constructor
                template <typename T> Base(const T &t, const char *s) {}
                // templated member method
                template <typename T> void template_method(const T &t, const char *s) {}
              };

              %template(Base) Base::Base<int>;
              %template(template_method) Base::template_method<double>;

              struct Derived : Base {
                using Base::Base;
                using Base::template_method;
              };

            Previously the templated methods and constructors were ignored and
            not introduced into the Derived class.

2023-08-04: wsfulton
            Fix using declarations for inheritance hierarchies more than
            two deep and the using declarations are overloaded. Using declarations
            from a base class' base were not available for use in the target
            language. For example in the code below, Using1::usingmethod(int i)
            was not wrapped for use in Using3:

              struct Using1 {
              protected:
                void usingmethod(int i) {}
              };
              struct Using2 : Using1 {
              protected:
                void usingmethod(int i, int j) {}
                using Using1::usingmethod;
              };
              struct Using3 : Using2 {
                void usingmethod(int i, int j, int k) {}
                using Using2::usingmethod;
              };

            Similarly for C++11 using declarations for inheriting constructors.

2023-08-02: wsfulton
            https://sourceforge.net/p/swig/bugs/932/
            Fix missing constructor generation due to abstract class test
            failure when a method is declared in the class along with a
            using declaration and the using declaration is declared before
            the method that implemented the pure virtual method, such as:

              struct ConcreteDerived : AbstractBase {
                ConcreteDerived() {} // was not wrapped
                using AbstractBase::f;
                virtual void f(int n) override {}
              };

2023-08-02: olly
	    [PHP] Implement overloading between different integer types and
	    between double and float.

2023-07-29: wsfulton
            https://sourceforge.net/p/swig/bugs/678/
            Fix %copyctor used on class hierarchies with non-const copy
            constructors. Previously SWIG always attempted to call a copy
            constructor taking a const reference parameter instead of a
            non-const reference parameter.

2023-07-28: wsfulton
            #2541 Fix overloading of templated constructors and %copyctor.

2023-07-21: wsfulton
            Don't generate a default constructor wrapper when a class has a
            templated constructor, as there isn't actually an implied default
            constructor. For example:

              struct TConstructor3 {
                template<typename T> TConstructor3(T val) {}
              };

            Previously wrappers were generated for a non-existent default
            constructor which failed to compile.

2023-07-15: wsfulton
            C++11 using declarations for inheriting constructors has now been
            extended to support the directors feature.

2023-07-13: wsfulton
            C++11 using declarations for inheriting constructors support now
            also includes inheriting implicitly defined default constructors
            from the base class.

2023-07-04: wsfulton
            #2641 Add support for C++11 using declarations for inheriting
            constructors.

2023-06-30: wsfulton
            #2640 Fix syntax error parsing an expression which calls a function
            with no parameters within additional brackets.

2023-06-27: mmomtchev
            [Javascript] #2545 New Javascript generator targeting the Node.js
            binary stable ABI Node-API.

2023-06-27: olly
	    [Java] Completely remove pragmas which were deprecated in 2002 and
	    have triggered an error since SWIG 2.0:

	    moduleimport		Use the moduleimports pragma
	    moduleinterface		Use the moduleinterfaces pragma
	    modulemethodmodifiers	Use %javamethodmodifiers
	    allshadowimport		Use %typemap(javaimports)
	    allshadowcode		Use %typemap(javacode)
	    allshadowbase		Use %typemap(javabase)
	    allshadowinterface		Use %typemap(javainterfaces)
	    allshadowclassmodifiers	Use %typemap(javaclassmodifiers)
	    shadowcode			Use %typemap(javacode)
	    shadowimport		Use %typemap(javaimports)
	    shadowbase			Use %typemap(javabase)
	    shadowinterface		Use %typemap(javainterfaces)
	    shadowclassmodifiers	Use %typemap(javaclassmodifiers)

2023-06-24: wsfulton
            #2616 https://sourceforge.net/p/swig/bugs/1102/ Fix directors and
            allprotected mode and using declarations. Previously SWIG either
            seg faulted or generated code that did not compile.

2023-06-20: olly
	    #2486 Fix handling of template in array size, which was being
	    rejected by SWIG because the type string contains '<' not followed
	    by '('.  Drop this check as it should be unnecessary now since the
	    fixes that ensure that template parameters are enclosed within
	    '<(' and ')>'.

2023-06-16: olly
	    [Java] Remove deprecated command line options which have done
	    nothing except emit a deprecation message since 2002 or before:

	    -jnic / -jnicpp	JNI calling convention now automatic.
	    -nofinalize		Use javafinalize typemap instead.
	    -proxy / -shadow	Now on by default.

2023-06-16: olly
	    [Guile] Drop support for -Linkage ltdlmod which was only useful
	    for Guile <= 1.4 which we no longer support.

2023-06-15: olly
	    [Guile] The -gh and -scm command line options have been removed.
	    These have done nothing except emit a message since 2013 when
	    SWIG dropped support for generating bindings which used GH.

2023-06-15: olly
	    Remove pointer.i from the SWIG library.  It's been a dummy file
	    which has done nothing except %echo a deprecation message since
	    2002.  The replacement is cpointer.i.

2023-06-15: olly
	    SWIG will no longer fall back to using the include path to find the
	    input file, which has been deprecated and emitted a warning since
	    SWIG 1.3.37 (2009-01-13).  This makes the behaviour of SWIG the
	    same as C/C++ compilers and works with ccache.

2023-06-15: olly
	    Remove features deprecated in SWIG 1.x and 2.x.  Most of these have
	    emitted a deprecation warning or error for well over a decade and
	    have replacements with fewer shortcomings so we expect users will
	    have migrated away from them long ago, but in case you need
	    them replacements are noted below:

	    %addmethods		Use %extend instead.
	    %attribute_ref      Use %attributeref instead (NB: If called with
				4 parameters, the 3rd and 4th need switching).
	    %disabledoc		Use Doxygen support instead.
	    %doconly		Use Doxygen support instead.
	    %enabledoc		Use Doxygen support instead.
	    %except		Use %exception instead.
	    %extern		Use %import instead.
	    %localstyle		Use Doxygen support instead.
	    %name		Use %rename instead.
	    %new		Use %newobject instead.
	    %out		%apply OUTPUT typemap rule instead.
	    %readonly		Use %immutable instead.
	    %readwrite		Use %mutable instead.
	    %section		Use Doxygen support instead.
	    %style		Use Doxygen support instead.
	    %subsection		Use Doxygen support instead.
	    %subsubsection	Use Doxygen support instead.
	    %text		Use Doxygen support instead.
	    %title		Use Doxygen support instead.
	    %typemap(except)	Use %exception instead.
	    %typemap(ignore)	Use %typemap(in,numinputs=0) instead.
	    %val		Use typemaps instead.
	    -debug_template	Use -debug-template instead.
	    -debug_typemap	Use -debug-typemap instead.
	    -dump_classes	Use -debug-classes instead.
	    -dump_memory	Use -debug-memory instead.
	    -dump_module	Use -debug-module 4 instead.
	    -dump_parse_module	Use -debug-module 1 instead.
	    -dump_parse_top	Use -debug-top 1 instead.
	    -dump_tags		Use -debug-tags instead.
	    -dump_top		Use -debug-top 4 instead.
	    -dump_tree		Use -debug-top 4 instead.
	    -dump_typedef	Use -debug-typedef instead.
	    -dump_xml		Use -xmlout /dev/stdout instead.
	    -make_default	On by default since SWIG 1.3.7 (2001-09-03).
	    -makedefault	On by default since SWIG 1.3.7 (2001-09-03).
	    -no_default		Use %nodefaultctor/%nodedefaultdtor instead.
	    -nodefault		Use %nodefaultctor/%nodedefaultdtor instead.
	    -noextern option	On by default since SWIG 1.3.26 (2005-10-09).
	    -noruntime		Type sharing happens via target lang global.
	    -runtime		Type sharing happens via target lang global.
	    -show_templates	Use -debug-template instead.
	    -tm_debug		Use -debug-typemap instead.
	    -xml out.xml	Use -xml -o out.xml instead.
	    BOTH typemap rule	Use INOUT typemap rule instead.
	    SWIG_INTRUSIVE_PTR(PROXYCLASS, TYPE)
				Use %intrusive_ptr(TYPE) instead.
	    SWIG_INTRUSIVE_PTR_DERIVED(PROXYCLASS, BASECLASSTYPE, TYPE)
				Use %intrusive_ptr(TYPE) instead.
	    SWIG_INTRUSIVE_PTR_NO_WRAP(PROXYCLASS, TYPE)
				Use %intrusive_ptr_no_wrap(TYPE) instead.
	    SWIG_INTRUSIVE_PTR_DERIVED_NO_WRAP(PROXYCLASS, BASECLASSTYPE, TYPE)
				Use %intrusive_ptr_no_wrap(TYPE) instead.
	    SWIG_SHARED_PTR(PROXYCLASS, TYPE)
				Use %shared_ptr(TYPE) instead.
	    SWIG_SHARED_PTR_DERIVED(PROXYCLASS, BASECLASSTYPE, TYPE...)
				Use %shared_ptr(TYPE) instead.
	    SWIG_STD_VECTOR_SPECIALIZE(CSTYPE, CTYPE)
				Use SWIG_STD_VECTOR_ENHANCED(CTYPE) instead.
	    SWIG_STD_VECTOR_SPECIALIZE_MINIMUM(CSTYPE, CTYPE)
				No longer required - remove uses.
	    specialize_std_map_on_both
				No longer required - remove uses.
	    specialize_std_map_on_key
				No longer required - remove uses.
	    specialize_std_map_on_value
				No longer required - remove uses.

2023-06-15: olly
	    [Guile] Fix freearg typemaps to go with char **INOUT and char
	    *INOUT in typemaps.  Previously the char **INOUT typemap would
	    leak memory if must_free$argnum was true, and the char *INOUT
	    typemap would generate code that didn't compile.

2023-06-07: olly
	    #2630 Fix preprocessor handling of a slash immediately followed by
	    a single quote, which wasn't getting recognised as starting a
	    character literal.

2023-06-07: olly
	    #2630 Fix parsing of <= and >= in templated lambda.

	    Skipping between matching delimiters is now done at the token level
	    rather than the character level.

2023-06-02: mmomtchev
	    [Javascript] #2622 Fix support for %typemap(default) and improve
	    support for default arguments in general.

2023-06-01: olly
	    [Perl] #2470 Fix some integer truncation warnings in generated
	    wrappers.

2023-05-30: olly
	    [Lua] Fix bug when passing a Lua number to a C++ function expected
	    std::string.  Order of evaluation of C++ function arguments is not
	    defined, and if lua_rawlen() was called before lua_tostring() then
	    it would return 0 (because the value was still a number) and an
	    empty string would be passed.

2023-05-30: mmomtchev
	    [Javascript] #2618 Fix handling of C++ pointer to member function.

2023-05-25: olly
	    #1032 Allow typename disambiguator in:

	    using typename NodeT::links_type;

2023-05-25: olly
	    SWIG now discriminates between long double, double and float
	    constants.  For example, this means that for target languages which
	    support a separate float type (such as C# and D) this will now
	    create a float constant instead of a double constant in the target
	    language:

	    #define PI_ISH 3.1414f

2023-05-25: olly
	    C++11 `auto` variables and `decltype()` can now deduce the
	    type of some expressions which involve literals of built-in types.

2023-05-25: olly
	    #1125 Support parsing C++11 auto variables.  This uses the
	    existing type deduction code from decltype so has the same
	    limitations, and such variables will only actually be wrapped
	    when SWIG can deduce the type.

2023-05-23: olly
	    [Ruby] Fix deprecation warnings about ANYARGS when compiling
	    C++ code for SWIG-generated Ruby wrappers with Ruby 3.x.

	    This is a recurrence of a problem fixed in 4.0.2.  Our fix was
	    conditional on RB_METHOD_DEFINITION_DECL being defined, but Ruby
	    3.0 stopped defining this.

2023-05-23: olly
	    #2606 Improve error output when SWIG reaches EOF while looking for
	    a closing delimiter.  This is reported with an error like:

	    Error: Missing '}'. Reached end of input.

	    We now exit after reporting this and so no longer report a second
	    more generic error like:

	    Error: Syntax error in input(1).

2023-05-22: mmomtchev
	    [Javascript] #2600 Improve test coverage by adding _runme.js files
	    for 22 test cases.

2023-05-20: erezgeva
	    [C#, D, Java, Javascript, Guile, Scilab] #2552 Implement argcargv.i
            library multi-argument typemaps.

2023-05-20: erezgeva
	    [D] #56 #2538 #2570 The generated code now works with recent D releases:
            adds override keyword on overridden methods.

            Support is now working using DMD, gcc D and LLVM D compilers.

2023-05-20: olly
	    Support deducing the type for decltype(false) and
	    decltype(true).

2023-05-19: olly
	    #2446 Add support for auto without trailing return type, which is a
	    C++14 feature.

2023-05-19: olly
	    SWIG no longer defines preprocessor symbols corresponding to
	    command line options (e.g. `-module blah` was resulting in
	    `SWIGOPT_MODULE` being set to `blah`).  This feature was added in
	    2001 so that "[m]odules can look for these symbols to alter their
	    code generation if needed", but it's never been used for that
	    purpose in over 20 years, and has never been documented outside of
	    CHANGES.

2023-05-18: olly
	    #2591 Add new -U command line option to undefine a preprocessor
	    symbol.

2023-05-18: olly
	    #1589 #2335 Support parsing arbitrary expression in decltype.

	    Use parser error recovery to skip to the closing matching `)` and
	    issue a warning that we can't deduce the decltype for the
	    expression (like we already do for any expression which isn't a
	    simple variable or similar).

2023-05-12: mmomtchev, erezgeva
	    [Javascript] #2561 Support check typemaps for Javascript.

2023-05-12: olly
	    [Java] #2556 Suppress Java removal warnings on finalize method.
	    SWIG will need to stop relying on finalize methods, but we know
	    that and meanwhile these warnings make the testsuite output very
	    noisy.

2023-05-11: olly
	    #302 #2079 #2474 Parse storage class more flexibly.

	    Previously we had a hard-coded list of allowed combinations in the
	    grammar, but this suffers from combinatorial explosion, and results
	    in a vague `Syntax error in input` error for invalid (and missing)
	    combinations.

	    This means we now support a number of cases which are valid C++ but
	    weren't supported, including `friend constexpr` and `virtual
	    explicit`.

2023-05-08: olly
	    #1567 Add support for std::string_view (new in C++17) for C#, Java,
	    Lua, Perl, PHP, Python, Ruby and Tcl.

2023-05-08: olly
	    [PHP] #2544 Wrap overloaded method with both static and non-static
	    forms.  We now wrap this as a non-static method in PHP, which means
	    the static form is only callable via an object.

	    Previously this case could end up wrapped as static or non-static
	    in PHP.  If it was wrapped as static, attempting to call non-static
	    overloaded forms would crash with a segmentation fault.

2023-05-06: mmomtchev, wsfulton
            #2550 Fix typedef/using declarations to a typedef struct/class.

2023-05-04: erezgeva
	    [D] #2538 Drop support for D1/Tango, which was discontinued in
	    2012.  Wrappers for D2/Phobos are now generated by default, though
	    the -d2 command line option is still accepted (and now ignored) for
	    backward compatibility.

	    *** POTENTIAL INCOMPATIBILITY ***

2023-04-27: olly
	    #2502 Allow using snprintf() instead of sprintf() in wrappers.

	    We aim to produce code that works with C90 or C++98 so we can't
	    assume snprintf() is available, but it almost always is (even
	    on systems from before it was standardised) so having a way to
	    use it is helpful.

	    We enable this automatically if the compiler claims conformance
	    with at least C99 or C++11. It can also be enabled manually by
	    defining SWIG_HAVE_SNPRINTF.  Define SWIG_NO_SNPRINTF to disable
	    completely.

	    The fallback is to call sprintf() without a buffer size check,
	    which is what we've done until now.  Adding a check after the
	    call seems of limited benefit - if the buffer was overflowed
	    then it's too late to block it, and most of our uses either have a
	    fixed maximum possible size or dynamically allocate a buffer that's
	    large enough.

2023-04-26: mmomtchev
	    [Javascript] Take into account numinputs when counting arguments.

2023-04-24: olly
	    [PHP] Add throws typemaps for std:string* and const std::string*.

2023-04-23: olly
	    [Javascript] #2453 The testsuite and examples now select which
	    Javascript engine to test based on what was detected by configure.
	    Previously they'd always test with node you specified a different
	    engine (e.g. with `ENGINE=jsc` on the make command line).  Now you
	    only need to specify ENGINE if you have more than one engine
	    installed.

2023-04-23: olly
	    [Javascript] Turn on C++ output when wrapping for node, like
	    we already do when wrapping for V8-without-node.

	    The testsuite was masking this bug by using SWIG options
	    `-v8 -DBUILDING_NODE_EXTENSION=1` rather than `-node` when testing
	    with nodejs, while the javascript examples were masking this by
	    all getting processed with -c++.

	    This shouldn't be an incompatible change for users, as if you're
	    wrapping a C API you'd have to be working around the problem before
	    this change (like our testsuite and examples were), and this change
	    shouldn't break your workaround - it just makes it unnecessary.

2023-04-21: mmomtchev
	    [Javascript] Fix naming of internal C++ helper for wrapping
	    variables for node to use the "getter" naming scheme rather
	    than the function wrapping one.  In practice this didn't actually
	    cause problems because Node wrappers are always compiled as C++
	    and the parameters are always different even if the names are
	    the same.

2023-04-21: olly
	    [PHP] Support INPUT,INOUT,OUTPUT for std::string&.

	    By default SWIG/PHP wraps std::string& as a pass-by-reference PHP
	    string parameter, but sometimes such a parameter is only for input
	    or only for output, so add support for the named typemaps that other
	    target languages support.

2023-04-21: degasus
	    #2519 Fix CanCastAsInteger range check to clear errno first to fix
	    bogus failures for valid inputs.if errno is set.

2023-04-21: ZackerySpytz
	    [OCaml] #1439 Fix reference typemaps for std::string

2023-04-21: olly
	    #2183 Fix #ifdef and #ifndef to work inside a %define.  Previously
	    they were silently ignored in this context (but #if defined already
	    worked here if you need a workaround which works for older
	    versions).

2023-04-20: erezgeva
	    [Go] #2533 Implement argcargv.i library for Go.

2023-04-19: davidcl
            [Scilab] Add support for Scilab 2023.x.
	    Introduce a new `-gatewayxml6` option to generate XML with full
	    function names.

2023-04-19: mmomtchev
	    https://sourceforge.net/p/swig/bugs/1163/ #1882 #2525
	    Fix preprocessor expansion when a macro expands to the name of
	    another macro which takes parameters from the input following the
	    original macro expansion.

2023-04-19: wildmaples
	    [Ruby] #2527 Fix "undefining the allocator of T_DATA" warning seen
	    with Ruby 3.2.

2023-04-18: davidcl
	    [Scilab] #894 extract values with ":" for typemap (int* IN, int IN_SIZE)

2023-04-14: olly
	    [PHP7] Support for PHP7 has been removed.  PHP7 security support
	    ended 2022-11-28 so it doesn't make sense to include support for
	    it in the SWIG 4.2.x release series.

	    *** POTENTIAL INCOMPATIBILITY ***

2023-04-05: wsfulton
            [Python] #2515 Add support for all STL containers to be constructible from a Python set.

            The previous implementation used the Python Sequence Protocol to convert from Python types
            to STL containers. The new implementation uses the Python Iterator Protocol instead and
            thereby can convert from a Python set too.

2023-03-25: alatina
            [Octave] #2512 Add support for Octave 8.1.

2023-03-22: wsfulton
            [C#] #2478 Minor enhancements to std::array wrappers in std_array.i.

2023-03-13: wsfulton
            Improved error checking when using %template to instantiate templates within
            the correct scope.

            1. When a template is instantiated via %template and uses the unary scope
            operator ::, an error occurs if the instantiation is attempted within a
            namespace that does not enclose the instantiated template.
            For example, the following will now error as ::test::max is not enclosed within test1:

            Error: '::test::max' resolves to 'test::max' and was incorrectly instantiated in
            scope 'test1' instead of within scope 'test'.
              namespace test1 {
                %template(maxchar) ::test::max<char>;
              }

            2. SWIG previously failed to always detect a template did not exist when using
            %template. In particular when instantiating a global template incorrectly within
            namespace. The code below now correctly emits an error:

            Error: Template 'test5::GlobalVector' undefined.
              namespace test5 {
              }
              template<typename T> struct GlobalVector {};
              %template(GVI) test5::GlobalVector<int>;

2023-03-13: wsfulton
            Error out if an attempt is made to define a class using the unary scope
            operator ::. The following is not legal C++ and now results in an error:

            Error: Using the unary scope operator :: in class definition '::Space2::B' is invalid.
              namespace Space2 {
                struct B;
              }
              struct ::Space2::B {};

2023-03-08: wsfulton
            Fix duplicate const in generated code when template instantiation type is const
            and use of template parameter is also explicitly const, such as:

              template <typename T> struct Conster {
                void cccc1(T const& t) {}
              };
              %template(ConsterInt) Conster<const int>;

            Above previously led to generated code:
              (arg1)->cccc1((int const const &)*arg2);
            instead of
              (arg1)->cccc1((int const &)*arg2);

2023-03-01: wsfulton
            Partial template specialization fixes to support default arguments from the primary
            template's parameter list.

              template<class Y, class T=int> struct X { void primary() {} };
              // Previously the specialization below resulted in:
              // Error: Inconsistent argument count in template partial specialization. 1 2
              template<class YY> struct X<YY*> { void special(YY*) {} };

              // Both of these correctly wrap the partially specialized template
              %template(StringPtr) X<const char *>;
              %template(ShortPtr) X<short *, int>;

2023-02-15: wsfulton
            #1300 Further partial template specialization fixes.
            Fixes when templates are used as a template parameter in a partially specialized
            instantiation such as:

              template<typename V> struct Vect {};
              template<class T, typename TT> class Foo { ... };
              template<class TS, typename TTS> class Foo<Vect<TS>, TTS> { ... };
              %template(VectInt) Vect<int>;
              %template(FooVectIntDouble) Foo<Vect<int>, double>; // was previously attempting to use primary template

            Also fixes partial specialization where the same template parameter name is used twice,
            for example:

              template<typename X, typename Y> struct H { ... };
              template<typename T> struct H<T, T> { ... };
              %template(HInts) H<int, int>; // was previously attempting to use primary template

2023-01-27: jschueller
	    #2492 [python] Fix unused parameter warnings for self parameter in
	    generated C/C++ wrapper code.

2023-01-14: wsfulton
            Fix deduction of partially specialized template parameters when the specialized
            parameter is non-trivial, used in a wrapped method and the type to %template uses
            typedefs. For example:

              typedef double & DoubleRef;
              template <typename T> struct XX {};
              template <typename T> struct XX<T &> { void fn(T t) {} };
              %template(XXD) XX<DoubleRef>;

            The type of the parameter in the instantiated template for fn is now correctly deduced
            as double.

2023-01-03: wsfulton
            #983 Fix seg fault when instantiating templates with parameters that are function
            parameters containing templates, such as:

              %template(MyC) C<int(std::vector<int>)>;

2023-01-03: wsfulton
            Complete support for C++11 variadic function templates. Support was previously limited
            to just one template parameter. Now zero or more template parameters are supported
            in the %template instantiation.

2022-12-29: wsfulton
            #1863 Syntax error fixes parsing more elaborate parameter pack arguments that are
            used in function pointers, member function pointers:

              template <typename... V> struct VariadicParms {
                void ParmsFuncPtrPtr(int (*)(V*...)) {}
                void ParmsFuncPtrPtrRef(int (*)(V*&...)) {}
                void ParmsFuncPtrPtrRValueRef(int (*)(V*&&...)) {}
                void ParmsFuncPtrRef(int (*)(V&...)) {}
                void ParmsFuncPtrRValueRef(int (*)(V&&...)) {}

                void ParmsMemFuncPtrPtr(int (KlassMemFuncs::*)(V*...)) {}
                void ParmsMemFuncPtrPtrRef(int (KlassMemFuncs::*)(V*&...)) {}
                void ParmsMemFuncPtrPtrRValueRef(int (KlassMemFuncs::*)(V*&&...)) {}
                void ParmsMemFuncPtrRef(int (KlassMemFuncs::*)(V&...)) {}
                void ParmsMemFuncPtrRValueRef(int (KlassMemFuncs::*)(V&&...)) {}
              };

              %template(VariadicParms0) VariadicParms<>;
              %template(VariadicParms1) VariadicParms<A>;

            Also in various other places such as within noexcept specifiers:

              template<typename T, typename... Args>
              void emplace(Args &&... args) noexcept(
                  std::is_nothrow_constructible<T, Args &&...>::value);

2022-12-27: wsfulton
            Fix instantiation of variadic class templates containing parameter pack arguments that
            are function pointers.

              template <typename... V> struct VariadicParms {
                void ParmsFuncPtrVal(int (*)(V...)) {}
              };

              %template(VariadicParms0) VariadicParms<>;
              %template(VariadicParms1) VariadicParms<A>;

2022-12-23: wsfulton
            #1863 Fix syntax error parsing variadic templates containing parameter pack arguments that
            are function pointers.

2022-12-22: wsfulton
            Complete support for C++11 variadic class templates. Support was previously limited
            to just one template parameter. Now zero or more template parameters are supported.

2022-12-06: wsfulton
            #1636 Fix syntax error for misplaced Doxygen comment after struct/class member.
            Fix syntax error using Doxygen member groups syntax, "///*}", when used after
            final struct/class member.

2022-12-05: wsfulton
            #2023 Fix garbled Doxygen post comments in parameter lists.
            Fix syntax error parsing a trailing Doxygen comment in parameter lists.

2022-12-03: wsfulton
            #1609 Fix syntax error parsing of Doxygen comments after last enum item.

2022-12-03: wsfulton
            #1715 Fix syntax error parsing of unconventionally placed Doxygen post
            comments for enum items.

2022-12-02: wsfulton
            #624 #1021 Improved template template parameters support. Previously, specifying more
            than one simple template template parameter resulted in a parse error. Now
            multiple template template parameters are working including instantiation with
            %template. Example:

              template <template<template<class> class, class> class Op, template<class> class X, class Y>
              class C { ... };

2022-11-26: wsfulton
            #1589 #1590 Slightly better decltype() support for expressions, such as:

              int i;
              ...  decltype(&i) ...

            These result in a warning for non-trivial expressions which SWIG cannot evaluate:

              Warning 344: Unable to deduce decltype for '&i'.

            See 'Type Inference' in CPlusPlus.html for workarounds.

2022-11-22: wsfulton
	    #366 #1037 Fix seg fault handling template parameter expressions
	    containing '<=' or '>='.

2022-11-18: wsfulton
            Duplicate class template instantiations via %template now issue a warning and are ignored.

                %template(Aint) A<int>;
                %template(Aint2) A<int>; // Now ignored and issues a warning

            example.i:7: Warning 404: Duplicate template instantiation of 'A< int >' with name 'Aint2' ignored,
            example.i:6: Warning 404: previous instantiation of 'A< int >' with name 'Aint'.

            A single empty template instantiation before a named instantiation is the one exception
            for allowing duplicate template instantiations as the empty template instantiation does not
            create a wrapper for the template, it merely adds the instantiation into SWIG's internal
            type system.
            Duplicate empty template instantiations are quietly ignored.

                %template() B<int>;
                %template(Bint) B<int>; // OK

                %template() C<int>;
                %template() C<int>; // Quietly ignored now
                %template(Cint) C<int>; // OK

            Note that default template parameters are considered when looking for duplicates such as:

                template <typename T, typename U = short> struct D {};
                %template(Dint) D<int>;
                %template(Dintshort) D<int, short>;

            example.i:7: Warning 404: Duplicate template instantiation of 'D< int,short >' with name 'Dintshort' ignored,
            example.i:6: Warning 404: previous instantiation of 'D< int >' with name 'Dint'.

            Note that the following always was ignored, but that was because the chosen name was a
            duplicate rather than the template being a duplicate:

                %template(Eint) E<int>;
                %template(Eint) E<int>; // Always has been ignored as a redefined identifier

            The old warning was:

            example.i:7: Warning 302: Identifier 'Eint' redefined (ignored) (Renamed from 'E< int >'),
            example.i:6: Warning 302: previous definition of 'Eint' (Renamed from 'E< int >').

	    *** POTENTIAL INCOMPATIBILITY ***

Version 4.1.1 (30 Nov 2022)
===========================

2022-11-29: bero
            Fix mismatch between #pragma GCC diagnostic push and pop statements

2022-11-26: wsfulton
            #2449 Fix undefined behaviour in ccache-swig calculating md4 hashes and possibly
            also handling errors when CCACHE_CPP2 is set.

2022-11-25: wsfulton
            #961 Fix syntax error parsing unnamed template parameters with a default value.

2022-11-25: olly
	    #2447 Fix undefined behaviour in swig's parser when handling
	    default parameter expressions containing method calls.

2022-11-13: olly
	    [PHP] #2419 Update the documentation to reflect that SWIG 4.1.0
	    dropped support for -noproxy when generating PHP wrappers.

2022-11-05: wsfulton
            #2417 Fix -swiglib for Windows when building with CMake.

2022-11-02: wsfulton
            #2418 Fix infinite loop handling non-type template parameters.

            Fixes infinite loop due to () brackets in a non-type template
            parameter containing an expression.

2022-10-28: wsfulton
            [R] R rtypecheck typemaps

            Further switch to use rtypecheck typemaps instead of hard coded logic.
            The full switch to typemaps is deferred until swig-4.2 as it can't be fully
            backwards compatible. For now a warning is provided to help the
            transition. It provides the full typemap that should be placed into
            a user's interface file, for example:

            %typemap("rtype") int32_t * "integer"
            void testmethod(int32_t * i);
            void testmethod();

            If there is no rtypecheck typemap for int32_t *, the warning shown is:

              example.i:7: Warning 750: Optional rtypecheck code is deprecated. Add the
              following typemap to fix as the next version of SWIG will not work without it:
              %typemap("rtypecheck") int32_t * %{ (is.integer($arg) || is.numeric($arg)) %}

            The warning is shown for any code that previously used "numeric", "integer" or
            "character" for the rtype typemap. Copying the rtypecheck typemap as
            shown into the user interface file will provide the appropriate fix and
            the warning will disappear. This is important to do as swig-4.2 will
            not be able to provide this helpful warning.

2022-10-27: wsfulton
            [R] Allow NULL to be used in overloaded functions taking shared_ptr.
            Also fixes special variable $argtype expansion in rtypecheck typemaps.

2022-10-26: wsfulton
            [R] Improve R wrapper error message when calling overloaded methods
            when incorrect types passed are passed to the overloaded methods.

            Old unhelpful error message:
              Error in f(...) : could not find function "f"

            Example of new improved error message:
              Error in use_count(k) :
                cannot find overloaded function for use_count with argtypes (NULL)

2022-10-26: wsfulton
            [R] #2386 Fix memory leak in R shared_ptr wrappers.
            Fix leak when a cast up a class inheritance chain is required.

Version 4.1.0 (24 Oct 2022)
===========================

2022-10-24: wsfulton, AndLLA
            [R] #2386 Fix problems in shared_ptr wrappers where the class names
            were not consistent when using the shared_ptr template or the actual
            underlying type.

2022-10-24: wsfulton
            [R] Add support for special variable replacement in the $typemap()
            special variable macro for R specific typemaps (rtype, rtypecheck,
            scoercein, scoereout).

2022-10-24: wsfulton
	    [R] Polymorphism in the wrappers was only working for C++ classes,
            now this works for C++ structs too.

2022-10-19: olly
	    [Lua] #2126 Fix type resolution between multiple SWIG-wrapped
	    modules.

2022-10-17: wsfulton
            [R] #2385 Add support for std::vector<std::vector<std::string>>.

2022-10-14: murillo128
	    [Javascript] #2109 Tweak unsigned long and unsigned long long typemaps
            to create a v8::Number instead of v8::Integer if the value exceeds
            the size of v8::Integer. Note that the v8::Number value will be
            imprecise if the value is > MAX_SAFE_INTEGER.

2022-10-14: olly
	    [R] Arrange that destructors of local C++ objects in the wrapper
	    function get run on SWIG_fail (which calls Rf_error() which calls
	    longjmp()).

2022-10-14: olly
	    [Lua] Arrange that destructors of local C++ objects in the wrapper
	    function get run on SWIG_fail (which calls lua_error() which calls
	    longjmp()).

2022-10-13: wsfulton
            [R] Add missing SWIGTYPE *const& typemaps for supporting pointers
            by const reference.

2022-10-10: wsfulton
            #2160 Fix compile error when using templates with more than one template
            parameter and used as an input parameter in a virtual method in a
            director class (problem affecting most of the scripting languages).

2022-10-10: treitmayr, wsfulton
            [Python, Ruby] #1811 #1823 Fix invalid code generated in some cases when
            returning a pointer or reference to a director-enabled class instance.
            This previously only worked in very simple cases, now return types are
            resolved to fix. A bug in template instantiations using pointers also
            works now.

2022-10-06: wsfulton
	    [CFFI] #1966 #2200 Remove code for Common Lisp CFFI.  We dropped support
	    for it in SWIG 4.0.0 by disabling it as the first stage. This is the
            final stage for complete removal as there has been no meaningful
            progress to revive it to the status of experimental language.

2022-10-06: olly
	    [Python] #2390 Remove deprecated and apparently useless defarg.swg

	    The only documentation is in the file itself and describes a Python
	    wrapper around the C function defined here, but digging though the
	    git history this Python wrapper doesn't seem to have ever actually
	    been generated by SWIG.

	    This file was also marked as deprecated in 2005.

2022-10-06: wsfulton
            [Java] #2048 Fix quoting for doxygen \image command to quote the output
            file name generated into the html src attribute.

2022-10-05: benjamin-sch
            [Python] added an interpreter counter to fix deinitialization
            issues if multiple subinterpreters are used

2022-10-05: olly, wsfulton
            #672 Add support for parsing C++11 final classes such as:

              class X final {};

            This no longer gives a syntax error.

2022-10-05: wsfulton
            [OCaml] Fix %rename for enum items. Previously the rename had no effect.

2022-10-05: olly
	    #1465 Report errors in preprocessor expressions by default

	    Until now SWIG quietly ignored such errors unless -Wextra (or -Wall
	    which implies -Wextra) was passed, but this is unhelpful as it tends
	    to hide genuine problems.  To illustrate this point, enabling this
	    warning by default revealed a typo in the preproc_defined.i
	    testcase in SWIG's own testsuite.

	    If you really don't want to see this warning, you can suppress it
	    with command line option -w202 or by using this in your interface
	    file:

	    %warnfilter(SWIGWARN_PP_EVALUATION);

	    Both will work with older versions of SWIG too.

2022-10-04: olly
	    #1050 Consistently define SWIG_VERSION both at SWIG-time and in
	    the generated wrapper.  Best practice remains to check at SWIG-time
	    where possible because that results in smaller generated wrapper
	    sources.

	    SWIGGO and SWIGJAVASCRIPT are now defined in the generated wrappers
	    to match behaviour for all other target languages.

	    The undocumented SWIGVERSION macro is no longer defined.

2022-09-29: olly
	    #2303 SWIG's internal hash tables now use a better hash function.

	    The old hash function only considered the last five characters
	    plus the least significant bit of the last-but-sixth character,
	    which as you might guess generated a lot of many-way collisions.

	    This change seems to give about a 4% reduction in wallclock time
	    for processing li_std_list_wrap.i from the testsuite for Python.
	    The hash collision rate for this example drops from 39% to 0!

2022-09-29: wsfulton
            #2303 Type tables are now output in a fixed order whereas previously
            the order may change with any minor input code change. This shouldn't
            affect users except SWIG_TypePrettyName may output a different C/C++
            typedef to a type - it's used mostly for showing errors when the type
            passed to a function is wrong.

2022-09-29: olly
	    [PHP] Dynamic class properties are no longer supported by default.

	    Historically PHP has supported dynamic class properties and SWIG
	    has implemented them too (because we implement the magic __get(),
	    __set() and __isset() methods we need to include explicit
	    handling).

	    PHP 8.2 deprecates dynamic class properties - initially they'll
	    warn, and apparently they'll not work by default in PHP 9.0:
	    https://wiki.php.net/rfc/deprecate_dynamic_properties

	    In PHP code dynamic properties can be enabled for a class by
	    marking that class with the attribute `#[AllowDynamicProperties]`.

	    To follow this PHP change, in SWIG you now need to specify
	    `%feature("php:allowdynamicproperties", 1) Foo;` (or
	    `%feature("php:allowdynamicproperties", 1)` to enable it for
	    all wrapped classes).  Unknown features are ignored, so you can add
	    it unconditionally and it'll work with older SWIG too.

	    *** POTENTIAL INCOMPATIBILITY ***

2022-09-19: wsfulton
            #1484 Fixes for class inheritance with the same name in different namespaces
            such as:

              namespace A { class Bar {}; }
              namespace B { template<typename T, typename U> class Bar : public A::Bar {}; }

2022-09-19: wsfulton
            #2316 Remove swig.spec file and srcrpm makefile target. These are very out of date
            and don't seem to be used by RPM based Linux distributions which have their
            own version of swig.spec.

2022-09-17: wsfulton
            [Go, Guile, Racket, Scilab] Add throws typemaps for std::string so that thrown
            string exception messages can be seen.

2022-09-17: wsfulton
            [Racket] Add throws typemaps for char * so that thrown string exception
            messages can be seen from Racket.

2022-09-17: wsfulton
            [Javascript, Octave, R] Improve exceptions for %catches and exception
            specifications for native types. String exception messages are shown as
            the exception message instead of just the type of the exception.

2022-09-17: wsfulton
            Add missing typecheck typemaps for std::auto_ptr and std::unique_ptr to
            fix overloading when using these types.

2022-09-17: wsfulton
            [Guile] Add error checking to SWIGTYPE and SWIGTYPE & in typemaps to prevent
            seg faults when passing #nil to these parameter types.

2022-09-16: wsfulton
            #999 Provide SWIGTYPE MOVE typemaps in swigmove.i for implementing full
            move semantics when passing parameters by value.

2022-08-31: wsfulton
            #999 Improve move semantics when using rvalue references.
            The SWIGTYPE && input typemaps now assume the object has been moved.

            These typemaps have been changed assuming that after the function call,
            the rvalue reference parameter has been moved. The parameter's proxy class
            that owns the C++ object thus has the underlying pointer set to null
            so that the (moved from, but still valid) C++ object cannot be used again
            and the object is additionally deleted.

            *** POTENTIAL INCOMPATIBILITY ***

2022-08-28: wsfulton
            [Octave] SWIG now marshals a C/C++ NULL pointer into the null matrix, [].
            SWIG has always marshalled the null matrix into a NULL pointer; this remains
            and now we have consistency in representing a NULL pointer.

2022-08-26: wsfulton
            [Racket] SWIG now marshals a C/C++ NULL pointer into a null value by calling
            scheme_make_null(), so that scheme's null? is true for a NULL C/C++ pointer value.

2022-08-18: wsfulton
            [Racket] Add support for std::unique_ptr in std_unique_ptr.i.
            Add support for std::auto_ptr in std_auto_ptr.i.

2022-08-13: wsfulton
            [Guile] Add support for std::unique_ptr in std_unique_ptr.i.
            Add support for std::auto_ptr in std_auto_ptr.i.

2022-08-11: wsfulton
            [Lua] Add support for std::unique_ptr in std_unique_ptr.i.
            Add support for std::auto_ptr in std_auto_ptr.i.

2022-08-05: wsfulton
            [D] Fix occasional undefined behaviour with inheritance hierarchies, particularly
            when using virtual inheritance as the pointers weren't correctly upcast from derived
            class to base class when stored in the base's proxy class.

2022-08-05: wsfulton
            [D] Add support for std::unique_ptr in std_unique_ptr.i.
            Add support for std::auto_ptr in std_auto_ptr.i.

2022-08-03: wsfulton
            [Javascript] Add support for std::unique_ptr in std_unique_ptr.i.
            Add support for std::auto_ptr in std_auto_ptr.i.

2022-08-02: wsfulton
            [Octave] Add support for std::unique_ptr in std_unique_ptr.i.
            Add support for std::auto_ptr in std_auto_ptr.i.

2022-08-01: wsfulton
            [Python] Add initialisers for additional members in PyHeapTypeObject
            (builtin mode) for Python-3.11 - _ht_tpname, _spec_cache.

2022-07-30: wsfulton
            C++20 has deprecated std::basic_string<>::reserve() and the C++11 method
            std::basic_string<>::shrink_to_fit() is a replacement that can be used.
            std_string.i and std_wstring.i provided wrappers for reserve with the following
            template instantiations:

              %template(string) std::basic_string<char>;
              %template(wstring) std::basic_string<wchar_t>;

            The reserve method is no longer wrapped, however the shrink_to_fit() method
            can be used as an alternative from the target language (the generated wrappers
            call reserve() instead if C++<=20).

            Note that std::basic_string<>::reserve(size_t n) is still wrapped unchanged.

            *** POTENTIAL INCOMPATIBILITY ***

2022-07-30: wsfulton
            [Tcl] Add support for std::unique_ptr in std_unique_ptr.i.
            Add support for std::auto_ptr in std_auto_ptr.i.

2022-07-27: ZackerySpytz, olly
	    #1678 Support parsing C++20 templated lambdas.

2022-07-27: ZackerySpytz, olly
	    #1622 Add support for the C++20 spaceship operator (<=>).

2022-07-26: olly
	    [Tcl] https://sourceforge.net/p/swig/bugs/977/
	    Fix handling of long long on 32-bit platforms.  This fix raises
	    SWIG's minimum supported Tcl version to 8.4.0 (which was released
	    just under 20 years ago).

2022-07-26: olly
            Fix incorrect operator precedence in preprocessor expressions.

2022-07-25: olly
	    Support for C++14 binary integer literals in preprocessor expressions.

2022-07-20: wsfulton
            [C#, Java] Ensure the order of interfaces generated in proxy interfaces for the
            %interface family of macros is the same as that parsed from the bases in C++.

2022-07-20: jicks, Ingener74, olly
	    #422 [Python] Fix mishandling of a Python class inheriting from
	    multiple SWIG-wrapped director classes.

2022-07-19: wsfulton
            #692 [C#, Java, Perl, Python, Ruby] std::unique_ptr and std::auto_ptr typemaps
            provided for inputs types in std_unique_ptr.i and std_auto_ptr.i.

            Now these smart pointers can be used as input parameters to functions. A proxy
            class instance transfers memory ownership of the underlying C++ object from the
            proxy class to a smart pointer instance passed to the wrapped function.

2022-07-19: jschueller
	    [Python] #2314 Drop support for Python 3.2.

2022-07-19: olly
	    Remove remaining support code for classic macos, which has not been
	    supported by Apple for over 20 years now.

2022-07-12: wsfulton
            #999 Performance optimisation for parameters passed by value that are C++11 movable.
            The C++ wrappers create a temporary variable for a parameter to be passed to a
            function. This is initially default constructed and then copy assigned from the
            instance being passed in from the target language. This is unchanged, however,
            when the temporary variable is passed to the wrapped function, it is now done using
            std::move. If the type is move constructible, the move constructor will be used
            instead of the copy constructor.

2022-07-12: wsfulton
            [Perl] Add std::auto_ptr support in std_auto_ptr.i library file.

2022-07-12: erezgeva
            [Perl] Add std::unique_ptr support in std_unique_ptr.i library file.

2022-07-07: jmarrec
	    #1158 #2286 Add basic support for C++11 attributes.  These are now
	    crudely ignored by SWIG's parser's tokeniser, which is better than
	    failing with a parse error.

2022-07-05: ianlancetaylor
	    [Go] #2245 Handle NULL pointers for string* conversions.
	    Rearrange generation of director methods and rename
	    receiver argument from p to swig_p.

2022-07-03: wsfulton
            #999 Performance optimisation for directors for classes passed by value. The directorin
            typemaps in the director methods now use std::move on the input parameter when
            copying the object from the stack to the heap prior to the callback into the target
            language, thereby taking advantage of move semantics if available.

2022-07-02: wsfulton
            #1722 [C#, Java, Python, Ruby] Add std::unique_ptr support. Ported from std::auto_ptr.
            Use the %unique_ptr(T) macro as follows for usage std::unique_ptr<T>. For example, for
            a class called Klass:

              %include "std_unique_ptr.i"
              %unique_ptr(Klass)

            Support is currently limited to only returning a std::unique_ptr from a function.

2022-06-29: wsfulton
            #999 #1044 Enhance SWIGTYPE "out" typemaps to use std::move when copying
            objects, thereby making use of move semantics when wrapping a function returning
            by value if the returned type supports move semantics.

            Wrapping functions that return move only types 'by value' now work out the box
            without having to provide custom typemaps.

            The implementation removed all casts in the "out" typemaps to allow the compiler to
            appropriately choose calling a move constructor, where possible, otherwise a copy
            constructor. The implementation also required modifying SwigValueWrapper to
            change a cast operator from:

              SwigValueWrapper::operator T&() const;

            to

              #if __cplusplus >=201103L
                SwigValueWrapper::operator T&&() const;
              #else
                SwigValueWrapper::operator T&() const;
              #endif

            This is not backwards compatible for C++11 and later when using the valuewrapper feature
            if a cast is explicitly being made in user supplied "out" typemaps. Suggested change
            in custom "out" typemaps for C++11 and later code:

            1. Try remove the cast altogether to let the compiler use an appropriate implicit cast.
            2. Change the cast, for example, from static_cast<X &> to static_cast<X &&>, using the
               __cplusplus macro if all versions of C++ need to be supported.

            *** POTENTIAL INCOMPATIBILITY ***

2022-06-15: wsfulton
            #2039 Add move assignment operator to SwigValueWrapper used by the
            valuewrapper feature.

2022-06-04: sethrj
            Enhance $typemap to support typemap attributes.

              $typemap(method:attribute, typepattern)

            For example:

              %typemap(cstype, out="object") XClass "XClass"
              %typemap(cscode) BarClass %{
                $typemap(cstype:out, XClass) bar() {
                  return null;
                }

              which expands to

                object bar() {
                  return null;
                }

2022-05-30: wsfulton
            [C#, D] Add new special variable expansion: $imfuncname.
            Expands to the function name called in the intermediary class.

2022-05-30: LindleyF
            [Java] #2042 Add new special variable expansion: $imfuncname.
            Expands to the function name called in the intermediary class.

2022-05-28: jkuebart
            [Java] On some versions of Android, specifically Android 6,
            detaching the current thread from the JVM after every invocation
            causes a memory leak.

            Offer SWIG_JAVA_DETACH_ON_THREAD_END to configure a behaviour
            where the JVM is only detached in the thread destructor.

            See https://developer.android.com/training/articles/perf-jni#threads.

2022-05-27: xypron
            [Python] #2277 Define PY_SSIZE_T_CLEAN macro before #include "Python.h" as
            recommended in Python 3.7 and later.

            To avoid this macro definition, add the following to your interface file so
            that SWIG_NO_PY_SSIZE_T_CLEAN is defined at the beginning of the C++ wrappers:

              %begin %{
              #define SWIG_NO_PY_SSIZE_T_CLEAN
              %}

2022-05-26: rokups
            [C#] #1323 Modify SwigDerivedClassHasMethod for a more efficient director
            implementation when calling virtual methods that are not overridden.

2022-05-15: erezgeva, eiselekd
            [Lua, Perl, Octave, PHP, Tcl] #2275 #2276 #2283 Add argcargv.i library containing
            (int ARGC, char **ARGV) multi-argument typemaps.

            Document this library in Typemaps.html.

2022-05-07: KrisThielemans
            [Python] Fix "too many initializers for 'PyHeapTypeObject'" errors
            using PyPy 3.8 and later.

2022-05-04: wsfulton
            [C#] Add C# wchar_t * director typemaps

2022-04-20: cminyard
	    Fix an issue where newlines were not properly generated
	    for godirectorin typemaps.  If you have a virtual function
	    not assigned to zero, in some cases it won't generate a
	    newline and you will see errors:
	      example.go:1508:3: expected ';', found swig_r
	    when compiling the go code.

	    Also add an example of using goin and godirectorin and add
	    a test for this situation.

2022-04-29: jason-daly, JerryJoyce, wsfulton
	    [C#] #1233 Add wchar_t * and std::wstring Unicode string support on Linux.

2022-04-11: robinst
	    #2257 Fix new Ruby 3.2 warning "undefining the allocator of T_DATA
	    class swig_runtime_data".

2022-04-07: olly
	    #1750 SWIG now recognises and ignores Doxygen group commands `@{` and `@}`.

2022-04-06: wsfulton
            ./configure now enables C++11 and later C++ standards testing by default (when
            running: 'make check').

            The options to control this testing are the same:

              ./configure --enable-cpp11-testing
              ./configure --disable-cpp11-testing

            But the former is now the default and the latter can be used to turn off C++11 and
            later C++ standards testing.

2022-04-06: wsfulton
            [Python] #1635 The "autodoc" feature no longer overrides Doxygen comments
            in the generated docstring.

            If a "docstring" feature is present it will still override a Doxygen comment.
            If the "autodoc" feature is also present, the combined "autodoc" and "docstring"
            will override the Doxygen comment. If no "docstring" is present then the
            "autodoc" feature will not be generated when there is a Doxygen comment.

            This way the "autodoc" feature can be specified and used to provide documentation
            for 'missing' Doxygen comments.

            *** POTENTIAL INCOMPATIBILITY ***

2022-04-01: olly
	    Remove undocumented and non-functional -browse command line option.

2022-03-26: eltoder
            [Python] #1684 Use different capsule names with and without -builtin

            Types generated with and without -builtin are not compatible. Mixing
            them in a common type list leads to crashes. Avoid this by using
            different capsule names: "type_pointer_capsule" without -builtin and
            "type_pointer_capsule_builtin" with.

2022-03-25: wsfulton
            The debug command line options that display parse tree nodes
            (-debug-module, -debug-top, -debug-symtabs) now display previously hidden
            linked list pointers which are useful for debugging parse trees.

            Added new command line option -debug-quiet. This suppresses the display
            of most linked list pointers and symbol table pointers in the parse tree nodes.

            The keys in the parse tree node are now shown in alphabetical order.

2022-03-24: wsfulton
            #2244 Fix using declaration in derived class bugs when all the base
            class's overloaded methods were overridden in the derived class -
            fixes "multiply defined" errors.

2022-03-23: wsfulton
            [Python] #1779 The -py3 option is deprecated and now has no effect on the
            code generated. Use of this option results in a deprecated warning.
            The related SWIGPYTHON_PY3 macro that this option defined is no longer generated.

            Note that %pythonnondynamic feature generates a metaclass that works on both
            Python 2 and Python 3.

2022-03-21: wsfulton
            [Python] #1779 pyabc.i for abstract base classes now supports versions of
            Python prior to 3.3 by using the collection module for these older versions.
            Python-3.3 and later continue to use the collections.abc module.
            The -py3 option no longer has any effect on the %pythonabc feature.

2022-03-21: jschueller, jim-easterbrook, wsfulton
            [Python] #2137 C++ static member functions no longer generate a "flattened"
            name in the Python module. For example:

              s = example.Spam()
              s.foo()               # Spam::foo() via an instance
              example.Spam.foo()    # Spam::foo() using class method
              example.Spam_foo()    # Spam::foo() "flattened" name

            The "flattened" name is no longer generated, but can be generated
            by using the new -flatstaticmethod option.

            *** POTENTIAL INCOMPATIBILITY ***

2022-03-18: ianlancetaylor
	    [Go] #337 Implement %extend base methods in child classes.

2022-03-17: olly
	    [Python] #1779 SWIG's Python test-suite and examples are now
	    run with Python 3 by default.  To run them with Python 2, set
	    PY2 to a non-empty value, e.g.:

	    make check-python-test-suite PY2=1

2022-03-16: olly
	    [Go] #683 -intgosize is now optional - if not specified the
	    generated C/C++ wrapper code will use ptrdiff_t for intgo and
	    size_t for uintgo.

2022-03-15: ianlancetaylor
	    [Go] Add typemaps for std::string*.

2022-03-15: ianlancetaylor
	    [Go] Don't convert arrays to pointers if there is a "gotype"
	    typemap entry.

2022-03-15: ianlancetaylor
	    [Go] Add documentation note about Go and C++ exceptions.

2022-03-12: wsfulton
            #1524 %interface family of macros no longer contain the getter/setter
            methods for wrapping variables. The interface only contains
            virtual and non-virtual instance methods, that is, no static methods.
            Enums are also no longer added to the interface (affects Java only where
            they were missing from the proxy class, C# never had them in the interface).

            *** POTENTIAL INCOMPATIBILITY ***

2022-03-12: wsfulton
            #1277 Fixes for the family of %interface macros, %interface,
            %interface_impl and %interface_custom fixes for overloaded methods
            in an inheritance chain.

            When C++ methods are not able to be overloaded in a derived class,
            such as when they differ by just const, or the target language
            parameters types are identical even when the C++ parameter types
            are different, SWIG will ignore one of the overloaded methods with
            a warning. A %ignore is required to explicitly ignore one of the
            overloaded methods to avoid the warning message. Methods added
            in the derived classes due to one of the %interface macros are now
            similarly ignored/not added to the derived class.

            The methods added to the derived classes can now also be modified
            via %feature and %rename.

2022-03-08: ianlancetaylor
	    [Go] Treat a nil argument as a NULL pointer.

2022-03-08: ianlancetaylor
	    [Go] Add documentation notes about thread local storage.

2022-03-08: olly
	    #1006 SWIG now copes with an interface filename specified on the
	    command line which contains a closing parenthesis `)`, and more
	    generally with attributes to `%include` and `%import` which
	    are quoted and contain parentheses.

2022-03-07: Omar Medina
	    [Tcl] https://sourceforge.net/p/swig/bugs/1290/
	    Fix SWIG_AsWCharPtrAndSize() to actually assign to result
	    variable.  It looks like SWIG/Tcl wide character handling is
	    currently fundamentally broken except on systems which use wide
	    characters as the system encoding, but this should fix wrapping
	    functions which take a wide string as a parameter on Microsoft
	    Windows.

2022-03-07: olly
	    [Javascript] #682 Fix handling of functions which take void*.

2022-03-06: olly
	    SWIG should now reliably exit with status 0 if the run was
	    successful and status 1 if there was an error (or a warning and
	    -Werror was in effect).

	    Previously in some situations SWIG would try to exit with the
	    status set to the number of errors encountered, but that's
	    problematic - for example if there were 256 errors this would
	    result in exit status 0 on most platforms.  Also some error
	    statuses have special meanings e.g. those defined by <sysexits.h>.
	    Also SWIG/Javascript tried to exit with status -1 in a few places
	    (which typically results in exit status 255).

2022-03-05: wsfulton
            #1441 Fix using declaration in derived class incorrectly introducing a method
            from a base class when the using declaration is declared before the method
            declaration. Problem occurred when within a namespace and the parameter types
            in the method signatures were not fully qualified.

2022-03-05: ianlancetaylor
	    [Go] Treat non-const references as pointers.

2022-03-05: ianlancetaylor
	    In SWIG Go testsuite, fail test if "go build" fails.

2022-03-03: olly
	    #1901 #2223 SWIG should now always exit cleanly if memory
	    allocation fails, including removing any output files created
	    during the current run.

	    Previously most places in the code didn't check for a NULL return
	    from malloc()/realloc()/calloc() at all, typically resulting in
	    undefined behaviour; some places used assert() to check for a NULL
	    return (which is a misuse of assert() and such checks disappear if
	    built with NDEBUG defined leaving us back with undefined
	    behaviour).

2022-03-03: olly
	    #891 Report errors for typemap attributes without a value
	    (previously SWIG segfaulted) and for typemap types with a value
	    (previously the value was quietly ignored).

	    The old way of specifying a language name in the typemap attributes
	    is no longer supported (it has been deprecated for 16 years).

2022-03-02: geographika, wsfulton
            [Python] #1951 Add Python variable annotations support.

            Both function annotations and variable annotations are turned on using the
            "python:annotations" feature. Example:

              %feature("python:annotations", "c");

              struct V {
                float val;
              };

            The generated code contains a variable annotation containing the C float type:

              class V(object):
                  val: "float" = property(_example.V_val_get, _example.V_val_set)
                  ...

            Python 3.5 and earlier do not support variable annotations, so variable
            annotations can be turned off with a "python:annotations:novar" feature flag.
            Example turning on function annotations but not variable annotations globally:

              %feature("python:annotations", "c");
              %feature("python:annotations:novar");

            or via the command line:

              -features python:annotations=c,python:annotations:novar

            *** POTENTIAL INCOMPATIBILITY ***

2022-02-27: wsfulton
            [Python] #735 #1561 Function annotations containing C/C++ types are no longer
            generated when using the -py3 option. Function annotations support has been
            moved to a feature to provide finer grained control. It can be turned on
            globally by adding:

              %feature("python:annotations", "c");

            or by using the command line argument:

              -features python:annotations=c

            Also see entry dated 2022-03-02, regarding variable annotations.

            *** POTENTIAL INCOMPATIBILITY ***

2022-02-26: wsfulton
            #655 #1840 Add new warning WARN_LANG_USING_NAME_DIFFERENT to warn when a
            method introduced by a using declaration in a derived class cannot
            be used due to a conflict in names.

2022-02-24: olly
	    #1465 An invalid preprocessor expression is reported as a pair of
	    warnings with the second giving a more detailed message from the
	    expression evaluator.  Previously SWIG prefixed the second message
	    with "Error:" - that was confusing as it's actually only a warning
	    by default so we've now dropped this prefix.

	    Before:

	    x.i:1: Warning 202: Could not evaluate expression '1.2'
	    x.i:1: Warning 202: Error: 'Floating point constant in preprocessor expression'

	    Now:

	    x.i:1: Warning 202: Could not evaluate expression '1.2'
	    x.i:1: Warning 202: Floating point constant in preprocessor expression

2022-02-23: olly
	    #1384 Fix a preprocessor expression evaluation bug.  A
	    subexpression in parentheses lost its string/int type flag and
	    instead used whatever type was left in the stack entry from
	    previous use.  In practice we mostly got away with this because
	    most preprocessor expressions are integer, but it could have
	    resulted in a preprocessor expression incorrectly evaluating as
	    zero.  If -Wextra was in use you got a warning:

	    Warning 202: Error: 'Can't mix strings and integers in expression'

2022-02-21: davidcl
	    [Scilab] Improve 5.5.2, 6.0.0 and 6.1.0 support.

	    For Scilab 5, long names are reduced to small names preserving the 
	    class prefix and accessor suffix (get or set).

	    For Scilab 6, long names with the class prefix and accessor suffix
	    should be used on the user code.

	    The `-targetversion` option has been removed as the generated code
	    now detects the Scilab version in loader.sce or builder.sce.

	    *** POTENTIAL INCOMPATIBILITY ***

2022-02-20: wsfulton
            Fix %warnfilter warning suppress for warning 315 SWIGWARN_PARSE_USING_UNDEF.

2022-02-17: olly
	    [PHP] https://sourceforge.net/p/swig/bugs/1211/
	    Fix to call cleanup code in exception situations and not to invoke
	    the freearg typemap twice in certain situations.

2022-02-15: olly
	    #300 #368 Improve parser handling of % followed immediately by
	    an identifier.  If it's not a recognised directive the scanner
	    now emits MODULO and then rescans what follows, and if the parser
	    then gives a syntax error we report it as an unknown directive.
	    This means that `a%b` is now allowed in an expression, and that
	    things like `%std::vector<std::string>` now give an error rather
	    than being quietly ignored.

2022-02-11: adr26
            [Python] #2154 Fix memory leak.

            SWIG python objects were being freed after the corresponding SWIG
            module information was destroyed in Python 3, causing leaks when as
            a result the object destructor could not be invoked. To prevent this
            misordering, SWIG python objects now obtain a reference to the
            Python capsule wrapping the module information, so that the module
            information is correctly destroyed after all SWIG python objects
            have been freed (and corresponding destructors invoked).

2022-02-10: olly
	    [Tcl] https://sourceforge.net/p/swig/bugs/1207/
	    https://sourceforge.net/p/swig/bugs/1213/

	    Fix Tcl generic input typemap for std::vector.

2022-02-07: sethrj
            #2196 Add alternative syntax for specifying fragments in typemaps.

            New syntax:
              %typemap("in", fragment="frag1", fragment="frag2", fragment="frag3") {...}
            which is equivalent to:
              %typemap(in, fragment="frag1,frag2,frag3") {...}


2022-02-07: olly
	    #1806 Remove support for the "command" encoder, which was mostly
	    intended for use in `%rename` - most uses can be achieved using
	    the "regex" encoder, so we recommend using that instead.

	    The "command" encoder suffers from a number of issues - as the
	    documentation for it admitted, "[it] is extremely slow compared to
	    all the other [encoders] as it involves spawning a separate process
	    and using it for many declarations is not recommended" and that it
	    "should generally be avoided because of performance
	    considerations".

	    But it's also not portable.  The design assumes that `/bin/sh`
	    supports `<<<` but that's a bash-specific feature so it doesn't
	    work on platforms where `/bin/sh` is not bash - it fails on
	    Debian, Ubuntu and probably some other Linux distros, plus most
	    non-Linux platforms.  Microsoft Windows doesn't even have a
	    /bin/sh as standard.

	    Finally, no escaping of the passed string is done, so it has
	    potential security issues (though at least with %rename the input
	    is limited to valid C/C++ symbol names).

2022-02-06: olly
	    #2193 -DFOO on the SWIG command line now sets FOO to 1 for
	    consistency with C/C++ compiler preprocessors.  Previously
	    SWIG set FOO to an empty value.

	    Existing invocations of SWIG with `-DFOO` where the empty value
	    matters can be updated to `-DFOO=` which should work with both
	    old and new releases of SWIG.

	    *** POTENTIAL INCOMPATIBILITY ***

2022-02-06: sethrj
	    #2194 Classes that are non-assignable due to const data or const
	    reference members are now automatically detected.

2022-02-04: friedrichatgc
	    [Octave] #1672 Fix for isobject for Octave 4.4 - 6.0.

2022-02-03: olly
	    [C#] #283 #998 Fix memory leak in directorin typemap for
	    std::string.

2022-02-03: olly
	    [Python] #967 Make `self` parameter available to user typemaps.

2022-02-03: teythoon
	    [Python] #801 Fix -Wunused-parameter warnings with builtin,

2022-02-03: teythoon
	    #801 Fix -Wstrict-prototypes warnings in generated pointer
	    functions.

2022-02-03: olly
	    #660 https://sourceforge.net/p/swig/bugs/1081/
	    Default parameter values containing method calls are now parsed and
	    handled - e.g. `x->foo(3,4)` and `y.z()`.

2022-02-02: olly
	    [Ruby] https://sourceforge.net/p/swig/bugs/1136/ Fix remove of prefix
	    from method name to only remove it at the start.

2022-02-01: olly
	    #231 Handle returning an object by reference in a C++ trailing
	    return type.

2022-02-01: davidcl
            [Scilab] #745 use SWIG_<module>_Init() as a C module init function.

2022-02-01: olly
	    [OCaml] #2083 Fix to work when CAML_SAFE_STRING is on, which it is
	    by default in recent Ocaml releases.

2022-01-31: mreeez
	    https://sourceforge.net/p/swig/bugs/1147/
	    Fix copyToR() generated for a struct in a namespace.

2022-01-29: fschlimb
	    #655 Better handling of using declarations.

2022-01-29: dontpanic92
	    [Go] #676 Fix code generated for a C++ class with a non-capitalised
	    name.

2022-01-26: trex58
	    #1919 #1921 #1923 Various fixes for AIX portability.

2022-01-26: olly
	    #1935 Don't crash on an unclosed HTML tag in a doxygen comment
	    when -doxygen is specified.

2022-01-25: olly
	    Constant expressions now support member access with `.` such as
	    `foo.bar`.  Previous this only worked in a case like `x->foo.bar`.

2022-01-25: olly
	    #2091 Support most cases of `sizeof` applied to an expression
	    in constant expressions.  Previously there was only support for
	    `sizeof(<type>)` and expressions which syntactically look like a
	    type (such as `sizeof(foo)`).

2022-01-25: olly
	    #80 #635 https://sourceforge.net/p/swig/bugs/1139/
	    Add support for parsing common cases of `<` and `>` comparisons
	    in constant expressions.  Adding full support for these seems hard
	    to do without introducing conflicts into the parser grammar, but in
	    fact all reported cases have had parentheses around the comparison
	    and we can support that with a few restrictions on the left side of
	    `<`.

2022-01-25: wsfulton
            New warning 327 for extern templates, eg:

              extern template class std::vector<int>;
              extern template void Func<int>();

            results in warning

              example.i:3: Warning 327: Extern template ignored.
              example.i:4: Warning 327: Extern template ignored.

            Extern template classes previously resulted in warning 320.

2022-01-24: romintomasetti
            #2131 #2157 C++11 extern function template parsing error fix.

2022-01-21: wsfulton
            #2120 #2138 Replace legacy PCRE dependency with PCRE2.
            This requires changes for building SWIG from source. See updated
            html documentation in Preface.html and Windows.html. Updated
            instructions are also shown when running ./configure if PCRE2 is not
            found. Note that debian based systems can install PCRE2 using:

              apt install libpcre2-dev

            Note that https://github.com/swig/swig/wiki/Getting-Started also has
            updated information for building from source.

2022-01-19: olly
	    [PHP] #2027 Automatically generate PHP type declarations for PHP 8.
	    The generate code still compiles for PHP 7.x, but without type
	    declarations since PHP 7.x has much more limited type declaration
	    support.

2022-01-18: olly
	    [Perl] #1629 Perl 5.8.0 is now the oldest version we aim to support.

2022-01-14: wsfulton
            [Python] Fix %callback and specifying the callback function as a
            static member function using Python staticmethod syntax, such as
            Klass.memberfunction instead of Klass_memberfunction when using
            -builtin and -fastproxy.

2022-01-11: wsfulton
            [Python] Accept keyword arguments accessing static member functions when
            using -builtin and kwargs feature and Python class staticmethod syntax.
            The missing keyword argument support was only when using the
            class staticmethod syntax, such as Klass.memberfunction, and not when
            using the flat static method syntax, such as Klass_memberfunction.

2022-01-04: juierror
            [Go] #2045 Add support for std::array in std_array.i.

2021-12-18: olly
	    [PHP] Add PHP keyword 'readonly' (added in 8.1) to the list SWIG
	    knows to automatically rename.  This keyword is special in that PHP
	    allows it to be used as a function (or method) name.

2021-12-07: vstinner
            [Python] #2116 Python 3.11 support: use Py_SET_TYPE()

2021-12-05: rwf1
            [Octave] #2020 #1893 Add support for Octave 6 up to and including 6.4.
            Also add support for compiling with -Bsymbolic which is used by default
            by mkoctfile.

2021-12-02: jsenn
            [Python] #2102 Fixed crashes when using embedded Python interpreters. 

2021-11-12: wsfulton
            [Javascript] v8 and node only. Fix mismatched new char[] and free()
            when wrapping C code char arrays. Now calloc is now used instead of
            new char[] in SWIG_AsCharPtrAndSize.

2021-10-03: ajrh1
            [Perl] #2074: Avoid -Wmisleading-indentation in generated code
            when using gcc11.

2021-10-03: jschueller
            [CMake] #2065: Add option to enable or disable PCRE support.

2021-09-16: ianlancetaylor
            [Go] Improved _cgo_panic implementation.

2021-09-16: ianlancetaylor
            [Go] Don't use crosscall2 for panicking. Instead rely on documented
            and exported interfaces.

2021-09-14: ianlancetaylor
            [Go] Remove -no-cgo option (long unsupported in Go)

2021-05-04: olly
	    [PHP] #2014 Throw PHP exceptions instead of using PHP errors

	    PHP exceptions can be caught and handled if desired, but if they
	    aren't caught then PHP exits in much the same way as it does for a
	    PHP error.

	    In particular this means parameter type errors and some other cases
	    in SWIG-generated wrappers now throw a PHP exception, which matches
	    how PHP's native parameter handling deals with similar situations.

	    `SWIG_ErrorCode()`, `SWIG_ErrorMsg()`, `SWIG_FAIL()` and `goto thrown;`
	    are no longer supported (these are really all internal implementation
	    details and none are documented aside from brief mentions in CHANGES
	    for the first three).  I wasn't able to find any uses in user interface
	    files at least in FOSS code via code search tools.

	    If you are using these:

	    Use `SWIG_PHP_Error(code,msg);` instead of `SWIG_ErrorCode(code);
	    SWIG_ErrorMsg(msg);` (which will throw a PHP exception in SWIG >= 4.1
	    and do the same as the individual calls in older SWIG).

	    `SWIG_FAIL();` and `goto thrown;` can typically be replaced with
	    `SWIG_fail;`.  This will probably also work with older SWIG, but
	    please test with your wrappers if this is important to you.

	    *** POTENTIAL INCOMPATIBILITY ***

2021-05-17: adr26
            [Python] #1985 Fix memory leaks:

            1. Python object references were being incorrectly retained by
            SwigPyClientData, causing swig_varlink_dealloc() never to run / free
            memory. SwigPyClientData_New() / SwigPyClientData_Del() were updated
            to fix the object reference counting, causing swig_varlink_dealloc()
            to run and the memory swig_varlink owns to be freed.

            2. SwigPyClientData itself was not freed by SwigPyClientData_Del(),
            causing another heap leak. The required free() was added to
            SwigPyClientData_Del()

            3. Fix reference counting/leak of python cached type query

            4. Fix reference counting/leak of SwigPyObject dict (-builtin)

            5. Python object reference counting fixes for out-of-memory
            scenarios were added to: SWIG_Python_RaiseOrModifyTypeError(),
            SWIG_Python_AppendOutput(), SwigPyClientData_New(),
            SwigPyObject_get___dict__() and SwigPyObject_format()

            6. Add error handling for PyModule_AddObject() to
            SWIG_Python_SetModule() (failure could be caused by OOM or a name
            clash caused by malicious code)

2021-05-13: olly
	    [UFFI] #2009 Remove code for Common Lisp UFFI.  We dropped support
	    for it in SWIG 4.0.0 and nobody has stepped forward to revive it in
	    over 2 years.

2021-05-13: olly
	    [S-EXP] #2009 Remove code for Common Lisp S-Exp.  We dropped
	    support for it in SWIG 4.0.0 and nobody has stepped forward to
	    revive it in over 2 years.

2021-05-13: olly
	    [Pike] #2009 Remove code for Pike.  We dropped support for it in
	    SWIG 4.0.0 and nobody has stepped forward to revive it in over 2
	    years.

2021-05-13: olly
	    [Modula3] #2009 Remove code for Modula3.  We dropped support for it
	    in SWIG 4.0.0 and nobody has stepped forward to revive it in over 2
	    years.

2021-05-13: olly
	    [CLISP] #2009 Remove code for GNU Common Lisp.  We dropped support
	    for it in SWIG 4.0.0 and nobody has stepped forward to revive it in
	    over 2 years.

2021-05-13: olly
	    [Chicken] #2009 Remove code for Chicken.  We dropped support for it
	    in SWIG 4.0.0 and nobody has stepped forward to revive it in over 2
	    years.

2021-05-13: olly
	    [Allegrocl] #2009 Remove code for Allegro Common Lisp.  We dropped
	    support for it in SWIG 4.0.0 and nobody has stepped forward to
	    revive it in over 2 years.

2021-05-04: olly
	    [PHP] #1982 #1457 https://sourceforge.net/p/swig/bugs/1339/
	    SWIG now only use PHP's C API to implement its wrappers, and no
	    longer generates PHP code to define classes.  The wrappers should
	    be almost entirely compatible with those generated before, but
	    faster and without some previously hard-to-fix bugs.

	    The main notable difference is SWIG no longer generates a .php
	    wrapper at all by default (only if %pragma(php) code=... or
	    %pragma(php) include=... are specified in the interface file).
	    This also means you need to load the module via extension=...
	    in php.ini, rather than letting the dl() in the generated
	    .php wrapper load it (but dl() has only worked for command-line
	    PHP for some years now).

	    *** POTENTIAL INCOMPATIBILITY ***

2021-04-30: olly
	    #1984 Remove support for $source and $target.
	    These were officially deprecated in 2001, and attempts to use them have
	    resulted in a warning (including a pointer to what to update them to)
	    for most if not all of that time.

2021-04-27: wsfulton
            #1987 [Java] Fix %interface family of macros for returning by const
            pointer reference.

2021-04-19: olly
	    Fix use of uninitialised variable in the generated code for an
	    empty typecheck typemap, such as the dummy one we include for
	    std::initializer_list.

2021-04-12: olly
	    #1777 [Python] Specifying -py3 now generates a check for Python
	    version >= 3.0.

2021-03-26: olly
	    [PHP] Add PHP keywords 'fn' (added in 7.4) and 'match' (added in
	    8.0) to the list SWIG knows to automatically rename.

2021-03-23: wsfulton
            #1942 [Python] Fix compilation error in wrappers when using -builtin
            and wrapping varargs in constructors.

2021-03-22: goto40
            #1977 Fix handling of template template parameters.

2021-03-21: olly
	    #1929, #1978 [PHP] Add support for PHP 8.

2021-03-19: wsfulton
            #1610 Remove -ansi from default compilation flags.

2021-03-19: dot-asm
            #1934 [Java] Clean up typemaps for long long arrays.

2021-03-19: olly
	    #1527 [PHP] Improve PHP object creation in directorin case.
	    Reportedly the code we were using in this case gave segfaults in
	    PHP 7.2 and later - we've been unable to reproduce these, but the
	    new approach is also simpler and should be bit faster too.

2021-03-18: olly
	    #1655 [PHP] Fix char* typecheck typemap to accept PHP Null like the
	    corresponding in typemap does.

2021-03-18: olly
	    #1900, #1905 [PHP] Fix wrapping of overloaded directed methods with
	    non-void return.

2021-03-11: murillo128
            #1498 [Javascript] Support type conversion.

2021-03-06: nshmyrev
            #872 [Javascript] Various typemap issues in arrays_javascript.i fixed.

2021-03-03: vaughamhong
            #577 [Javascript] Implemented SetModule/GetModule for JSC to allow type sharing
            across modules.

2021-03-01: xantares, Oliver Buchtala, geographika
            #1040 Add support for building SWIG with CMake. See documentation in Windows.html.

2021-03-01: vadz
            #1952 Fix incorrect warning "Unknown Doxygen command: ."

2021-02-28: p2k
            #969 [Javascript] v8/node - prevent crash calling a constructor without new keyword.

2021-02-28: alecmev
            #405 #1121 [Javascript] Fix OUTPUT typemaps on methods that don't return void.
            The output value is appended to the return value.

2021-02-26: murillo128, wsfulton
            #1269 [Javascript] Fix handling of large positive unsigned long and
            unsigned long long values.

2021-02-24: tomleavy, yegorich, tungntpham
            #1746 [Javascript] Add support for Node v12, v14 and v16.
            SWIG support for Node is now for v6 and later only.

2020-02-09: ZackerySpytz
            #1872 Fix typos in attribute2ref macros.

2020-10-10: wsfulton
            [Javascript] Fix so that ccomplex.i interface to file can be used.

2020-10-10: wsfulton
            #252 complex can now be used as a C identifier and doesn't give a syntax error.

2020-10-10: lpsinger
            #1770 Correct C complex support.
            _Complex is now parsed as a keyword rather than complex as per the C99 standard.
            The complex macro is available in the ccomplex.i library file along with other
            complex number handling provided by the complex.h header.

2020-10-07: ZackerySpytz
            [Python] #1812 Fix the error handling for the PyObject_GetBuffer() calls in
            pybuffer.i.

2020-10-07: treitmayr
            #1824 Add missing space in director method declaration returning
            const pointer.

2020-10-07: adelva1984
            #1859 Remove all (two) exceptions from SWIG executable.

2020-09-25: wsfulton
            [C#, Java] #1874 Add ability to change the modifiers for the interface
            generated when using the %interface macros.

            For C# use the 'csinterfacemodifiers' typemap.
            For Java use the 'javainterfacemodifiers' typemap.

            For example:

              %typemap(csinterfacemodifiers) X "internal interface"

2020-09-24: geefr
            [C#] #1868 Fix wchar_t* csvarout typemap for member variable wrappers.

2020-08-28: wsfulton
            [Java] #1862 Fix crashes in swig_connect_director during director class construction
            when using the director class from multiple threads - a race condition initialising
            block scope static variables. The fix is guaranteed when using C++11, but most
            compilers also fix it when using C++03/C++98.

2020-08-16: wsfulton
            [Python] Add missing initializer for member '_heaptypeobject::ht_module' when using
            -builtin to complete Python 3.9 support.

2020-08-16: wsfulton
            [Python] Remove PyEval_InitThreads() call for Python 3.7 and later as Python calls
            it automatically now. This removes a deprecation warning when using Python 3.9.

2020-08-15: wsfulton
            [Python] All Python examples and tests are written to be Python 2 and Python 3
            compatible, removing the need for 2to3 to run the examples or test-suite.

2020-08-13: wsfulton
            [C#] Add support for void *VOID_INT_PTR for member variables.

2020-07-29: chrisburr
            #1843 [Python] Compilation error fix in SwigPyBuiltin_SetMetaType when using PyPy.

2020-06-14: ZackerySpytz
            #1642 #1809 Fix virtual comparison operators in director classes by removing an
            incorrect space in the function name (for example, operator= = is now operator==).

Version 4.0.2 (8 Jun 2020)
==========================

2020-06-07  vigsterkr
            [Ruby] #1717 Nil fix mangling strings

2020-06-07  vadz
            #1748 Fix doxygen comments quoting issue

2020-06-07  munoah
            #1800 Escape spaces in file paths for dependencies (-M -MM etc)

2020-06-06  andreas-schwab
            [Ruby] #1801 Fix encoding on big endian systems when wrapping std::wstring.

2020-05-31  kwwette
            [Octave] #1789 error handling improvements and return error code on exit for SWIG wrapped modules.

2020-05-30  msteinbeck
            [D] #1593 Replace broken imports when using newer versions of D.

2020-05-29: ZackerySpytz
            [Python] #1716 Performance improvements when converting strings when using Python >= 3.3.

2020-05-28: ZackerySpytz
            #1776 Quite dramatically decrease run times when generating very large interface files by changing
            some internal memory pool sizes.

2020-05-28: mcfarljm
            #1788 Fix handling of Doxygen \endlink command.

2020-05-24: vapier
            [Javascript] #1796 Fix pkg-config invocation in configure.

2020-04-30: kwwette
            [Octave] Fix exception raising for newer Octave versions
            Since (at least) Octave 5.1.0, the Octave error() function now raises a C++ exception,
            which if uncaught immediately exits a SWIG wrapper function, bypassing any cleanup code
            that may appear after a "fail:" label. This patch adds a "try { ... } catch(...) { }"
            block around the contents of SWIG wrapper functions to first execute the cleanup code
            before rethrowing any exception raised. It is backward compatible with earlier versions
            of Octave where error() does not raise an exception, which will still branch to the
            "fail:" block to execute cleanup code if an error is encountered.

            Note that the new "try { ... } catch(...) { }" block will localise any local variables
            used in typemaps that were NOT declared through SWIG's %typemap(...) syntax, so it's
            possible this could break existing SWIG wrappers which were implicitly sharing local
            variables between typemaps. This can be fixed, however, by declaring local variables
            which need to be shared between typemaps through SWIG's %typemap(...) syntax.

2020-02-18: ryannevell
            [Lua] #1728 Add support for LUA lightuserdata to SWIG_Lua_ConvertPtr.

2020-02-18: dmach
            [Ruby] #1725 Fix gcc -Wcatch-value warnings.

2020-02-14: treitmayr
            #1724 Fix wrapping of abstract user-defined conversion operators.

2020-02-13: ddurham2
            [Python] #1512 Fix memleak when using STL containers of shared_ptr objects.

2020-02-06: wsfulton
            [Python] #1673 #1674 Fix setting 'this' when extending a proxy class with __slots__.

2020-01-31: vadz
            [Ruby] #1651 Add std::auto_ptr<> typemaps.

2020-01-31: ZackerySpytz
            [Python] #1700 The Python C API functions PyBytes_AsStringAndSize() and
            PyString_AsStringAndSize() are now checked for failure.

2020-01-31: vadz
            [Python] #1710 Fix crash parsing empty docstrings.

2020-01-30: Alzathar
            [R] #910 #914 Fix R memory leak on exception.

2020-01-30: richardbeare
            [R] #1511 Fix bug wrapping functions. These were previously incorrectly wrapped as if
            they were variables. This happened when 'get' or 'set' was in the name of the function
            or method, but sometimes also in some other circumstances. If you were using R
            attribute syntax to access these methods, you'll need to switch to calling them as R
            methods.

            *** POTENTIAL INCOMPATIBILITY ***

2020-01-24: etse-dignitas, wsfulton
            [C#, D, Java] #1533 Fix upcasting for shared_ptr's of templated types.

2020-01-16: mcfarljm
            #1643 #1654 When using -doxygen, fix segfault when nameless parameters or vararg parameters
            are used.

2020-01-16: mcfarljm
            #1632 #1659 Fix newline handling for doxygen "///" comments.

2020-01-14: mcfarljm
            #1647 #1656 Fix crash handling empty doxygen comments.

2020-01-14: mcfarljm
            #1608 Improve doxygen support.
            - Add support for \param[] commands such as: \param[in].
            - Optional arguments are marked as 'optional' in pydoc.
            - Improve support for \code commands so that other languages are supported as code blocks.
              Support added for java, c and py.  For example Python: \code{.py} ... \endcode
            - Fix doxygen handling of \em and \p tags for Python.

2020-01-13: wsfulton
            [Python] #1595 Python -builtin constructors silently ignored keyword arguments.
            Instead of silently ignoring them, now a "TypeError: f() takes no keyword arguments"
            exception is thrown if keyword arguments are used. Hence constructors and normal methods/
            functions behave in the same way. Note, -keyword should be used with -builtin to obtain
            keyword argument support.

2020-01-05: jschueller shadchin
            [Python] #1670 #1696 Add missing field initializers introduced in python 3.8:
            tp_vectorcall and tp_print.

2020-01-05: friedrichatgc
            [Octave] #1688 Change swig_this() to use size_t instead of long for compatibility
            with Windows 64 bit.

2020-01-05: treitmayr
            [Ruby] #1692 #1689 Add support for Ruby 2.7

2019-12-30: treitmayr
            [Ruby] #1653 #1668 Fix code generated when using -globalmodule option.

2019-12-29: ZackerySpytz
            [OCaml] #1686 Fix compilation errors with OCaml 4.09.0.

2019-12-10: wsfulton
            #1679 Fix parsing of C++11 identifiers with special meaning (final and override) when
            they are used as part of the scope name of an identifier, such as a namespace name.

2019-11-26: wsfulton
            [C#] #1628 'out' or 'ref' used in a cstype typemap was not always stripped out in parts
            of director code generation.

2019-11-01: wsfulton
            [Python] #1595 Fix bug in support for keyword arguments (kwargs feature or -keyword)
            when using -builtin. The fix is in the argument error checking when wrapping zero
            argument constructors only.

Version 4.0.1 (21 Aug 2019)
===========================

2019-08-20: TekuConcept
            [Javascript] #1535 Add %native support to Javascript.

2019-08-20: bkotzz
            [Java] #1616 Add SWIG_JavaIllegalStateException to support throwing
            java.lang.IllegalStateException from JNI code.

2019-08-19: sjml
            [Lua] #1596 tostring output changes to show the underlying C/C++ pointer.

2019-08-08: rokups
            [C#, Java] #1601 Fix invalid code generated for "%constant enum EnumType.

2019-08-07: wsfulton
            [Python] Fix method overloading of methods that take STL containers of different
            types. The following usage (using std::vector) would fail when using -builtin:

              %include <std_string.i>
              %include <std_vector.i>

              %inline %{
              struct X {};
              %}

              %template(VectorX) std::vector<X>;
              %template(VectorInt) std::vector<int>;

              %inline %{
              using namespace std;
              string VectorOverload(vector<X> v);
              string VectorOverload(vector<int> v);
              %}

            The following would incorrectly fail:

              s = VectorOverload([1, 2, 3])

            With:

              Traceback (most recent call last):
                File "runme3.py", line 20, in <module>
                  ret = VectorOverload([1, 2, 3])
              TypeError: Wrong number or type of arguments for overloaded function 'VectorOverload'.
                Possible C/C++ prototypes are:
                  VectorOverload(std::vector< Number,std::allocator< Number > >)
                  VectorOverload(std::vector< int,std::allocator< int > >)

            The problem was due to some error handling that was not cleared during typechecking.
            In this case an error was not cleared when the elements in the list failed the
            typecheck for converting to X. Only occurs in Python 3+.

            In some combinations of overloaded methods, the following type of error message would
            occur:

              RuntimeError: in sequence element 0

              The above exception was the direct cause of the following exception:

              Traceback (most recent call last):
                File "runme3.py", line 23, in <module>
                  check(VectorOverload(v), "vector<X>")
              SystemError: <built-in function VectorOverload> returned a result with an error set

2019-08-01: wsfulton
            #1602 Fix regression in 4.0.0 where a template function containing a parameter
            with the same name as the function name led to the parameter name used in the
            target language being incorrectly modified.

2019-07-29: wsfulton
            Remove all generated files on error. Previously generated files were not removed,
            potentially breaking Makefiles using file dependencies, especially when -Werror
            (warnings as errors) was used.

2019-07-23: smithx
            [C#] #1530 #1532 Fix marshalling of std::wstring to C#.

2019-07-18: gicmo
            [Python] #1587 Python 3.8 support - remove use of deprecated PyObject_GC_UnTrack.

2019-07-18: cher-nov
            [Python] #1573 Generated Python code uses consistent string quoting style - double
            quotes.

2019-07-16: geefr
            [C#] #616 #1576 Fix C# bool INPUT[], bool OUTPUT[], bool INOUT[] typemaps to marshall
            as 1-byte.

2019-07-12: vadz
            [C#, Java] #1568 #1583 Fix std::set<> typemaps for primitive types.

2019-07-12: vadz
            #1566 #1584 Regression in 4.0.0 - fix missing value for first item of enums with
            trailing comma.

2019-07-11: mcfarljm
            #1548 #1578 Fix segfault in Doxygen parser parsing empty lines in some commands like
            \code.

2019-07-09: IsaacPascual
            [C#, Java] #1570 Fix name of generated C#/Java classes for %interface macros
            in swiginterface.i when wrapping nested C++ classes.

2019-07-05: wsfulton
            [Python] #1547 Whitespace fixes in Doxygen translated comments into pydoc comments
            for Sphinx compatibility.

2019-06-28: wsfulton
            [MzScheme, OCaml] #1559 $arg and $input were incorrectly substituted in the
            argout typemap when two or more arguments were present.

2019-06-24: wsfulton
            [Python, Ruby] #1538 Remove the UnknownExceptionHandler class in order to be
            C++17 compliant as it uses std::unexpected_handler which was removed in C++17.
            This class was intended for director exception handling but was never used by
            SWIG and was never documented.

            *** POTENTIAL INCOMPATIBILITY ***

2019-06-06: bkotzz
            [Java] #1552 Improve performance in Java std::vector constructor wrapper that takes
            a native Java array as input.

2019-06-03: olly
	    [Python] Fix regression in implicit_conv handling of tuples,
	    introduced in SWIG 4.0.0.  Fixes #1553, reported by Alexandre
	    Duret-Lutz.

2019-05-24: wsfulton
            [Octave] Fix detection of Octave on MacOS.

2019-05-24: opoplawski
            [Octave] #1522 Adapt OCTAVE_LDFLAGS for Octave 5.1.

2019-05-22: ferdynator
	    [PHP] #1528 Don't add a closing '?>' PHP tag to generated files.
	    PSR-2 says it MUST be omitted for files containing only PHP.

Version 4.0.0 (27 Apr 2019)
===========================

2019-04-24: vadz
            #1517 Fix crash if "@return" Doxygen tag was used on a node without any return type.

2019-04-24: vadz
            #1515 Fix parsing of enums with trailing comma when using -doxygen.

2019-04-19: ianlancetaylor
            [Go] #1055 When generating Go code, make -cgo the default. Add new -no-cgo option
            to disable the default.

2019-04-19: pbecherer
            [Tcl] #1508 Fix Visual Studio 2015 and later compilation errors due to snprintf macro
            definition.

2019-04-09: wsfulton
            [C#] Fix FxCop warning CA2002 in SWIGPendingException - a lock on a reference of
            type 'Type'.

2019-03-30: wsfulton
            [Java, D] Add the parameters typemap attribute to the javadestruct,
            javadestruct_derived, ddispose, ddispose_derived typemaps to mirror enhanced
            flexibility in the csdisposing and csdisposing_derived (C#) typemaps. If provided
            the contents are generated as the delete/dispose method's parameters declaration.

2019-03-30: wsfulton
            [C#] #421 Fix FxCop warning CA1063 by implementing the recommended Dispose methods for
            the IDisposable interface. Previously just the Dispose() method was generated.
            Now the Dispose() and Dispose(bool disposing) methods are generated.
            Changes are required if custom "csfinalize", "csdestruct" or "csdestruct_derived"
            typemaps are being used. Details in #421 on Github. SWIG will error out if one of
            the "csfinalize, "csdestruct" or "csdestruct_derived" typemaps are found. Example
            error message:

              foo.h:60: Error: A deprecated csfinalize typemap was found for Foo, please remove
              it and replace all csdestruct, csdestruct_derived and csfinalize typemaps by the
              csdispose, csdispose_derived, csdisposing and csdisposing_derived typemaps.

            *** POTENTIAL INCOMPATIBILITY ***

2019-03-25: Liryna
            [C#] #1143 Add std_list.i for std::list support.
            The C# std::list<T> wrappers are made to look and feel like a C#
            System.Collections.Generic.LinkedList<> collection.
            The IEnumerable<> interface is implemented in the proxy class.
            The ICollection<> interface can also be implemented to provide enhanced functionality
            whenever a C++ operator== is available. This is the case for when T is a
            primitive type or a pointer. If T does define an operator==, then use the
            SWIG_STD_LIST_ENHANCED macro to obtain this enhanced functionality, for example:

              SWIG_STD_LIST_ENHANCED(SomeNamespace::Klass)
              %template(ListKlass) std::list<SomeNamespace::Klass>;

2019-03-18: richardbeare
            [R] #1328 Non-trivial enums are working now. The enum values are now obtained from
            the C/C++ layer. const reference enums and C++11 enum classes are also now working.

2019-03-14: mochizk
            [Javascript] #1500 Fix compilation errors due to deprecating V8 API in Node.js.
            New V8 API is used if node.js >= v10.12, or if V8 >= v7.0.

2019-03-12: vadz
            [C#] #1495 Add std_set.i for std::set support.

2019-03-11: dirteat,opoplawski
            [Octave] Fix compilation errors in Octave 5.1.

              error: format not a string literal and no format arguments [-Werror=format-security]

2019-02-28: wsfulton
            [Java] std::vector improvements for types that do not have a default constructor.

            The std::vector wrappers have been changed to work by default for elements that are
            not default insertable, i.e. have no default constructor. This has been achieved by
            not wrapping:

              vector(size_type n);

            Previously the above had to be ignored via %ignore.

            If the above constructor is still required it can be added back in again via %extend:

              %extend std::vector {
                vector(size_type count) { return new std::vector< T >(count); }
              }

            Alternatively, the following wrapped constructor could be used as it provides near-enough
            equivalent functionality:

              vector(jint count, const value_type& value);

            *** POTENTIAL INCOMPATIBILITY ***

2019-02-25: wsfulton
            [Python] Fix compile errors wrapping overloaded functions/constructors where a vararg
            function is declared after a non-vararg function.

2019-02-23: zphensley42
            Use fully qualified name 'java.lang.Object' instead of 'Object' in generated code to
            avoid clashes with wrapped C++ classes called 'Object'.

2019-02-23: gtbX
            [Java] #1035 Add (const char *STRING, size_t LENGTH) typemaps in addition to the non-const
            typemaps (char *STRING, size_t LENGTH) which does not attempt to write back to the const
            string.

2019-02-22: tamuratak
            [Ruby] #984 Add support for RTypedData introduced in Ruby 1.9.3.

2019-02-22: ZackerySpytz
            #1483 Fix compilation failures when a director class has final methods.

2019-02-21: wsfulton
            [Java] #1240 Suppress Java 9 deprecation warnings on finalize method.

2019-02-21: ZackerySpytz
            #1480 Fix some rejections of valid floating-point literals.

2019-02-19: wsfulton
            #1475 Fix regression parsing gcc preprocessor linemarkers in the form:

            # linenum filename flags

2019-02-18: jakecobb
            [Python] #945 #1234 Elements in std::vector memory access fix.

            Accessing an element in a std::vector obtains a reference to the element via an
            iterator pointing to the element in the container. If the vector is garbage collected,
            the SWIG wrapper containing the pointer to the element becomes invalid. The fix is
            to obtain a back-reference to the container by the wrapper to the element in the Python
            layer to prevent the garbage collector from destroying the underlying container.

2019-02-17: wsfulton
            Fix typemap matching to expand template parameters when the name contains
            template parameters. In the %typemap below the type is T and the name is X<T>::make
            and the name now expands correctly to X< int >::make

              template<typename T> struct X {
                %typemap(out) T X<T>::make "..."
                T make();
              };

              %template(Xint) X<int>;

2019-02-16: wsfulton
            Fix parser error containing multiple #define statements inside an enum.

            The second #define fails to parse:

              enum FooEnum {
                ENUM1 = 0,
                ENUM2 = 1,

              #define MACRO_DEF1 "Hello"
              #define MACRO_DEF2 "World!"

                ENUM3 = 2,
                ENUM4 = 3,
              };

            Bug mentioned at https://sourceforge.net/p/swig/patches/333/

2019-02-14: wsfulton
            Add some missing copy constructors into STL containers.

2019-02-14: bkotzz
            [Java] #1356 Add STL containers:
              std::unordered_map
              std::unordered_set
              std::set

2019-02-14: bkotzz
            [Java] #1356 std::map wrappers have been modified. Now the Java proxy class
            extends java.util.AbstractMap. The std::map container looks and feels much like
            a java.util.HashMap from Java.

            A few members have changed their names. If the old method signatures are needed,
            then copy std_map.i from swig-3.0.12 and use that instead. Alternatively,
            add the old missing methods to the new methods by using the following %proxycode:

              %extend std::map {
              %proxycode %{
                // Old API
                public boolean empty() {
                  return isEmpty();
                }
                public void set($typemap(jboxtype, K) key, $typemap(jboxtype, T) x) {
                  put(key, x);
                }
                public void del($typemap(jboxtype, K) key) {
                  remove(key);
                }
                public boolean has_key($typemap(jboxtype, K) key) {
                  return containsKey(key);
                }
              %}
              }

            *** POTENTIAL INCOMPATIBILITY ***

2019-02-13: ZackerySpytz
            #1469 Add support for C++17 hexadecimal floating literals.

2019-02-11: wsfulton
            [OCaml] #1437 OCaml has been give the 'Experimental' language status. The examples work
            and most of the test-suite is also working, so it is quite close to being a 'Supported' language.

2019-02-10: ZackerySpytz
	    #1464 Add support for C++14 binary integer literals.

2019-02-10: ZackerySpytz
	    #1450 Add support for C++11 UCS-2 and UCS-4 character literals. Also, add support for
            C++17 UTF-8 character literals.

2019-02-10: wsfulton
	    [MzScheme] #1437 MzScheme/Racket is now an 'Experimental' language. The examples work
            and a large portion of the test-suite is also working.

2019-02-10: wsfulton
	    [MzScheme] Destructor wrappers were not being generated.

2019-02-10: wsfulton
	    [MzScheme] Static variable wrappers fixed - $argnum was not expanded.

2019-02-10: sethrj
	    #1452 Fix %apply for anonymous template instantiations

2019-02-09: olly
	    [PHP] Fix access to already released memory during PHP module
	    shutdown, which often didn't cause visible problems, but could
	    result in segmentation faults, bus errors, etc.  Fixes #1170,
	    reported by Jitka Plesníková.

2019-02-09: olly
	    [PHP] A renamed constructor is now wrapped as a static method in
	    PHP.

2019-02-08: olly
	    [PHP] Don't generate code which references $r when $r hasn't been
	    defined.  This could happen in overloaded methods which returned
	    void and took at least one const std::string& parameter.

2019-02-08: olly
	    [PHP] The generated code is now compatible with PHP 7.3, and the
	    testsuite now runs cleanly with this version too.

2019-02-05: wsfulton
            #1437 SWIG now classifies the status of target languages into either 'Experimental' or
            'Supported'. This status is provided to indicate the level of maturity to expect when using
            a particular target language as not all target languages are fully developed. Details are
            in the Introduction.html chapter of the documentation.

2019-02-04: wsfulton
	    [CFFI] #1447 Common Lisp CFFI has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-04: wsfulton
	    [Allegrocl] #1447 Allegro Common Lisp has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-04: wsfulton
	    [Chicken] #1447 CHICKEN has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-04: wsfulton
	    [CLISP] #1447 GNU Common Lisp has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-04: wsfulton
	    [S-EXP] #1447 Common Lisp S-Exp has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-04: wsfulton
	    [UFFI] #1447 Common Lisp UFFI has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-04: wsfulton
	    [Pike] #1447 Pike has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-04: wsfulton
	    [Modula3] #1447 Modula3 has been disabled as a target language in SWIG as part of a
            clean up to remove target languages that have been neglected/not functional.

2019-02-02: ahnolds
	    [Python] Documentation enhancements for Python:

            #728 Fixed the handling of autodoc when using -fastproxy.

            #1367 Added documentation to wrapped member variables using the
            property(... doc="...") construct.

            Only show a single documentation entry for functions with default arguments when
            using autodoc.

            Fixed a bug where a cached doxygen docstring could be deleted while still in use,
            causing swig to segfault.

2019-01-31: olly
	    SWIG now requires a target language to be specified instead of
	    defaulting to wrapping for Tcl.  Specifying swig --help without
	    a target language now just shows the generic help.  The -nolang
	    option has been removed.

2019-01-28: ZackerySpytz
            [OCaml] #1429 Remove support for OCaml versions < 3.12.0.

            *** POTENTIAL INCOMPATIBILITY ***

2019-01-22: vadz
            [Ruby, Octave] #1424 Improve autodoc parameter naming.

2019-01-22: vadz
            [Python] #1271 #1423 Always include default parameter values in autodoc strings.

2019-01-19: vadz
            #1272, #1421 When a function's parameter is a keyword, the name of the paramater is
            no longer simply changed to argN, where N is the argument number. Instead the
            parameter name is changed to the renaming rules for keywords that normally apply to
            symbols such as classes/functions etc. Note that unlike other symbol renaming,
            parameter renaming does not issue a warning when the parameter is renamed. This
            change only affects languages where the parameter names are actually used, for example,
            Java function parameter lists in the proxy class or Python documentation comments.

2019-01-18: wsfulton
            #1420 Fix gdb debugger functions 'swigprint' and 'locswigprint' from swig.gdb to
            work with newer versions of gdb-8. Fixes errors when debugging SWIG source with gdb:

              (gdb) swigprint n
              Undefined command: "Printf".  Try "help".

2019-01-16: wsfulton
            Python static method wrapper changes

            - Static method wrappers were using the 'fastproxy' approach by default.
              This is inconsistent with instance method wrappers. The fastproxy approach
              is now turned off by default to be consistent with instance methods.
              Static method wrappers can now also be controlled using the -fastproxy and
              -olddefs options.

              Example:

                struct Klass {
                  static int statmethod(int a = 2);
                };

              generates by default:

              class Klass(object):
                  ...
                  @staticmethod
                  def statmethod(a=2):
                      return _example.Klass_statmethod(a)

              instead of the following (which can be restored by using -fastproxy):

                class Klass(object):
                  ...
                  statmethod = staticmethod(_example.Klass_statmethod)

              - Modernise wrappers for static methods to use decorator syntax - @staticmethod.

              - Add missing runtime test for static class methods and using the actual class method.

2019-01-12: ZackerySpytz
            [OCaml] #1403 #1194 Fix compilation problems for OCaml >= 4.03.0 due to OCaml using
            int64_t instead of int64.

2019-01-11: ZackerySpytz
            [OCaml] #1400 Fix the getters and setters of non-static member variables.

2019-01-07: wsfulton
            #358 Add VOID to windows.i

2019-01-05: wsfulton
            #948 #1019 #1273 Fix for C++11 raw strings where the delimiters were mistakenly left
            in the string contents in situations where the string was copied into generated code.
            For example, %constant, the "docstring" feature and for C#/Java/D constants turned on
            with %javaconst/%csconst/%dmanifestconst.

2019-01-05: wsfulton
            [Ruby] #538. Fix Ruby support for %feature("docstring").

2019-01-03: wsfulton
            #1202 Fix overloading of non-pointer class types in scripting languages when overloaded
            with a pointer and a NULL scripting language equivalent is used, eg None in Python.

            The implementation changes the SWIGTYPE, SWIGTYPE& and SWIGTYPE&& typecheck typemaps to
            prevent accepting a conversion to a NULL pointer.

2019-01-03: ZackerySpytz
            [OCaml] #1386 Fix the OCaml examples and test suite for out-of-source builds.

2019-01-01: wsfulton
            [Python] #639 remove duplicate proxy method definitions for global function wrappers.

            Global functions previously generated two definitions, eg:

              def foo():
                  return _example.foo()
              foo = _example.foo

            The first definition is replaced by the second definition and so the second definition
            is the one used when the method is actually called. Now just the first definition is
            generated by default and if the -fastproxy command line option is used, just the second
            definition is generated. The second definition is faster as it avoids the proxy Python
            method as it calls the low-level C wrapper directly. Using both -fastproxy and -olddefs
            command line options will restore the previously generated code as it will generate both
            method definitions.

            With this change, the wrappers for global C/C++ functions and C++ class methods now work
            in the same way wrt to generating just a proxy method by default and control via
            -fastproxy/-olddefs options.

2018-12-20: hasinoff,wsfulton
            [Java] #1334 Set Java thread name to native thread name when using directors.

            Default is to use name "Thread-XXX" and is still works like this by default. However,
            adding the following will turn on the thread name setting (works for more recent
            versions of Linux and MacOS):

            %begin %{
            #define SWIG_JAVA_USE_THREAD_NAME
            %}

2018-12-20: chlandsi
            [Python] #1357. Fix overriding __new__ in Python 3.6.

            Fixes SystemError: Objects/tupleobject.c:81: bad argument to internal function"

2018-12-16: wsfulton
            [Python] #848 #1343 The module import logic has changed to stop obfuscating real ImportError
            problems. Only one import of the low-level C/C++ module from the pure Python module is
            attempted now. Previously a second import of the low-level C/C++ module was attempted
            after an ImportError occurred and was done to support 'split modules'. A 'split module' is
            a configuration where the pure Python module is a module within a Python package and the
            low-level C/C++ module is a global Python module. Now a 'split module' configuration is
            no longer supported by default. This configuration can be supported with a simple
            customization, such as:

              %module(package="mypackage", moduleimport="import $module") foo

            or if using -builtin:

              %module(package="mypackage", moduleimport="from $module import *") foo

            instead of

              %module(package="mypackage") foo

            See the updated Python chapter titled "Location of modules" in the documentation.

2018-12-11: tlby
            [Perl] #1374 repair EXTEND() handling in typemaps

2018-12-06: vadz
            #1359 #1364 Add missing nested class destructor wrapper when the nested class is
            inside a template. Removes associated bogus 'Illegal destructor name' warning. Only
            occurred when the nested class' destructor is explicitly specified.

2018-12-04: adr26
            [Python] #1368 #1369 Access Violation in tp_print caused by mismatched Python/extension
            CRT usage

            Remove all use of tp_print, as this API uses a FILE*, which can be
            mismatched when modules are built with different C libraries from
            the main python executable.

            This change also brings consistent output between Python 2 and 3 for the 'cvar' SWIG
            object (that contains the global variables) and SWIG packed objects (such as callback
            constants).

2018-12-04: wsfulton
            [Python] #1282 Fix running 'python -m'  when using 'swig -builtin'

            Similar to the earlier PEP 366 conforming fix for non-builtin.

2018-11-29: adr26
            [Python] #1360 Leak of SWIG var link object

            Fix reference counting on _SWIG_globals to allow var link to be freed on module unload.

2018-11-28: wsfulton
            [Python] When using -builtin, the two step C-extension module import is now
            one step and the wrapped API is only available once and not in an underlying
            module attribute like it is without -builtin. To understand this, consider a
            module named 'example' (using: %module example). The C-extension is compiled into
            a Python module called '_example' and a pure Python module provides the actual
            API from the module called 'example'. It was previously possible to additionally
            access the API from the module attribute 'example._example'. The latter was an
            implementation detail and is no longer available. It shouldn't have been used, but
            if necessary it can be resurrected using the moduleimport attribute described in the
            Python chapter of the documentation. If both modules are provided in a Python
            package, try:

              %module(moduleimport="from . import _example\nfrom ._example import *") example
            or more generically:
              %module(moduleimport="from . import $module\nfrom .$module import *") example

            and if both are provided as global modules, try:

              %module(moduleimport="import _example\nfrom _example import *") example
            or more generically:
              %module(moduleimport="import $module\nfrom $module import *") example

            The module import code shown will appear in the example.py file.

2018-11-24: vadz
            #1358 Fix handling of abstract base classes nested inside templates

            Correct detecting of whether a derived class method overrides a pure virtual
            base class method when both classes are nested inside a template class: this
            notably didn't work correctly for methods taking parameters of the base class
            type.

2018-11-22: rupertnash
            [Python] #1282 Make generated module runnable via python -m (PEP 366 conforming)

            Previously any SWIG generated modules in a package would fail with an ImportError
            when using 'python -m' for example 'python -m mypkg.mymodule'.

            This fix also allows the SWIG generated module to be placed into a directory and
            then renamed __init__.py to convert the module into a package again. This ability
            stopped working in swig-3.0.9. However, only Python 2.7 or 3.3 and later work. If
            Python 3.2 support is needed, use moduleimport in %module to customise the import
            code.

2018-11-13: wsfulton
            #1340 Remove -cppcast and -nocppcast command line options (this was an option
            available to the scripting language targets).

            The -cppcast option is still turned on by default. The -nocppcast option
            to turn off the use of c++ casts (const_cast, static_cast etc) has been
            removed. However, defining SWIG_NO_CPLUSPLUS_CAST will still generate C casts
            instead of C++ casts for C++ wrappers.

            *** POTENTIAL INCOMPATIBILITY ***

2018-11-13: wsfulton
            [Python] #1340 Remove -outputtuple and -nooutputtuple command line options.

            Both the command line and %module options of the same name have been
            removed. These were undocumented. The -outputtuple option returned a
            Python tuple instead of a list, mostly typically in the OUTPUT
            typemap implementations.

            It unclear why a tuple instead of a list return type is needed and
            hence this option has been removed as part of the simplification of
            the SWIG Python command line options for SWIG 4.

2018-11-13: wsfulton
            [Python] #1340 Remove -noproxyimport command line option.

            This option turned off the insertion of Python import statements
            derived from a %import directive. For example given:

              %module module_b
              %import "module_a.i"

            then module_b.py will contain:

              import module_a

            *** POTENTIAL INCOMPATIBILITY ***

2018-10-29: AlexanderGabriel
	    [PHP] The following PHP7 reserved keywords are now only renamed by
	    SWIG when used as function names in the API being wrapper:
	    __halt_compiler array die echo empty eval exit include include_once
	    isset list print require require_once return unset

2018-10-22: olly,wsfulton
            [Python] #1261 #1340 Turn on many optimisation options by default and rationalise the
            number of command line options.

            There were an unnecessary number of command line options and many of these have now
            been removed in a drive for simplification. Some were needed to support older versions
            of Python (2.6 and earlier).

            Many of the options could be turned on individually and when using -O. Previously -O
            resulted in turning on a set of options:

              -modern -fastdispatch -nosafecstrings -fvirtual -noproxydel
              -fastproxy -fastinit -fastunpack -fastquery -modernargs -nobuildnone

            Now -O results in turning on this reduced set:

              -fastdispatch -fastproxy -fvirtual

            The following options are now on by default, a deprecated warning is displayed if they
            are used:
              -fastinit     Class initialisation code done in C/C++ rather than in Python code.
              -fastquery    Python dictionary used for lookup of types.
              -fastunpack   Faster unpacking of function arguments in C/C++ wrappers.
              -modern       Use Python 2.3 features such as object and property.
              -modernargs   Use Python 2.3 C APIs for unpacking arguments in tuples.
              -noproxydel   Stop generating a proxy __del__ method for backwards compatibility.
              -safecstrings No discernable difference

            The following options have been removed altogether:
              -aliasobj0
              -buildnone
              -classptr
              -new_repr
              -newrepr
              -noaliasobj0
              -nobuildnone
              -nocastmode
              -nodirvtable
              -noextranative
              -nofastinit
              -nofastproxy
              -nofastquery
              -nomodern
              -nomodernargs
              -nooutputtuple
              -nosafecstrings
              -old_repr
              -oldrepr
              -proxydel

            -new_vwm is no longer supported. Use the -newvwm alias instead.

            *** POTENTIAL INCOMPATIBILITY ***

2018-10-22: olly
            [Python] #1261 Remove command line option no longer needed as Python 2.3 and earlier
            are no longer supported:

              -classic

2018-10-09: wsfulton
            [D, Go, Guile, Lua, Mzscheme, Ocaml, Perl5, Php, Scilab, Tcl]
            Allow wrapping of std::map using non-default comparison function.

2018-10-09: vadz
            [Java] #1274 Allow wrapping of std::map using non-default comparison function.

2018-10-04: wsfulton
            [Python] #1126 Fix C default arguments with -builtin and -fastunpack and -modernargs.
            Problem occurred when there is just one (defaulted) parameter in the parameter list.

2018-09-24: wsfulton
            [Python] #1319 C++11 hash tables implementation is finished now (including for -builtin):
              std::unordered_map
              std::unordered_set
              std::unordered_multimap
              std::unordered_multiset

2018-09-21: wsfulton
            [Python] Fix when using -builtin and wrapping std::map, std::set, std::unordered_map or
            std::unordered_set to ensure __contains__ is called. This is a wrapper for the STL
            container's find method. Without it, Python will do its own slower sequence search.

2018-09-19: wsfulton
            [Python] Fix functors (wrapped as __call__) when using -builtin -modern -fastunpack.

2018-09-02: andreas.gaeer,tkrasnukha
            [Python] #1321 Fix assert in PyTuple_GET_SIZE in debug interpreter builds of python-3.7
            when calling tp_new.

2018-09-01: ChristopherHogan
            [Guile] #1288 Fix garbage collection for guile >= 2.0.12.

2018-08-31: wsfulton
            [Python] #1319 C++11 hash tables support:
              std::unordered_map
              std::unordered_set
              std::unordered_multimap
              std::unordered_multiset
            is now compiling and working (sorting using -builtin not fully functional yet though).

2018-08-20: wkalinin
            #1305 Fix nested structure symbol tables in C mode to fix member name conflicts
            in different structs with the same nested struct member name.

2018-08-18: wsfulton
            [Python] #688 Fix makefile recursion when running python test-suite.

2018-08-18: wsfulton
            [Python] #1310 Re-implement Python -fastproxy option.

            The previous implementation failed with Python 3 and abstract base clases.
            The new implementation replaces the Python 2 implementation using
            new.instancemethod with the C API PyMethod_New to match the equivalent Python 3
            implementation which uses PyInstanceMethod_New.

            The new approach runs slightly faster. See #1310.

2018-08-12: gmazzamuto
            [Python] #1283 Update pybuffer.i library to use new-style Python buffer C API.

2018-08-12: brianhatwood,wsfulton
            [Java] #1303 #1304 Fix crash in directors when using OUTPUT and INOUT typemaps in typemaps.i and
            passing NULL pointers in C++ to director method overloaded and implemented in Java.

2018-08-10: wsfulton
            [Python] #1293 Improve TypeError message inconsistencies between default and fastdispatch
            mode when handling overloaded C++ functions. Previously the error message did not always
            display the possible C/C++ prototypes in fastdispatch mode.

2018-08-02: furylynx,jacobwgillespie,p2k
            [Javascript] #1290, #968. Add support for NodeJS versions 2-10.

2018-07-31: wsfulton
            [Python] #1293 Overloaded C++ function wrappers now raise a TypeError instead
            of NotImplementedError when the types passed are incorrect. This change means
            there is now consistency with non-overloaded function wrappers which have always
            raised TypeError when the incorrect types are passed. The error message remains
            the same and is for example now:

              TypeError: Wrong number or type of arguments for overloaded function 'f'.
                Possible C/C++ prototypes are:
                  f(int)
                  f(char const *)

            instead of:

              NotImplementedError: Wrong number or type of arguments for overloaded function 'f'.
                Possible C/C++ prototypes are:
                  f(int)
                  f(char const *)

            *** POTENTIAL INCOMPATIBILITY ***

2018-06-23: wsfulton
            [Python] #718 Fix pythonnondynamic feature for modern classes

            Fixes nondynamic mode when an instance variable is set with the same
            name as a class variable in a class derived from a SWIG proxy class.
            This corner case set an instance variable instead of raising an AttributeError.

            Also fix %pythonnondynamic in Python 3 with -modern. The metaclass
            containing the implementation was previously not being applied in Python 3.

2018-07-17: petrmitrichev,wsfulton
            [Python] #1275 #1279 Initialize function-local statics (singletons) that call Python
            code during Python module initialization in order to avoid deadlocks with subsequent
            multi-threaded usage.

2018-06-15: wsfulton
            [Python] Fix seg fault using Python 2 when passing a Python string, containing
            invalid utf-8 content, to a wstring or wchar * parameter. A TypeError is thrown instead, eg:

              %include <std_wstring.i>
              void instring(const std::wstring& s);

              instring(b"h\xe9llooo") # Python

2018-06-15: wsfulton
            [Python] Python 3.7 support: Replace use of deprecated PyUnicode_GetSize with
            PyUnicode_GetLength to remove deprecated warnings compiling the C/C++ wrappers.

2018-06-12: wsfulton
            [Python] Python 3.7 support: The %pythonabc feature in pyabc.i now uses base classes
              collections.abc.MutableSequence
              collections.abc.MutableMapping
              collections.abc.MutableSet
            instead of
              collections.MutableSequence
              collections.MutableMapping
              collections.MutableSet
            as the latter are deprecated in Python 3.7 and are due to be removed in Python 3.8.
            The classes in collections.abc.* are available from Python 3.3 onwards. If you
            require support for Python 3.2, then copy the pyabc.i file and modify by removing
            the few instances of the .abc sub-module.

            *** POTENTIAL INCOMPATIBILITY ***

2018-06-12: olly,wsfulton
            [Python] #701 Remove support for Python versions < 2.7 and 3.0 and 3.1.

            *** POTENTIAL INCOMPATIBILITY ***

2018-06-11: olly
            [Python] Fix new GCC8 warnings in generated code by avoiding casts
            between incompatible function types where possible, and by
            suppressing the warning when it's due to the design of Python's C
            API.  Fixes #1259.

2018-06-08: philippkraft
	    [Python] Stop exposing <CLASS>_swigregister to Python.  It's not
	    useful for user Python code to call this, and it just clutters the
	    API unnecessarily.  Fixes #1225.

2018-06-07: cmfoil, kabbi, Jamie Kirkpatrick, markok314, vadz, wsfulton, Yann Diorcet
            #170 Doxygen documentation support added. This allows translation of Doxygen comments
            into JavaDoc and PyDoc documentation. It is enabled via the -doxygen command line
            option. See the Doxygen.html chapter in the documentation for further information.

2018-06-07: olly
	    [PHP] We've finally removed support for %pragma(php4) which was
	    deprecated back in 2008.  Use %pragma(php) instead, which has been
	    supported since at least 2005.

            *** POTENTIAL INCOMPATIBILITY ***

2018-06-07: olly
	    [PHP5] Support for PHP5 has been removed.  PHP5 is no longer
	    actively supported by the PHP developers and security support for
	    it ends completely at the end of 2018, so it doesn't make sense
	    to include support for it in the upcoming SWIG 4.0.0 release.

            *** POTENTIAL INCOMPATIBILITY ***

2018-06-06: olly
	    [Lua] Improve configure probes for Lua headers and libs used in testsuite.

2018-05-15: kwwette
            [Octave] add support for version 4.4
            - Should not introduce any user-visible incompatibilities

2018-05-15: wsfulton
            [C#, D, Java] Fix lookup of csconstruct, dconstruct and javaconstruct typemaps.
            The C++ namespace was previously ignored when looking up the typemap.

2018-05-15: wsfulton
            [Javascript] Fix generated C++ code when using %nspace on namespaces that are more
            than two levels deep.

2018-05-14: wsfulton
            Issue #1251 Add support for C++17 nested namespace definitions,
            for example:
              namespace A::B { ... }

2018-05-11: wsfulton
            [C#, D, Java] Add support so that the %csmethodmodifiers, %dmethodmodifiers,
            %javamethodmodifiers can modify the method modifiers for the destructor wrappers
            in the proxy class: dispose, Dispose, delete. With this feature, it is now possible
            to make a C# proxy class sealed, eg when wrapping a class X, the virtual method modifiers
            can be removed using:

              %typemap(csclassmodifiers) X "public sealed class"
              %csmethodmodifiers X::~X "public /*virtual*/";

2018-04-18: olly
	    [Python] Suppress new pycodestyle warning:
	    E252 missing whitespace around parameter equals

2018-04-07: goatshriek
            [Ruby] #1213 Fix ruby %alias directive for global C/C++ functions.

2018-04-03: olly
	    [Ruby] Fix to pass Qnil instead of NULL to rb_funcall(), which silences GCC
	    -Wconversion-null warning (on by default with recent GCC).

2018-03-09: wsfulton
            [Java] #1184 Fix swigReleaseOwnership() and swigTakeOwnership() regression
            for non-director classes. Restores a dynamic_cast which was previously removed.

2018-03-07: llongi
	    Github PR #1166 - Fix preprocessor handling of macros with commas
	    in a // comment.

2018-02-18: JPEWdev
            Patch #1164 - Add support for a command-line options file, also sometimes
            called a response file. This is useful if the command-line options exceed
            the system command-line length limit. To use, put the command-line options
            into a file, then provide the file name prefixed with @, for example using
            a file called args.txt:

              swig @args.txt

2018-02-11: wsfulton
            [Javascript] #1187 Fix compilation error wrapping std::complex via
            std_complex.i.

2018-01-30: smarchetto
            [Scilab] add type name argument in SWIG_ptr() function to cast from pointer address to typed pointers

2018-01-16: wsfulton
            Expressions following a preprocessor directive must now be separated by whitespace
            or non-numeric characters. This syntax change makes the SWIG preprocessor work like
            the C preprocessor in this area.

            For example, the following code used be accepted as valid syntax:
              #if1
              #define ABC 123
              #endif

            Now you get an error:
              example.h:1: Error: Unknown SWIG preprocessor directive: if1 (if this is a block of
              target language code, delimit it with %{ and %})
              example.h:3: Error: Extraneous #endif.

            The following is the correct syntax:
              #if 1
              #define ABC 123
              #endif

            The following of course also works:
              #if(1)
              #define ABC 123
              #endif

            *** POTENTIAL INCOMPATIBILITY ***

2018-01-15: wsfulton
            Fix issue #1183. Floating point exception evaluating preprocessor expressions
            resulting in division by zero.

2018-01-14: wsfulton
            Fix issue #1172. Seg fault parsing invalid exponents in the preprocessor.

2018-01-12: Liryna
            [C#] Patch #1128. Add ToArray function to std::vector wrappers.

2018-01-12: wsfulton
            [Java] Fix issue #1156. Add missing throws clause for interfaces when using the
            %interface family of macros.

2018-01-05: wsfulton
            Fix default arguments using expressions containing -> syntax error. Problem reported on
            swig-user mailing list.

2017-12-30: wsfulton
            [Python] Replace pep8 with pycodestyle for checking the Python code style when
            running Python tests.

2017-12-30: davedissian
            Fixed a symbol lookup issue when encountering a typedef of a symbol from the tag
            namespace to the global namespace when the names are identical, such as 'typedef
            struct Foo Foo;'.

2017-12-13: wsfulton
            [Perl] add missing support for directorfree typemaps.

2017-12-13: wsfulton
            Issue #1167 Fix directorout typemaps which were causing undefined behaviour when
            returning pointers by reference.

2017-12-08: olly
	    [PHP] Use ZEND_MODULE_GLOBALS_ACCESSOR to access globals so the
	    generated code builds when PHP was built with ZTS enabled.

2017-12-04: wsfulton
            [Python] Add missing checks for failures in calls to PyUnicode_AsUTF8String. Previously a
            seg fault could occur when passing invalid UTF8 strings (low surrogates), eg passing
            u"\udcff" to the C layer (Python 3).

2017-11-24: joequant
	    [R] Fix #1124 and return R_NilValue for null pointers

2017-11-29: wsfulton
            [Java] director exception handling improvements.

            When a director method throws an exception and it is caught by DirectorException
            and passed back to Java using Swig::DirectorException::throwException, the Java
            stack trace now contains the original source line that threw the exception.

            Deprecate Swig::DirectorException::raiseJavaException, please replace usage with
            Swig::DirectorException::throwException.

            *** POTENTIAL INCOMPATIBILITY ***

2017-10-26: wsfulton
            Add support for C++11 ref-qualifiers when using directors.

2017-10-26: wsfulton
            Fix generated code when using directors and methods returning const ref pointers.

2017-10-26: wsfulton
            [C#, D, Java, Octave, R, Scilab] Port director typemaps to these additional languages.
            Issue #700.

2017-10-26: radarsat1
            [Ruby Python] Patch #1029 - Correct handling of null using directors and shared_ptr.

2017-10-10: joequant
	    [R] pass enum expressions to R.  This will generate
	    incorrect files when there is an arithmetic expression
	    in the enum, but this is better than silently generating
	    incorrect code

2017-10-09: olly
	    [PHP] Fix incorrect wrapper code generated when there's a
	    combination of overloading, parameters with a default value
	    and %newobject.  Fixes https://sourceforge.net/p/swig/bugs/1350/

2017-10-09: olly
	    Remove GCJ support.  It isn't in a good state and doesn't seem to
	    be used, and GCC7 dropped GCJ.  Closes
	    https://sourceforge.net/p/swig/bugs/823/

2017-10-07: olly
	    Fix preprocessor handling of empty macro arguments to match that of
	    C/C++ compilers.  Fixes issue #1111 and
	    https://sourceforge.net/p/swig/bugs/826/

2017-10-06: wsfulton
            [Python] Issue #1108. Fix platform inconsistency in Python default argument handling.
            32 bit and 64 bit compiled versions of SWIG generated different Python files
            when default arguments were outside the range of 32 bit signed integers.
            The default arguments specified in Python are now only those that are in the
            range of a 32 bit signed integer, otherwise the default is obtained from C/C++ code.

2017-10-02: wsfulton
            [C#] Fix std::complex types passed by value.

2017-10-02: wsfulton
            [Javascript, Python, Ruby] Issue #732 - Missing type information for std::complex
            in std_complex.i meant that previously std::complex always had to be fully qualified
            in order to be wrapped with the appropriate typemaps.

2017-10-01: joequant
            allow R package names with docs
	    allowing multiple get accessors in R
	    fix smart-pointer and NAMESPACE support
	    constructors now returning smart pointers (if class
	    declared as such)
	    smart-pointer classes deriving from parent smart-pointers

2017-09-29: wsfulton
            Issue #1100 - Allow an instantiated template to have the same name in the target
            language as the C++ template name, for example, this is now possible:

              template<typename T> struct X { ... };
              %template(X) X<int>;

2017-09-23: wsfulton
            Issue #1098. Fix overloading of shared_ptr with underlying pointer types, eg:

              void m(std::shared_ptr<T> p);
              void m(T &p);
              void m(T *p);

            Only the first method is wrapped and the others are ignored/shadowed.
            The implementation is done via a new attribute in the 'typecheck' typemap called
            'equivalent'. If specified, it must contain the equivalent pointer type for overloading
            and can only be used for the special SWIG_TYPECHECK_POINTER precedence level.
            The shared_ptr 'typecheck' typemaps have been modified accordingly.
            Here is a simplified version:

              %typemap(typecheck, precedence=SWIG_TYPECHECK_POINTER, equivalent="T *")
                T,
                T CONST &,
                T CONST *,
                T *CONST&,
                std::shared_ptr< T >,
                std::shared_ptr< T > &,
                std::shared_ptr< T > *,
                std::shared_ptr< T > *&
                { ... }

            Overloading with any of these types will result in SWIG ignoring all but the first
            overloaded method by default. Without the 'equivalent' attribute, wrapping the overloaded
            methods resulted in types being shadowed (scripting languages) or code that did not
            compile (statically typed languages).

2017-09-19: futatuki
            [Python] #1003 Add --with-2to3=/path/to/2to3 option to configure.

2017-09-18: wsfulton
            Fix type promotion wrapping constant expressions of the form:
              # define EXPR_MIXED1    (0x80 + 11.1) - 1
            This was previously an integral type instead of a floating point type.

2017-09-17: wsfulton
            Fix generated code for constant expressions containing wchar_t L literals such as:
              # define __WCHAR_MAX    (0x7fffffff + L'\0')
              # define __WCHAR_MIN    (-__WCHAR_MAX - 1)

2017-09-10: mlamarre
            [Python] Patch #1083. Define_DEBUG to 1 to do exactly like Visual Studio
            /LDd, /MDd or /MTd compiler options.

2017-08-25: wsfulton
            Issue #1059. Add support for C++11 ref-qualifiers on non-static member functions.
            Members with lvalue ref-qualifiers such as:

              struct RQ {
                void m1(int x) &;
                void m2(int x) const &;
              };

            are wrapped like any other member function. Member functions with rvalue ref-qualifiers
            are ignored by default, such as:

              struct RQ {
                void m3(int x) &&;
                void m4(int x) const &&;
              };

              example.i:7: Warning 405: Method with rvalue ref-qualifier m3(int) && ignored.
              example.i:8: Warning 405: Method with rvalue ref-qualifier m4(int) const && ignored.

            These can be unignored and exposed to the target language, see further documentation in
            CPlusPlus11.html.

2017-08-16: wsfulton
            Fix #1063. Add using declarations to templates into typedef table.

            Using declarations to templates were missing in SWIG's internal typedef tables.
            This led to a few problems, such as, templates that did not instantiate and generated
            C++ code that did not compile as SWIG did not know what scope the template was
            in. This happened mostly when a using declaration was used on a template type in a
            completely unrelated namespace.

2017-08-16: wsfulton
            Fix type lookup in the presence of using directives and using declarations.

            Fix some cases of type lookup failure via a combination of both using directives and
            using declarations resulting in C++ code that did not compile as the generated type was
            not fully qualified for use in the global namespace. Example below:

              namespace Space5 {
                namespace SubSpace5 {
                  namespace SubSubSpace5 {
                    struct F {};
                  }
                }
                using namespace SubSpace5;
                using SubSubSpace5::F;
                void func(SubSubSpace5::F f);
              }

2017-08-16: wsfulton
            Issue #1051. %template scope enforcement and class definition fixes.

            The scoping rules around %template have been specified and enforced.
            The %template directive for a class template is the equivalent to an
            explicit instantiation of a C++ class template. The scope for a valid
            %template instantiation is now the same as the scope required for a
            valid explicit instantiation of a C++ template. A definition of the
            template for the explicit instantiation must be in scope where the
            instantiation is declared and must not be enclosed within a different
            namespace.

            For example, a few %template and C++ explicit instantiations of std::vector
            are shown below:

              // valid
              namespace std {
                %template(vin) vector<int>;
                template class vector<int>;
              }

              // valid
              using namespace std;
              %template(vin) vector<int>;
              template class vector<int>;

              // valid
              using std::vector;
              %template(vin) vector<int>;
              template class vector<int>;

              // ill-formed
              namespace unrelated {
                using std::vector;
                %template(vin) vector<int>;
                template class vector<int>;
              }

              // ill-formed
              namespace unrelated {
                using namespace std;
                %template(vin) vector<int>;
                template class vector<int>;
              }

              // ill-formed
              namespace unrelated {
                namespace std {
                  %template(vin) vector<int>;
                  template class vector<int>;
                }
              }

              // ill-formed
              namespace unrelated {
                %template(vin) std::vector<int>;
                template class std::vector<int>;
              }

            When the scope is incorrect, an error now occurs such as:

              cpp_template_scope.i:34: Error: 'vector' resolves to 'std::vector' and
              was incorrectly instantiated in scope 'unrelated' instead of within scope 'std'.

            Previously SWIG accepted the ill-formed examples above but this led to
            numerous subtle template scope problems especially in the presence of
            using declarations and using directives as well as with %feature and %typemap.

            Actually, a valid instantiation is one which conforms to the C++03
            standard as C++11 made a change to disallow using declarations and
            using directives to find a template.

              // valid C++03, ill-formed C++11
              using std::vector;
              template class vector<int>;

            Similar fixes for defining classes using forward class references have
            also been put in place. For example:

              namespace Space1 {
                struct A;
              }
              namespace Space2 {
                struct Space1::A {
                  void x();
                }
              }

            will now error out with:

              cpp_class_definition.i:5: Error: 'Space1::A' resolves to 'Space1::A' and
              was incorrectly instantiated in scope 'Space2' instead of within scope 'Space1'.

            Previously some symbols would have been instantiated in the wrong scope and led
            to lots of scope problems involving SWIG typemaps, features, renames etc.
            You will need to correct the scope used in other SWIG directives which do not
            support 'using declarations' and 'using directives'. For example, if you previously had:

              %rename(Zap) vector<int>::clear;
              using namespace std;
              %template(VectorInt) vector<int>;

            Prior versions of SWIG incorrectly instantiated vector<int> in the global namespace
            and so the %rename matched. Now the template is instantiated in the correct namespace,
            so is fully qualified as std::vector<int>. The other SWIG directives need correcting as
            they do not follow 'using declarations' and 'using directives'. Change it to:

              %rename(Zap) std::vector<int>::clear;
              using namespace std;
              %template(vin) vector<int>;


            *** POTENTIAL INCOMPATIBILITY ***

2017-08-16: wsfulton
            Fix scope lookup for template parameters containing unary scope operators.

            Fixes cases like:

            namespace Alloc {
              template<typename T> struct Rebind {
                typedef int Integer;
              };
            }
            %template(RebindBucket) Alloc::Rebind< Bucket >;
            OR
            %template(RebindBucket) Alloc::Rebind< ::Bucket >;

            Alloc::Rebind< Bucket >::Integer Bucket1();
            Alloc::Rebind< ::Bucket >::Integer Bucket2();
            Alloc::Rebind<::template TemplateBucket<double>>::Integer Bucket3();

2017-08-16: wsfulton
            For templates only, the template parameters are fully resolved when
            handling typemaps. Without this, it is too hard to have decent rules
            to apply typemaps when parameter types are typedef'd and template
            parameters have default values.

            Fixes %clear for typedefs in templates, eg:

              %typemap("in") XXX<int>::Long "..."
              template typename<T> struct XXX {
                typedef long Long;
              };
              %clear XXX<int>::Long;

            as the typemap was previously incorrectly stored as a typemap for long
            instead of XXX<int>::Long.

2017-08-05: olly
	    [C++11] Allow static_assert at the top level (and disallow it right
	    after template<T>).  Fixes issue 1031 reported by Artem V L.

2017-08-02: wsfulton
            Fix incorrectly shown warning when an empty template instantiation was used on a
            class used as a base class and that base class was explicitly ignored with %ignore.
            Example of the warning which will no longer appear:

              Warning 401: Base class 'Functor< int,int >' has no name as it is an empty
              template instantiated with '%template()'. Ignored.

2017-07-17: fflexo
            [Java] #674 Add std_list.i to add support for std::list containers. The Java proxy
            extends java.util.AbstractSequentialList and makes the C++ std::list container look
            and feel much like a java.util.LinkedList from Java.

2017-07-07: wsfulton
            [Python] Fix display of documented template types when using the autodoc
            feature. For example when wrapping:

              %feature("autodoc");
              template<typename X> struct T {};
              %template(TInteger) T<int>;

            the generated documentation contains:
              """Proxy of C++ T< int > class."""
            instead of:
              """Proxy of C++ T<(int)> class."""
            and
              """__init__(TInteger self) -> TInteger"""
            instead of
              """__init__(T<(int)> self) -> TInteger"""

2017-06-27: nihaln
	    [PHP] Update the OUTPUT Typemap to add return statement to the
	    PHP Wrapper.

2017-06-27: nihaln
	    [PHP] Update the enum and value examples to use the OO wrappers
	    rather than the flat functions produced with -noproxy.  There's
	    not been a good reason to use -noproxy for since PHP5 OO wrapping
	    was fixed back in 2005.

2017-06-23: m7thon
            [Python] fix and improve default argument handling:

            1. Fix negative octals. Currently not handled correctly by `-py3`
               (unusual case, but incorrect).
            2. Fix arguments of type "octal + something" (e.g. `0640 | 04`).
               Currently drops everything after the first octal. Nasty!
            3. Fix bool arguments "0 + something" (e.g. `0 | 1`) are always
               "False" (unusual case, but incorrect).
            4. Remove special handling of "TRUE" and "FALSE" from
               `convertValue` since there's no reason these have to match
               "true" and "false".
            5. Remove the Python 2 vs. Python 3 distinction based on the
               `-py3` flag. Now the same python code is produced for default
               arguments for Python 2 and Python 3. For this, octal default
               arguments, e.g. 0644, are now wrapped as `int('644', 8)`. This
               is required, as Python 2 and Python 3 have incompatible syntax
               for octal literals.

            Fixes #707

2017-06-21: futatuki
            #1004 - Fix ccache-swig executable name to respect configure's --program-prefix and
            --program-suffix values if used.

2017-06-21: tamuratak
            [Ruby] #911 - Add std::wstring support.

2017-06-19: wsfulton
            [Python] Fix handling of rich comparisons when wrapping overloaded operators:

              operator<  operator<=  operator>  operator>=  operator==  operator!=

            Previously a TypeError was always thrown if the type was not correct. NotImplemented
            is now returned from these wrapped functions if the type being compared with is
            not correct. The subsequent behaviour varies between different versions of Python
            and the comparison function being used, but is now consistent with normal Python
            behaviour. For example, for the first 4 operator overloads above, a TypeError
            'unorderable types' is thrown in Python 3, but Python 2 will return True or False.
            NotImplemented should be returned when the comparison cannot be done, see PEP 207 and
            https://docs.python.org/3/library/constants.html#NotImplemented

            Note that the bug was only present when overloaded operators did not also have a
            function overload.

            Fixes SF bug #1208 (3441262) and SF patch #303.

            *** POTENTIAL INCOMPATIBILITY ***

2017-06-17: fabrice102
            [Go] Fix Go callback example.  Fixes github #600, #955, #1000.

2017-06-16: wsfulton
            Make sure warning and error messages are not split up by other processes writing to
            stdout at the same time.

2017-06-16: wsfulton
            [R] Fix wrapping function pointers containing rvalue and lvalue reference parameters.

2017-06-13: olly
	    [Perl] Fix testsuite to work without . in @INC - it was removed in
	    Perl 5.26 for security reasons, and has also been removed from
	    older versions in some distros.  Fixes #997 reported by lfam.

2017-06-03: wsfulton
            Fix %import on a file containing a file scope %fragment forced inclusion to not
            generate the fragment contents as %import should not result in code being generated.
            The behaviour is now the same as importing code insertion blocks.
            Wrapping FileC.i in the following example will result in no generated code, whereas
            previously "#include <limits.h>" was generated:

              // FileA.i
              %fragment("<limits.h>", "header") %{
                #include <limits.h>
              %}

              %{
                #include <stdio.h>
              %}
              %fragment("<limits.h>");

              // FileC.i
              %import "FileA.i"

            *** POTENTIAL INCOMPATIBILITY ***

2017-05-26: Volker Diels-Grabsch, vadz
            [Java] #842 Extend from java.util.AbstractList<> and implement java.util.RandomAccess for
            std::vector wrappers. This notably allows to iterate over wrapped vectors in a natural way.
            Note that boxed types are now used in the Java layer when wrapping vector of C primitive
            types, for example. This may introduce some subtle incompatibilities due to some
            differences in how Java converts boxed types and unboxed types. For example,

              int i=0;
              double d1 = i; // ok
              Double d2 = i; // error: incompatible types: int cannot be converted to Double

            This can be a problem when calling the add and set functions. A suggested backwards
            compatible workaround is to use something like (shown for std::vector<double>:

              #if defined(SWIGJAVA)
              // Add in old api that uses non-boxed types
              %extend std::vector<double> {
              %proxycode %{
                public void add(double x) {
                  add(Double.valueOf(x));
                }
                public void set(int i, double val) {
                  set(i, Double.valueOf(val));
                }
              %}
              }
              #endif

              %include "std_vector.i"
              %template(VectorDouble) std::vector<double>;

            *** POTENTIAL INCOMPATIBILITY ***

2017-05-30: davidcl
            [Scilab] #994 Undefined symbol error when loading in Scilab 6

2017-05-25: asibross
            [Java] #370 #417 Missing smart pointer handling in Java director extra methods
            swigReleaseOwnership() and swigTakeOwnership().

2017-05-23: wsfulton
            [Java] #230 #759 Fix Java shared_ptr and directors for derived classes java compilation
            error.

            For shared_ptr proxy proxy classes, add a protected method swigSetCMemOwn for modifying
            the swigCMemOwn and swigCMemOwnDerived member variables which are used by various other
            methods for controlling memory ownership.

2017-05-21: Sghirate
            [Java, C#, D] #449 Remove unnecessary use of dynamic_cast in directors to enable
            non-RTTI compilation.

2017-05-21: wsfulton
            [Python] #993 Fix handling of default -ve unsigned values, such as:
              void f(unsigned = -1U);

2017-05-20: jschueller
            [Python] #991 Fix E731 PEP8 warning: do not assign a lambda expression

2017-05-16: nihal95
            [PHP] Add %pragma version directive to allow the version of the
            extension to be set.  Patch #970, fixes #360.

2017-05-13: yag00
            Patch #975 - Add support for noexcept on director methods.

2017-04-27: redbrain
            Issue #974, Patch #976 - Fix preprocessor handling of macros with commas in a comment.

2017-04-25: jleveque
            [Lua] #959 - Fix Visual Studio C4244 conversion warnings in Lua wrappers.

2017-04-21: tamuratak
            [Ruby] #964 - Add shared_ptr director typemaps.

2017-04-20: wsfulton
            [Ruby] #586, #935 Add assert for invalid NULL type parameter when calling SWIG_Ruby_NewPointerObj.

2017-04-20: tamuratak
            [Ruby] #930, #937 - Fix containers of std::shared_ptr.
            Upcasting, const types (eg vector<shared_ptr<const T>>) and NULL/nullptr support added.

2017-04-12: smarchetto
            [Scilab] New parameter targetversion to specify the Scilab target version (5, 6, ..) for code generation
            With Scilab 6 target specified, identifier names truncation is disabled (no longer necessary)

2017-03-24: tamuratak
            [Ruby] Fix #939 - Wrapping std::vector<bool> fix due to incorrect null checks
            on VALUE obj.

2017-03-17: vadz
            [C#] #947 Add support for std::complex<T>

2017-03-17: wsfulton
            [Go] Fix handling of typedef'd function pointers and typedef'd member function pointers
            such as:

              typedef int (*FnPtr_td)(int, int);
              int do_op(int x, int y, FnPtr_td op);

2017-03-16: wsfulton
            Add support for member const function pointers such as:

              int fn(short (Funcs::* parm)(bool)) const;

            Also fix parsing of references/pointers and qualifiers to member
            pointers such as:

              int fn(short (Funcs::* const parm)(bool));
              int fn(short (Funcs::* & parm)(bool));

2017-03-10: wsfulton
            Extend C++11 alternate function syntax parsing to support const and noexcept, such as:

              auto sum1(int x, int y) const -> int { return x + y; }
              auto sum2(int x, int y) noexcept -> int { return x + y; }

2017-02-29: tamuratak
            [Ruby] #917 - Add Enumerable module to all container class wrappers. It was missing
            for std::list, std::multiset, std::unordered_multiset and std::unordered_map.

2017-02-27: assambar
            [C++11] Extend parser to support throw specifier in combination
            with override and/or final.

2017-02-10: tamuratak
            [Ruby] #883 - Add support for C++11 hash tables:
              std::unordered_map
              std::unordered_set
              std::unordered_multimap
              std::unordered_multiset

2017-02-08: jcsharp
            [C#] #887 Improve std::vector<T> wrapper constructors -
            Replace constructor taking ICollection with IEnumerable and also add IEnumerable<T>
            constructor to avoid the boxing and unboxing overhead of the original constructor,
            when the type parameter is a value type.

Version 3.0.12 (27 Jan 2017)
============================

2017-01-27: wsfulton
            [C#] #882 Fix missing filename in error messages when there is a problem
            writing out C# files.

2017-01-27: briancaine
            [Guile] #744 Fix compilation errors in Guile wrappers - regression
            introduced in swig-3.0.11.

2017-01-24: andrey-starodubtsev
            [Java] Apply #704 - director typemap improvements.
            Memory leak fixes, add support for "directorargout" typemap and
            add director support to typemaps.i.

2017-01-24: wsfulton
            Enhance %extend to extend a class with template constructors, eg:

              struct Foo {
                %extend {
                  template<typename T>
                  Foo(int a, T b) {
                    ...
                  }
                }
              };
              %template(Foo) Foo::Foo<double>;

2017-01-22: wsfulton
            Issue #876 Enhance %extend to extend a class with template methods, eg:

              struct Foo {
                %extend {
                  template<typename T>
                  void do_stuff(int a, T b) {
                    ...
                  }
                }
              };
              %template(do_stuff_inst) Foo::do_stuff<double>;

              Similarly for static template methods.

2017-01-22: kwwette
            [Octave] add support for version 4.2
            - The Octave API now uses some C++11 features. It is recommended to use
              the mkoctfile program supplied by Octave to compile the SWIG-generated
              wrapper code, as mkoctfile will ensure the correct C++ compiler/options
              are used. Otherwise, the value of `mkoctfile -p CXX` should be parsed
              for any -std=* flags which might be present.
            - Octave has dropped support for << and >> operators, so SWIG now
              ignores them.
            - The Octave error() function now raises C++ exceptions to propagate
              Octave errors, so %exception directives may need to be modified.
              For convenience the SWIG_RETHROW_OCTAVE_EXCEPTIONS macro can be used
              to rethrow any Octave exceptions for Octave itself to handle, e.g.:

                try {
                  $action                        // may call error()
                }
                SWIG_RETHROW_OCTAVE_EXCEPTIONS   // error() exceptions are rethrown
                catch(...) {
                  ...                            // all other exceptions
                }

            *** POTENTIAL INCOMPATIBILITY ***

2017-01-16: wkalinin
            [C#] Fix #733 regression introduced in swig-3.0.9.
            Missing virtual function override in C# layer when using %import.

2017-01-16: fschlimb
            Fix #813 template symbol name lookup bug when typedef names are the same but in different
            namespaces.

2017-01-15: wsfulton
            [C# D Java]
            The SWIG library no longer uses the javatype, dtype or cstype typemaps, thereby
            completely freeing them up for users to use without having to replicate the library
            code that they previously added. The code previously generated by these typemaps
            has been replaced by the new %proxycode directive. Their use in the library code
            was fairly minimal:

              C#   cstype:   std_array.i std_map.i std_vector.i
              D    dtype:    std_vector.i
              Java javatype: arrays_java.i

2017-01-14: wsfulton
            The %extend directive can now optionally support one of the 'class', 'struct' or 'union'
            keywords before the identifier name, for example:

              struct X { ... };
              %extend struct X { ... }

            Previously this had to specified as:

              struct X { ... };
              %extend X { ... }

2017-01-13: wsfulton
	    [C# D Java] Add new %proxycode directive which is a macro for %insert("proxycode").
            This is a way of adding pure C#/D/Java code into the appropriate proxy class, eg:

              %extend Proxy2 {
              %proxycode %{
                public int proxycode2(int i) {
                  return i+2;
                }
              %}
              }

              %inline %{
              struct Proxy2 {};
              %}

            There will then be a pure Java/C#/D method called proxycode2 in the Proxy2 class.

2016-12-31: ajrheading1
	    Issue #860 - Remove use of std::unary_function and std::binary_function
            which is deprecated in C++11.

2016-12-30: olly
	    [PHP7] Register internal 'swig_runtime_data_type_pointer' constant
	    as "CONST_PERSISTENT" to avoid segmentation fault on module unload.
	    Fixes #859 reported by Timotheus Pokorra. Thanks also to Javier Torres
	    for a minimal reproducer.

Version 3.0.11 (29 Dec 2016)
============================

2016-12-24: wsfulton
            [C#] Add %feature("csdirectordelegatemodifiers") to enable customization
            of the delegate access modifiers generated in director classes.
            Fixes issue #748.

2016-12-23: wsfulton
            [Python] Fix builtin "python:slot" feature failing for tp_hash when using
            hashfunc closure with a "Wrong type for hash function" for Python 2.
            Issue #843.

2016-12-21: joequamt
            Changed generation of functions so that only functions
            that end in _set generate accessor functions rather than
	    looking for "set".
	    Change generation of operators to not have underscores
	    to start in R. Users need to provide custom names for these operator overloads.

2016-12-21: olly
	    Fix isfinite() checks to work with all C++11 compilers.
	    Fixes issues #615, #788 and #849.

2016-12-20: wsfulton
            %namewarn unnecessarily caused keyword warnings for non-instantiated template classes
            and duplicate warnings for instantiated template classes when keywords were used.
            Issue #845.

2016-12-18: ezralanglois 
            [Python, Ruby, Octave] Memory leak fix on error in std::pair wrappers.
            Issue #851.

2016-12-18: wsfulton
            Zero initialize arrays when using %array_class and %array_functions.

2016-12-18: t-ikegami
            [Python] Fix #446
            Python %array_class of carrays.i failed with -builtin option.

2016-12-16: briancaine
            [Guile] Patch #744 Added support for Guile's native pointer functionality

2016-12-01: wsfulton
            [Python] Issue #769.
            Add optional moduleimport attribute to %module so that the
            default module import code can be overridden. See the "Searching for the wrapper module"
            documentation in Python.html. Example:

              %module(moduleimport="import _foo") foo

            $module also expands to the low-level C/C++ module name, so the following is the
            same as above

              %module(moduleimport="import $module") foo

2016-11-30: olly
	    [PHP] Add support for PHP7.  PHP5's C extension API has changed
	    substantially so you need to use -php7 to specify you want PHP7
	    compatible wrappers.  The default extension for generated wrappers
	    is now .cxx (to match SWIG's default for every other language - to
	    generate foo_wrap.cpp you can run SWIG with -cppext cpp).  Fixes
	    issue #571.

	    As part of this change, the language subdirectory for PHP5 has
	    changed from "php" to "php5" - if you are making use of the search
	    path feature where the language subdirectory of each directory
	    is also searched, you'll need to update your bindings.  A simple
	    fix which works for older and newer SWIG is to add a symlink:
	    ln -s php php5

	    *** POTENTIAL INCOMPATIBILITY ***

2016-11-30: olly
	    [PHP] Only emit one copy of each distinct arginfo.  Previously we
	    emitted a separate one for every wrapped function, but typically
	    many functions have the same number of parameters and combinations
	    of parameters passed by reference or not.

	    This change significantly reduces both the size of the generated
	    wrapper, and of the compiled PHP extension module (e.g. by ~6% for
	    the stripped extension module for Xapian's PHP7 bindings).

2016-11-28: wsfulton
            Fix %rename override of wildcard %rename for templates. For example:

              %rename(GlobalIntOperator) *::operator bool; // wildcard %rename

              %rename(XIntOperator) X::operator bool; // fix now overrides first %rename above
              OR
              %rename(XIntOperator) X<int>::operator bool; // fix now overrides first %rename above

              template<typename T> struct X {
                operator bool();
                ...
              };
              %template(Xint) X<int>;

            This also fixes %rename override of global %rename for templates. For example:

              // Global rename to make all functions start with a lower case letter
              %rename("%(firstlowercase)s", %$isfunction ) "";
              %rename(woohoo) W::Woo; // fix now overrides above %rename

              template<typename T> struct W {
                W Woo();
                ...
              };
              %template(Wint) W<int>;

            The above also introduces a possibly unexpected change. Many of the STL containers
            provided by SWIG use %rename to rename some methods, eg in std::vector, push_back
            is renamed to add in Java. Previously this intended rename did not happen when using
            using global %rename rules and the method would remain as push_back, but is now
            renamed to add. Some more info in issue #856.

	    *** POTENTIAL INCOMPATIBILITY ***

2016-11-26: m7thon
            [Python] Issue #709 - improved wrapping of division operators
            'from __future__ import division' now works in Python 2 whether or not the
            -py3 flag is used.

2016-11-12: joequant
            [R] Issue #697 - fix comma issue with overload methods

2016-11-12: joequant
	    [R] Issue #555 - R runtime needs stdio.h

2016-11-02: wsfulton
            [Python] Issue #816 - fix compilation error when using -extranative and -builtin.

2016-11-02: liorgold
            Patch #741 - Add support for C++11 alias templates, see updated CPlusPlus11.html
            documentation.

2016-10-30: myd7349
            [C#] Patch #740 Add std_array.i for C# for wrapping std::array.

            Patch also enhances std::vector<std::wstring> C# wrappers with additional functions
            (Contains, IndexOf, LastIndexOf and Remove).

2016-10-30: tobilau
            [Java] Fix wrappers for wstring parameters in director methods to cleanup local
            ref after director callback has finished.

2016-10-23: wsfulton
            [C#] Add missing csdirectorin VOID_INT_PTR and csdirectorout VOID_INT_PTR typemaps.

2016-10-23: jiulongw
            Patch #781 - Fix wrapping of C compound expressions containing char constants
            in quotes such as:

              #define H_SUPPRESS_SCALING_MAGIC (('s'<<24) | ('u'<<16) | ('p'<<8) | 'p')

              enum DifferentTypes {
                typecharcompound='A'+1,
                typecharcompound2='B' << 2
              };

2016-10-13: wsfulton
            [Python] Issue #808 - fix Python pickling and metaclass for builtin wrappers.

            The metaclass (SwigPyObjectType) for SWIG objects was not defined in
            a way that let importlib successfully import the Python wrappers.
            The pickle module previously failed to pickle objects because it couldn't
            determine what module the SWIG wrapped objects were in.

2016-09-29: wsfulton
            [Allegrocl, CFFI, GO, Javascript, Ocaml, R, Scilab]
            Add missing support for the "ret" typemap in a few target languages.
            The documentation also now has info on the "ret" typemap.

2016-09-27: ahmed-usman
            [xml] Handle template parameters correctly.

2016-09-27: dontpanic92
            [Go] Fix argument names in inherited functions taking more than 8
            parameters.  Fixes #795.

2016-09-26: smarchetto
            [Scilab] mlists that map pointers can be given a custom type name.

2016-09-25: wsfulton
            Patch #793 from q-p to expand exception handling to include std::bad_cast
            in std_except.i.

2016-09-24: olly
            [PHP] Fix code generated for feature("director:except") -
            previously the return value of call_user_function() was ignored and
            we checked an uninitialised value instead.  Fixes #627.  Based on
            patch from Sergey Seroshtan.

2016-09-22: wsfulton
            [Python] More flexible python builtin slots for overloaded C++ function.

            The closure names used for builtin slots are mangled with their functype so
            that overloaded C++ method names can be used for multiple slots.
            For example:

              %feature("python:slot", "mp_subscript", functype="binaryfunc") SimpleArray::__getitem__;
              %feature("python:slot", "sq_item", functype="ssizeargfunc") SimpleArray::__getitem__(Py_ssize_t n);

            will generate closures:

              SWIGPY_SSIZEARGFUNC_CLOSURE(_wrap_SimpleArray___getitem__) /* defines _wrap_SimpleArray___getitem___ssizeargfunc_closure */
              SWIGPY_BINARYFUNC_CLOSURE(_wrap_SimpleArray___getitem__) /* defines _wrap_SimpleArray___getitem___binaryfunc_closure */

            Previously only one name was defined: _wrap_SimpleArray___getitem___closure.
            Hence the overloaded __getitem__ method can be used to support both mp_subscript and sq_item slots.

2016-09-17: wsfulton
            [Python] Fix iterators for containers of NULL pointers (or Python None) when using
            -builtin. Previously iteration would stop at the first element that was NULL.

2016-09-16: olly
            [Javascript] Fix SWIG_exception() macro to return from the current
            function.  Fixes #789, reported by Julien Dutriaux.

2016-09-16: olly
            [PHP] Fix SWIG_exception() macro to return from the current function.
            Fixes #240, reported by Sergey Seroshtan.

2016-09-12: xypron
            [C#] Patch #786 Keyword rename to be CLS compliant by adding an underscore
            suffix instead of an underscore prefix to the C symbol name. Please use an explicit
            %rename to rename the symbol with a _ prefix if you want the old symbol name.

            *** POTENTIAL INCOMPATIBILITY ***

2016-09-09: olly
            [Python] Fix import handling for Python 2.6 to work in a frozen
            application.  Fixes #145, reported by Thomas Kluyver.

2016-09-02: smarchetto
            [Scilab] Pointers are mapped to mlist instead of tlist
            (mlist better for scilab overloading)

2016-09-02: olly
            [PHP] Fix "out" typemap for member function pointers and "in"
            typemap for char INPUT[ANY].

2016-09-01: wsfulton
            [Python] More efficient Python slicing.
            Call reserve for container types that support it to avoid repeated
            memory reallocations for new slices or slices that grow in size.

2016-09-01: wsfulton
            [Python] #771 - Make builtin types hashable by default.
            Default hash is the underlying C/C++ pointer. This matches up with testing for
            equivalence (Py_EQ in SwigPyObject_richcompare) which compares the pointers.

2016-08-22: wsfulton
            [Python] The following builtin slots can be customized like other slots via the
            "python:<x>" and "python:slot" features where <x> is the appropriate slot name:
              tp_allocs
              tp_bases
              tp_basicsize
              tp_cache
              tp_del
              tp_dealloc
              tp_flags
              tp_frees
              tp_getset
              tp_is_gc
              tp_maxalloc
              tp_methods
              tp_mro
              tp_new
              tp_next
              tp_prev
              tp_richcompare
              tp_subclasses
              tp_weaklist
              was_sq_ass_slice
              was_sq_slice

            A few documentation improvements for slot customization.

2016-08-09: joequant
            [R] Patch #765 Fix extern "C" header includes for C++ code.

2016-08-05: olly
            [xml] Fix how the output filename is built to avoid problems when
            it contains the embedded strings ".c", ".cpp" or ".cxx".
            Fixes #540 reported by djack42.

2016-07-01: wsfulton
            Fix corner case of wrapping std::vector of T pointers where a pointer to a pointer of T
            also exists in the wrapped code. SF Bug 2359417 (967).

2016-06-26: wkalinin
            [Java, C#] Patch #681 Fix seg fault when ignoring nested classes.

2016-06-25: mromberg
            [Python] #711 Fix -castmode and conversion of signed and unsigned integer types.
            See 2015-12-23 CHANGES entry for details of these improvements when they were
            implemented for the default options (ie not using -castmode).

2016-06-25: ahnolds
            Patch #730 - Fix %implicitconv for overloaded functions when using
            -castmode or -fastdispatch options.

            The result is that in all overload cases where there are multiple possibilities
            with the same number of arguments, the dispatch function will first check for
            exact (aka non implicit) matches, and then subsequently check for implicit
            casting matches. This was already happening in the normal dispatch situation,
            and in the -fastdispatch case two passes through the candidates were happening,
            just with SWIG_POINTER_IMPLICIT_CONV always set. After this patch, it is not set
            on the first pass, and then set on the second pass.

2016-06-25: liorgold
            Patch #727 - Add support for C++11 type aliasing.

Version 3.0.10 (12 Jun 2016)
============================

2016-06-06: mromberg
            [Python] Patch #698. Add support for -relativeimport for python 2.7, so -py3 is no
            longer also required for relative import support.

2016-06-05: mromberg
            [Python] Patch #694 - Fix package import regressions introduced in swig-3.0.9.

            1) The code in 3.0.9 did not fall back to 'import _foo' if 'import bar._foo' failed
            (assuming bar.foo was the main module). Every place _foo is imported now first tries
            it from the package where foo was found and if that fails tries _foo as a global module.

            2) The separate block of Python code that injected code to pull in the attributes
            from _foo when -builtin is used made use of the -py3 switch to either do
            'from ._foo import *' or "from _foo import *". This block of code no longer does this
            and instead checks the Python version at runtime to switch between the two syntaxes.

            In summary, swig-3.0.10 has been modified to ease the creation of wrapper modules
            that can be fully made part of a Python package.  SWIG no longer
            assumes the dynamically linked C module is a global module.
            The dynamic module can now be placed into either the same package as the pure Python
            module or as a global module.  Both locations are used by the Python wrapper to
            locate the C module.

            However, this could cause a backwards incompatibility with some code
            that was relying on the ability of "from package import _module" to
            pull attributes out of the package directly.  If your code populates a
            module (which is also a package) with attributes that are SWIG
            generated modules which were not loaded in a conventional way,
            swig-3.0.8 and earlier may have worked due to 'from package import
            _module' bypassing a real import and pulling your module in as an
            attribute. This will no longer work.  Since this is not a common (or
            even recommended) practice, most folk should not be affected.

            *** POTENTIAL INCOMPATIBILITY ***

2016-05-31: wsfulton
            Fix #690 - Smart pointer to %ignored class doesn't expose inherited methods.
            Regression introduced in swig-3.0.9.

Version 3.0.9 (29 May 2016)
===========================

2016-05-24: mromberg
            [Python] Patch #612 - Add support for Python's implicit namespace packages.

2016-05-23: wsfulton
            [Ruby] Fix #602 - Error handling regression of opaque pointers introduced
            in swig-3.0.8 when C functions explicitly reset a pointer using 'DATA_PTR(self) = 0'.
            An ObjectPreviouslyDeleted error was incorrectly thrown when the pointer was used
            as a parameter.

2016-05-17: tamuratak
            [Ruby] Patch #651 - Correct overloaded function error message when function is
            using %newobject.

2016-05-17: aurelj
            [Ruby] Patch #582 - add support for docstring option in %module()

2016-05-14: wsfulton
            Fix #434 - Passing classes by value as parameters in director methods did not create
            a copy of the argument leading to invalid memory accesses if the object was used
            after the upcall into the target language. Passing arguments by value shouldn't give
            rise to these sorts of memory problems and so the objects are now copied and ownership
            of their lifetime is controlled by the target language.

2016-05-07: wsfulton
            Fix #611. Fix assertion handling defaultargs when using %extend for a template
            class and the extended methods contain default arguments.

2016-05-05: ejulian
            [Python] Patch #617. Fix operator/ wrappers.

2016-05-02: wsfulton
            Fix #669. Don't issue warning about ignoring base classes when the derived class is
            itself ignored.

2016-04-18: ianlancetaylor
	    [Go] Fix use of goout typemap when calling base method by
	    forcing the "type" attribute to the value we need.

2016-04-17: ianlancetaylor
	    [Go] Fixes for Go 1.6: avoid returning Go pointers from
	    directors that return string values; add a trailing 0 byte
	    when treating Go string as C char*.

2016-04-06: smarchetto
            [Scilab] #552 Make Scilab runtime keep track of pointer types
            Instead of a Scilab pointer which has no type, SWIG Scilab maps a
            pointer to a structure tlist containing the pointer adress and its type.

2016-04-02: ahnolds
            [Python] Apply #598. Fix misleading error message when attempting to read a non-existent
            attribute. The previous cryptic error message:
              AttributeError: type object 'object' has no attribute '__getattr__'
            is now replaced with one mentioning the attribute name, eg:
              AttributeError: 'Foo' object has no attribute 'bar'

2016-04-02: derkuci
            [Python] Patch #610 to fix #607.
            Fix single arguments when using python -builtin -O with %feature("compactdefaultargs")

2016-03-31: wsfulton
            Fixes #594. Fix assertion for some languages when wrapping a C++11 enum class that
            is private in a class.

            Also don't wrap private enums for a few languages that attempted to do so.

2016-03-31: wsfulton
            [Java] unsigned long long marshalling improvements when a negative number
            is passed from Java to C. A cast to signed long long in the C layer will now
            result in the expected value. No change for positive numbers passed to C.
            Fixes #623.

2016-03-22: alexwarg
	    [Lua] #398 Fix lua __getitem + inheritance
            The new handling of classes in Lua (not merging methods into the derived classes)
            breaks for classes that provide a __getitem function. The __getitem function
            prevents method calls to any method defined in a base class. This fix calls
            __getitem only if the member is not found using recursive lookup.

2016-03-18: ptomulik
	    [Python] #563 Stop generating unnecessary _swigconstant helpers.

2016-03-16: richardbeare
	    [R] #636 Add extra std::vector numeric types

2016-03-14: wsfulton
	    [Java] Add std_array.i for C++11 std::array support.

2016-03-12: wsfulton
	    [Java, C#, D] Fix static const char member variables wrappers with %javaconst(1)
            %csconst(1) or %dmanifestconst.
            This fixes the case when an integer is used as the initializer, such as:

              struct W { static const char w = 100; };

	    Fix generated code parsing enum values using char escape sequences
            when these values appear in the Java code (usually when using %javaconst(1))
            such as:

              enum X { x1 = '\n', x2 = '\1' };

            Similarly for static const member char variables such as:

              struct Y { static const char y = '\n'; }

            Likewise for D and %dmanifestconstant. For C# and %csconst(1), char
            values in C# are now hex escaped as C# doesn't support C octal escaping.

2016-03-11: wsfulton
            [Java C#] Add support for treating C++ base classes as Java interfaces
            instead of Java proxy classes. This enable some sort of support for
            multiple inheritance. The implementation is in swiginterface.i and
            provides additional macros (see Java.html for full documentation):

              %interface(CTYPE)
              %interface_impl(CTYPE)
              %interface_custom("PROXY", "INTERFACE", CTYPE)

2016-03-01: wsfulton
            Add rstrip encoder for use in %rename. This is like the strip encoder but
            strips the symbol's suffix instead of the prefix. The example below
            will rename SomeThingCls to SomeThing and AnotherThingCls to AnotherThing:

              %rename("%(rstrip:[Cls])s") "";

              class SomeThingCls {};
              struct AnotherThingCls {};

2016-03-01: olly
	    Fix isfinite() check to work with GCC6.  Fixes
	    issue #615 reported by jplesnik.

2016-02-17: olly
	    [Python] Add missing keywords 'as' and 'with' to pythonkw.swg.

2016-02-07: kwwette
            [Octave] recognise various unary functions
            * Use __float__() for numeric conversions, e.g. when calling double()
            * Map various unary functions, e.g. abs() to __abs__(), see full list
              in section 32.3.10 of manual; only available in Octave 3.8.0 or later

2016-02-07: kwwette
            [Octave] export function swig_octave_prereq() for testing Octave version

2016-02-06: pjohangustavsson
            [C#] Fix duplicate symbol problems when linking the source generated
            from multiple SWIG modules into one shared library for the -namespace
            option. The namespace is now mangled into the global PInvoke function
            names.

            *** POTENTIAL INCOMPATIBILITY ***

2016-01-27: ahnolds
            [Python] Added support for differentiating between Python Bytes
            and Unicode objects using by defining SWIG_PYTHON_STRICT_BYTE_CHAR
            and SWIG_PYTHON_STRICT_UNICODE_WCHAR.

2016-01-27: steeve
            [Go] Ensure structs are properly packed between gc and GCC/clang.

2016-01-25: ahnolds
            [Python] Support the full Python test suite in -classic mode
            * Convert long/unsigned long/long long/unsigned long long to PyInt
              rather than PyLong when possible. Certain python functions like
              len() require a PyInt when operating on old-style classes.
            * Add support for static methods in classic mode, including support
              for pythonappend, pythonprepend, and docstrings.
            * Removing the use of __swig_getmethods__ for static member methods
              since they will always be found by the standard argument lookup
            * Fix a bug where the wrong type of exception was caught when
              checking for new-style class support

2016-01-23: ahnolds
            [Go] Enable support for the Go test-suite on OSX:
            * The linker on OSX requires that all symbols (even weak symbols)
              are defined at link time. Because the function _cgo_topofstack is
              only defined starting in Go version 1.4, we explicitly mark it as
              undefined for older versions of Go on OSX.
            * Avoid writing empty swigargs structs, since empty structs are not
              allowed in extern "C" blocks.

2016-01-12: olly
	    [Javascript] Look for "nodejs" as well as "node", as it's packaged
	    as the former on Debian.

2016-01-12: olly
	    [Javascript] For v8 >= 4.3.0, use V8_MAJOR_VERSION.
	    Fixes issue 561.

2016-01-10: ahnolds
            Improved size_t and ptrdiff_t typemaps to support large values
            on platforms where sizeof(size_t) > sizeof(unsigned long) and
            sizeof(ptrdiff_t) > sizeof(long).

Version 3.0.8 (31 Dec 2015)
===========================

2015-12-30: wsfulton
            The pdf documentation is now generated by wkhtmltopdf and has colour
            for the code snippets just like the html documentation!

2015-12-23: ahnolds
            [Python] Fixes for conversion of signed and unsigned integer types:

            No longer check for PyInt objects in Python3. Because PyInt_Check
            and friends are #defined to the corresponding PyLong methods, this
            had caused errors in Python3 where values greater than what could be
            stored in a long were incorrectly interpreted as the value -1 with
            the Python error indicator set to OverflowError. This applies to
            both the conversions PyLong->long and PyLong->double.

            Conversion from PyLong to long, unsigned long, long long, and
            unsigned long long now raise OverflowError instead of TypeError in
            both Python2 and Python3 for PyLong values outside the range
            expressible by the corresponding C type. This matches the existing
            behavior for other integral types (signed and unsigned ints, shorts,
            and chars), as well as the conversion for PyInt to all numeric
            types. This also indirectly applies to the size_t and ptrdiff_t
            types, which depend on the conversions for unsigned long and long.

2015-12-19: wsfulton
            [Python] Python 2 Unicode UTF-8 strings can be used as inputs to char * or
            std::string types if the generated C/C++ code has SWIG_PYTHON_2_UNICODE defined.

2015-12-17: wsfulton
            Issues #286, #128
            Remove ccache-swig.1 man page - please use the CCache.html docs instead.
            The yodl2man and yodl2html tools are no longer used and so SWIG no
            longer has a dependency on these packages which were required when
            building from git.

2015-12-16: zturner/coleb
            [Python] Fix Python3.5 interpreter assertions when objects are being
            deleted due to an existing exception. Most notably in generators
            which terminate using a StopIteration exception. Fixes #559 #560 #573.
            If a further exception is raised during an object destruction,
            PyErr_WriteUnraisable is used on this second exception and the
            original exception bubbles through.

2015-12-14: ahnolds/wsfulton
            [Python] Add in missing initializers for tp_finalize,
            nb_matrix_multiply, nb_inplace_matrix_multiply, ht_qualname
            ht_cached_keys and tp_prev.

2015-12-12: wsfulton
            Fix STL wrappers to not generate <: digraphs.
            For example std::vector<::X::Y> was sometimes generated, now
            corrected to std::vector< ::X::Y >.

2015-11-25: wsfulton
            [Ruby] STL ranges and slices fixes.

            Ruby STL container setting slices fixes:

            Setting an STL container wrapper slice better matches the way Ruby
            arrays work. The behaviour is now the same as Ruby arrays. The only
            exception is the default value used when expanding a container
            cannot be nil as this is not a valid type/value for C++ container
            elements.

            Obtaining a Ruby STL container ranges and slices fixes:

            Access via ranges and slices now behave identically to Ruby arrays.
            The fixes are mostly for out of range indices and lengths.
            - Zero length slice requests return an empty container instead of nil.
            - Slices which request a length greater than the size of the container
              no longer chop off the last element.
            - Ranges which used to return nil now return an empty array when the
              the start element is a valid index.

            Ruby STL container negative indexing support improved.

            Using negative indexes to set values works the same as Ruby arrays, eg

            %template(IntVector) std::vector<int>;

            iv = IntVector.new([1,2,3,4])
            iv[-4] = 9 # => [1,2,3,9]
            iv[-5] = 9 # => IndexError

2015-11-21: wsfulton
            [Ruby, Python] Add std::array container wrappers.

            These work much like any of the other STL containers except Python/Ruby slicing
            is somewhat limited because the array is a fixed size. Only slices of
            the full size are supported.

2015-10-10: wsfulton
            [Python] #539 - Support Python 3.5 and -builtin.  PyAsyncMethods is a new
            member in PyHeapTypeObject.

2015-10-06: ianlancetaylor
	    [Go] Don't emit a constructor function for a director
	    class with an abstract method, since the function will
	    always panic.

2015-10-01: wsfulton
            Fix %shared_ptr support for private and protected inheritance.
            - Remove unnecessary Warning 520: Derived class 'Derived' of 'Base'
              is not similarly marked as a smart pointer
            - Do not generate code that attempts to cast up the inheritance chain in the
              type system runtime in such cases as it doesn't compile and can't be used.
            Remove unnecessary warning 520 for %shared_ptr when the base class is ignored.

2015-10-01: vkalinin
            Fix #508: Fix segfault parsing anonymous typedef nested classes.

2015-09-26: wsfulton
            [Ruby] Add shared_ptr support

2015-09-13: kkaempf
            [Ruby] Resolve tracking bug - issue #225.
            The bug is that the tracking code uses a ruby hash and thus may
            allocate objects (Bignum) while running the GC. This was tolerated in
            1.8 but is invalid (raises an exception) in 1.9.
            The patch uses a C hash (also used by ruby) instead.

2015-09-09: lyze
            [CFFI] Extend the "export" feature in the CFFI module to support
            exporting to a specified package.

2015-09-04: olly
	    [Python] Fix docstrings for %callback functions.

2015-09-03: demi-rluddy
            [Go] Removed golang stringing for signed/unsigned char

            Changed default handling of signed char* and unsigned char* to be
            opaque pointers rather than strings, similarly to how other
            languages work.

            Any existing code relying on treating signed char* or unsigned
            char* as a string can restore the old behavior with typemaps.i by
            using %apply to copy the [unchanged] char* behavior.

            *** POTENTIAL INCOMPATIBILITY ***

2015-08-07: talby
            [Perl] tidy -Wtautological-constant-out-of-range-compare warnings when building generated code under clang

2015-08-07: xantares
            [Python] pep257 & numpydoc conforming docstrings:
            - Mono-line module docsstring
            - Rewrite autodoc parameters section in numpydoc style:
              https://github.com/numpy/numpy/blob/master/doc/HOWTO_DOCUMENT.rst.txt
            - One line summary should end with "."
            - Adds a blank line after class docstring

2015-08-05: vadz
            [Java] Make (char* STRING, size_t LENGTH) typemaps usable for
            strings of other types, e.g. "unsigned char*".

Version 3.0.7 (3 Aug 2015)
==========================

2015-08-02: wsfulton
            [Java] Fix potential security exploit in generated Java classes.
            The swigCPtr and swigCMemOwn member variables in the generated Java
            classes are now declared 'transient' by default. Further details of the exploit
            in Android is being published in an academic paper as part of USENIX WOOT '15:
            https://www.usenix.org/conference/woot15/workshop-program/presentation/peles.

            In the unlikely event that you are relying on these members being serializable,
            then you will need to override the default javabody and javabody_derived typemaps
            to generate the old generated code. The relevant typemaps are in the Lib directory
            in the java.swg, boost_shared_ptr.i and boost_intrusive_ptr.i files. Copy the
            relevant default typemaps into your interface file and remove the 'transient' keyword.

            *** POTENTIAL INCOMPATIBILITY ***

2015-08-01: vadz
            Make configure --without-alllang option more useful: it can now be overridden by the following
            --with-xxx options, allowing to easily enable just one or two languages.

2015-07-30: wsfulton
            Fix #440 - Initialise all newly created arrays when using %array_functions and %array_class
            in the carrays.i library - bug is only relevant when using C++.

2015-07-29: wsfulton
            [Python] Improve indentation warning and error messages for code in the following directives:

              %pythonprepend
              %pythonappend
              %pythoncode
              %pythonbegin
              %feature("shadow")

            Old error example:
              Error: Line indented less than expected (line 3 of pythoncode)

            New error example:
              Error: Line indented less than expected (line 3 of %pythoncode or %insert("python") block)
              as no line should be indented less than the indentation in line 1

            Old warning example:
              Warning 740: Whitespace prefix doesn't match (line 2 of %pythoncode or %insert("python") block)

            New warning example:
              Warning 740: Whitespace indentation is inconsistent compared to earlier lines (line 3 of
              %pythoncode or %insert("python") block)

            
2015-07-28: wsfulton
            [Python] Fix #475. Improve docstring indentation handling.
            
            SWIG-3.0.5 and earlier sometimes truncated text provided in the docstring feature.
            This occurred when the indentation (whitespace) in the docstring was less in the
            second or later lines when compared to the first line.
            SWIG-3.0.6 gave a 'Line indented less than expected' error instead of truncating
            the docstring text.
            Now the indentation for the 'docstring' feature is smarter and is appropriately
            adjusted so that no truncation occurs.

2015-07-22: wsfulton
            Support for special variable expansion in typemap attributes. Example usage expansion
            in the 'out' attribute (C# specific):

              %typemap(ctype, out="$*1_ltype") unsigned int& "$*1_ltype"

            is equivalent to the following as $*1_ltype expands to 'unsigned int':

              %typemap(ctype, out="unsigned int") unsigned int& "unsigned int"

            Special variables can be used within special variable macros too. Example usage expansion:

              %typemap(cstype) unsigned int "uint"
              %typemap(cstype, out="$typemap(cstype, $*1_ltype)") unsigned int& "$typemap(cstype, $*1_ltype)"

            Special variables are expanded first and hence the above is equivalent to:

              %typemap(cstype, out="$typemap(cstype, unsigned int)") unsigned int& "$typemap(cstype, unsigned int)"

            which then expands to:

              %typemap(cstype, out="uint") unsigned int& "uint"

2015-07-22: lindleyf
	    Apply patch #439 - support for $typemap() (aka embedded typemaps or special variable
            macros) in typemap attributes. A simple example where $typemap() is expanded in the
            'out' attribute (C# specific):

              %typemap(cstype) unsigned int "uint"
              %typemap(cstype, out="$typemap(cstype, unsigned int)") unsigned int& "$typemap(cstype, unsigned int)"

            is equivalent to:

              %typemap(cstype, out="uint") unsigned int& "uint"

2015-07-18: m7thon
	    [Python] Docstrings provided via %feature("docstring") are now quoted and added to
            the tp_doc slot when using python builtin classes (-builtin). When no docstring is
            provided, the tp_doc slot is set to the fully qualified C/C++ class name.
            Github issues #445 and #461.

2015-07-17: kwwette
            [octave] Support Octave version 4.0.0 (thanks to patches from Orion Poplawski).

2015-07-07: wsfulton
	    SWIG no longer generates a wrapper for a class' constructor if that class has
            any base class with a private destructor. This is because your compiler should
            not allow a class to be instantiated if a base has a private destructor. Some
            compilers do, so if you need the old behaviour, use the "notabstract" feature, eg:

              %feature("notabstract") Derived;
              class Base {
                ~Base() {}
              };
              struct Derived : Base {};

Version 3.0.6 (5 Jul 2015)
==========================

2015-07-02: wsfulton
	    Fix syntax error when the template keyword is used in types, eg:

              std::template vector<int> v;

2015-07-02: ngladitz
	    [Lua] Push characters as unformatted 1-character strings to avoid
	    unprintable characters such as (char)127 being converted to
	    "<\127>" with Lua 5.3 and later.  (github PR #452)

2015-06-29: olly
	    [Python] Improve handling of whitespace in %pythoncode.

	    Previously SWIG looked at the indentation of the first line and
	    removed that many characters from each subsequent line, regardless
	    of what those characters were.  This was made worse because SWIG's
	    preprocessor removes any whitespace before a '#'.  Fixes github
	    issue #379, reported by Joe Orton.

2015-06-12: wsfulton
	    [R] Fix #430 - call to SWIG_createNewRef in copyToC was incorrectly named.

2015-06-11: sghirate
	    [C#] Patch #427 adds in new command line option -outfile to combine all the
            generated C# code into a single file.

2015-06-09: wsfulton
	    Fix seg fault processing C++11 type aliasing. Issue #424.

2015-05-28: wsfulton
	    [Python] Add new feature "python:cdefaultargs" to control default argument
            code generation. By default, SWIG attempts to convert C/C++ default argument values
            into Python values and generates code into the Python layer with these values.
            Recent versions of SWIG are able to convert more of these values, however, the
            new behaviour can be circumvented if desired via this new feature, such that
            the default argument values are obtained from the C layer and not the Python layer.
            For example:

              struct CDA {
                int fff(int a = 1, bool b = false);
              };

            The default code generation in the Python layer is:

              class CDA(_object):
                  ...
                  def fff(self, a=1, b=False):
                      return _default_args.CDA_fff(self, a, b)

            Adding the feature:

              %feature("python:cdefaultargs") CDA::fff;

            Results in:

              class CDA(_object):
                  ...
                  def fff(self, *args):
                      return _default_args.CDA_fff(self, *args)

            Some code generation modes, eg -builtin and -fastproxy, are unaffected by this as
            the default values are always obtained from the C layer.

2015-05-27: wsfulton
	    [Python] Deal with an integer as the default value of a typedef to bool
	    parameter in the C++ prototype.  See #327. Regression from 3.0.0 onwards.

2015-05-19: olly
	    [Python] Fix warning when compiling generated code with MSVC.
	    (Fixes https://sourceforge.net/p/swig/patches/351/ reported by
	    Mateusz Szyma¿ski).

2015-05-14: wsfulton
            Fix seg fault wrapping shared_ptr of classes with private constructors and destructors. 
            This also fixes the "unref" feature when used on classes with private destructors.

2015-05-10: wsfulton
            [Java] Fix multi-argument typemaps (char *STRING, size_t LENGTH)
            so that they can be applied to a wider range of types. Fixes #385.

2015-05-07: olly
	    [Python] Deal with an integer as the default value of a bool
	    parameter in the C++ prototype.  Fixes github #327, reported by
	    Greg Allen.

2015-05-07: LindleyF
	    [Java] Allow feature("director") and feature("ref") to be used
	    together.  Github PR#403.

2015-05-05: olly
	    Suppress warning 325 "Nested class not currently supported (Foo
	    ignored)" when Foo has already been explicitly ignored with "%ignore".

2015-05-04: wsfulton
            Add support for friend templates, including operator overloading - fixes #196. Considering
            the example below, previously the operator gave a syntax error and friendfunc incorrectly
            warned with:

             "Warning 503: Can't wrap 'friendfunc<(Type)>' unless renamed to a valid identifier."

              template <class Type> class MyClass {
                friend int friendfunc <Type>(double is, MyClass <Type> & x);
                friend int operator<< <Type>(double un, const MyClass <Type> &x);
              };

            The following also previously incorrectly warned with:

              "Warning 302: Identifier 'template_friend' redefined (ignored),"

              template<typename T> T template_friend(T);
              struct MyTemplate {
                template<typename T> friend T template_friend(T);
              };

2015-05-01: wsfulton
            Fix handling of conversion operators where the operator is split over multiple
            lines or has comments within the operator type. Fixes #401.

            Also fix similar problem with normal operators which gave a syntax error if split over
            multiple lines or had a comment within the operator declaration.

2015-04-30: olly
	    Ignore unknown preprocessor directives which are inside an inactive
	    conditional (github issue #394, reported by Dan Wilcox).
	    Regression introduced in 3.0.3.

2015-04-27: vadz
            [Python] Fix "default" typemap used after an argument with "numinputs=0" (#377).

2015-04-24: wsfulton
            [Python] Fix #256. Code generated with '-builtin -modernargs' segfaults for any
            method taking zero arguments.

            Also fixes: "SystemError: error return without exception set" during error checking
            when using just -builtin and the incorrect number of arguments is passed to a class
            method expecting zero arguments.

2015-04-23: wsfulton
            [Java] Bug #386 - Memory leak fix in (char *STRING, size_t LENGTH) typemaps.

2015-04-23: vadz
            [Python] Make "default" typemap work again (#330, #377).

2015-04-23: vadz
            [Python] Fix the use of default values for the pointer types (#365, #376).

2015-04-23: wsfulton
            Fix 'make check-ccache' which is part of 'make check' when one of the CCACHE_
            environment variables, for example CCACHE_DISABLE, is set.

2015-04-14: wsfulton
            Clearer warning message for badly constructed typecheck typemaps. For example, was:

              example.i:3: Warning 467: Overloaded foo(int) not supported (no type checking
              rule for 'int').

            Now:

              example.i:3: Warning 467: Overloaded foo(int) not supported (incomplete type checking
              rule - no precedence level in typecheck typemap for 'int').

2015-04-11: wsfulton
            [Java] Fix #353 - Linker multiple definition of 'ExceptionMatches' when
            using directors and multiple modules.

2015-04-11: wsfulton
            Merge #320 - Make __dict__ accessible for Python builtin classes.

2015-04-07: wsfulton
            Fix #375 - parsing of extern "C" and typedef for example:
              extern "C" typedef void (*Hook2_t)(int, const char *);
              extern "C" typedef int Integer;

2015-03-12: olly
	    -DSWIG_DIRECTOR_STATIC is now supported for all languages with
	    director support, not only Python and PHP.

2015-03-02: ianlancetaylor
	    [Go] Add -cgo option, required for Go versions 1.5 and
	    later.

2015-02-26: olly
	    Fix segmentation fault when top==NULL, introduced by nested class
	    handling (reported in issue#346 by Pawe¿ Tomulik).

2015-02-09: wsfulton
            [Guile] Fix generated code for static const char member variables when
            defined and declared inline.

2015-02-09: mishas
            [Go] Fix %import of files in sub directories.

2015-02-05: ianlancetaylor
            [Go] Ignore Go specific type maps (goin, goout, etc.) if they are empty.

2015-02-05: ianlancetaylor
            [Go] Generated Go code no longer calls _swig_goallocate or
            _swig_makegostring, as they will no longer work as of Go 1.5.

Version 3.0.5 (31 Jan 2015)
===========================

2015-01-30: wsfulton
            [Python] Fix Python -classic and property setting. Setting properties on classic classes
            was broken in swig-3.0.3 by attempting to use __setattr__. This regression is fixed now
            by using __dict__ again when using -classic.
            Fixes patch #232.

2015-01-27: smarchetto
	    [Scilab] Support for the Scilab language has been added

2015-01-23: olly
	    [PHP] When wrapping a returned resource as an object, check if all
	    cases wrap it in the same class, and if so eliminate the pointless
	    switch statement wrapper we previously generated.

2015-01-22: wsfulton
            [Octave] Merge patch #297 for SF bug #1277 - Octave shared_ptr support

2015-01-15: wsfulton
            [Python] Merge patch #250 - Fixes for using %constant and objects (non-primitive types)

2015-01-15: wsfulton
            [C# Go] Merge patch #308 and fix #307 - C++11 strongly typed enum support
            in directors

2015-01-15: wsfulton
            [Python] Second fix for #294 #296 - Regression introduced in SWIG-3.0.3 when
            wrapping functions with default arguments, this time when using kwargs.

Version 3.0.4 (14 Jan 2015)
===========================

2015-01-12: olly
	    [PHP] Fix segfault in director upcall check when using PHP built with
	    ZTS enabled.  Fixes #155, reported by Pierre Labastie.

2015-01-12: vadz
            [Python] Fix #294 #296 - Regression introduced in SWIG-3.0.3 when
            wrapping functions with default arguments. Invalid or missing default
            arguments were sometimes being generated into the python layer.

2015-01-08: olly
	    Allow C++11 "explicit constexpr".  Fixes github issue #284 reported
	    by Pawel Tomulik.  Also handle "constexpr explicit" and "constexpr
	    static".

2015-01-08: olly
	    When reporting an error for a construct which hasn't been
	    terminated when the end of the file is reached, report it at the
	    start line rather than "EOF" as then tools like editors and IDEs
	    will take you to a generally more useful place for fixing the
	    problem.

2015-01-08: olly
	    Improve error messages for a few cases which previously gave the
	    one of the cryptic catch-all errors "Syntax error in input".

2015-01-08: olly
	    Provide -cppext as a general command line option for setting the
	    extension used for generated C++ files (previously it was specific
	    to the PHP backend).  Deprecate the equivalent -suffix option
	    provided by the Ocaml backend, but continue to support that for
	    now.

Version 3.0.3 (30 Dec 2014)
===========================

2014-12-27: wsfulton
            Fix #280 - abort using all default template parameters within other template
            parameters.

2014-12-27: talby
            [Perl] Issue #282 perl5 archlib vs archlibexp
            [Perl] tidy "warning: duplicate 'extern' declaration specifier" when building generated code
            under clang

2014-12-18: wsfulton
            Add support for %constant and structs/classes - issue #272

2014-12-09: wsfulton
            Fix #245 - regression (since swig-3.0.0) in templated constructors.
            Templated constructors could not be instantiated - they were incorrectly ignored with a warning 504:
            "Function: xyz must have a return type. Ignored."

2014-12-07: wsfulton
            Add support for C++11 strongly typed enumerations.

2014-11-21: wsfulton
            [Java C#] Fix multiply defined error when using %rename of enum items when using the "simple enum"
            wrappers.

2014-10-28: vadz
            [Python] Patch #201 The generated .py file no longer uses *args for all Python parameters.
            Instead, the parameters are named using the C++ parameter names.

            "compactdefaultargs" feature can be enabled to restore the old behaviour.

            *** POTENTIAL INCOMPATIBILITY ***

2014-10-24: timotheecour
            [D] Patch #204 Use core.atomic.atomicOp to mutate shared variables

2014-10-21: wsfulton
            Fix issue #242 - Use of the "kwargs" feature no longer automatically turns on the
            "compactdefaultargs" feature if the target language does not support kwargs.
            This change affects all languages except Python and Ruby.

            *** POTENTIAL INCOMPATIBILITY  ***

2014-10-10: diorcety
            [Python] Patch #232 Fix property access using directors

2014-10-06: wsfulton
            [Python] Fixes when using -builtin and std::vector/std::list wrappers to allow deletion
            of single elements, such as 'del vec[0]'.

2014-09-30: oliverb
            [Javascript] Merge patch #216 by Richie765 - Added support for many versions of v8 javascript.

2014-09-30: oliverb
            [Javascript] Merge patch #195 by zittix - Fixed JSClassRef declaration not using the static one.

2014-09-30: ianlancetaylor
	    [Go] In configure script, require Go 1.1 or later.

2014-09-30: wsfulton
            [Python] Patch #207 - Fix No module error with -relativeimport when using single
            header file import.

2014-09-27: wsfulton
            Patch #208 - Initialise newly created array when using array_functions in the
            carrays.i library (C++ usage).

2014-09-27: wsfulton
            [Ruby] Patch #187 - Fix crash on shutdown of the Ruby interpreter if more than one
            module was loaded at a time when data is being shared between modules.

2014-09-27: wsfulton
            [Java] Patch #168 - Fix leak in Java director string handling after the Java
            upcall when called from a native thread.

2014-09-25: ianlancetaylor
	    [Go] Adjust generated code to work with upcoming Go 1.4
	    release.

2014-09-23: wsfulton
            [Python] Add patch from Thomas Maslach to fix crash in wrappers when using -threads in
            the STL iterators (SwigPyIterator destructor).

2014-09-17: wsfulton
            [C#] Merge patch #229 from contre - Add bool array types to arrays_csharp.i

2014-09-12: olly
	    [PHP] Add support for specifying any PHP interfaces a wrapped class
	    implements, e.g.: %typemap("phpinterfaces") MyIterator "Iterator"

2014-09-11: olly
	    [PHP] Fix throwing a PHP exception through C++ from a subclassed
	    director method - PHP NULL gets returned by the subclassed method
	    in this case, so the directorout typemap needs to allow that (at
	    least if an exception is active).

2014-09-09: ianlancetaylor
	    [Go] Add goargout typemap.

2014-09-09: olly
	    [PHP] Fix segmentation faults with directors in PHP >= 5.4, and
	    reenable runme tests for director_basic testcase.  Fix from
	    pavel-charvat in issue#164.

2014-09-05: ianlancetaylor
	    [Go] Add imtype, goin, goout, godirectorin, and
	    godirectorout typemaps, to support writing Go code to
	    convert between types.

2014-09-02: olly
	    [Python] Fix regression in indentation of python code produced with
	    -modern, introduced by changes in #188.  Reported by fabiencastan
	    in #218.

2014-09-01: olly
	    Issue an error for unknown SWIG preprocessor directives, rather
	    than quietly ignoring them.  Reported by jrhelsey in issue#217.

            *** POTENTIAL INCOMPATIBILITY  ***

2014-08-15: talby
            [Perl] Include guard fix for nested modules from Anthony Heading (SF Patch #350).

2014-08-04: wsfulton
            [C#] Merge patch #200 from gpetrou - Changed CSharp license header to include auto-generated
            tag so that StyleCop ignores the files.

2014-08-04: wsfulton
            [Java] Merge patch #198 from Yuval Kashtan - Support for java.nio.ByteBuffer mapping to
            unsigned char * in various.i in NIOBUFFER typemaps.

2014-07-14: ianlancetaylor
	    [Go] Change struct definition to use void *, not uint8, so
	    that the type is recorded as possibly containing
	    pointers.  This ensures that the 1.3 garbage collector
	    does not collect pointers passed to C++ code.

2014-07-01: wsfulton
            Fix SF Bug #1375 - Expansion of the $parentclassname special variable incorrectly contains
            brackets in the expanded name.

Version 3.0.2 (4 Jun 2014)
==========================

2014-06-02: v-for-vandal
            [Lua] Pull request #176:
            If class has no __eq implemented, then default __eq is generated. 
            Default __eq compares actual pointers stored inside Lua userdata.

2014-06-02: vkalinin
            Fix #183 - %extend and unnamed nested structs

2014-05-28: kwwette
            Fix install failure when using an 'out of source' build using the shipped
            tarball - regression introduced in swig-3.0.1.

2014-05-24: kwwette
            [Octave] Remove deprecated -global/-noglobal command-line arguments

            *** POTENTIAL INCOMPATIBILITY  ***

Version 3.0.1 (27 May 2014)
===========================

2014-05-25: hfalcic
	    [Python] Python 3 byte string output: use errors="surrogateescape"
            if available on the version of Python that's in use. This allows
            obtaining the original byte string (and potentially trying a fallback
            encoding) if the bytes can't be decoded as UTF-8.

            Previously, a UnicodeDecodeError would be raised with no way to treat
            the data as bytes or try another codec.

2014-05-18: vkalinin
	    Bug #175 - Restore %extend to work for unnamed nested structures by using a C
            symbol comprising the outer structure name and unnamed variable instance name.

2014-05-15: kwwette
	    Add #166 - 'make check' now works out of source. This required the examples to build
            out of source. The main languages have been tested - C#, Go, Guile, Java, Javascript,
            Lua, Octave, Perl, PHP, Python, Ruby and Tcl.

2014-05-01: Oliver Buchtala
	    Javascript support added, see Javascript chapter in the documentation.

2014-05-01: olly
	    [PHP] The generated __isset() method now returns true for read-only properties.

2014-04-24: kwwette
            [Go] Fix go ./configure parsing of gccgo --version, and
            goruntime.swg typo in __GNUC_PATCHLEVEL__ (SF Bug #1298)

2014-04-24: kwwette
            Fix {python|perl5|ruby|tcl}/java examples

            In Lib/gcj/cni.i, for compatibility with newer gcj versions:

            - remove JvAllocObject() which gcj no longer defines, from gcj Changelog:
              2004-04-16  Bryce McKinlay  <mckinlay@redhat.com>
                * gcj/cni.h (JvAllocObject): Remove these obsolete,
                undocumented CNI calls.

            - change JvCreateJavaVM() argument from void* to JvVMInitArgs*, from gcj Changelog:
              2005-02-23  Thomas Fitzsimmons  <fitzsim@redhat.com>
              PR libgcj/16923
              ...
              (JvCreateJavaVM): Declare vm_args as JvVMInitArgs* rather than void*.

            *** POTENTIAL INCOMPATIBILITY  ***

2014-04-08: wsfulton
            SF Bug #1366 - Remove duplicate declarations of strtoimax and strtoumax in inttypes.i

2014-04-08: wsfulton
            [Java C#] Enums which have been ignored via %ignore and are subsequently
            used are handled slightly differently. Type wrapper classes are now generated
            which are effectively a wrapper of an empty enum. Previously in Java uncompilable
            code was generated and in C# an int was used.

2014-04-04: wsfulton
            Fix regression in 3.0.0 where legal code following an operator<< definition might
            give a syntax error. SF Bug #1365.

2014-04-03: olly
	    [PHP] Fix wrapping director constructors with default parameters
	    with a ZTS-enabled build of PHP.

2014-04-02: olly
	    [PHP] Pass the ZTS context we already have to avoid needing to
	    call TSRMLS_FETCH, which is relatively expensive.

2014-04-02: olly
	    [PHP] Pass ZTS context through to t_output_helper() so it works
	    with a ZTS-enabled build of PHP.  Reported by Pierre Labastie in
	    github PR#155.

2014-03-28: wsfulton
            [Java C# D Go] Fixes for C enums used in an API and the definition of the enum
            has not been parsed. For D, this fixes a segfault in SWIG. The other languages
            now produce code that compiles, although the definition of the enum is needed
            in order to use the enum properly from the target language.

2014-03-23: v-for-vandal
            [Lua] Fix for usage of snprintf in Lua runtime which Visual Studio does not have.

Version 3.0.0 (16 Mar 2014)
===========================

2014-03-16: wsfulton
            C++11 support initially developed as C++0x support by Matevz Jekovec as a Google Summer of Code
            project has been further extended. The C++11 support is comprehensive, but by no means complete
            or without limitations. Full details for each new feature in C++11 is covered in the
            CPlusPlus11.html chapter in the documentation which is included in SWIG and also available
            online at https://www.swig.org/Doc3.0/CPlusPlus11.html.

2014-03-14: v-for-vandal
            [Lua] Numerous Lua improvements:
            1. %nspace support has been added. Namespaces are mapped to tables in the module, with the same
               name as the C++ namespace.
            2. Inheritance is now handled differently. Each class metatable keeps a list of class bases instead
               of merging all members of all bases into the derived class.
            3. The new metatables result in differences in accessing class members. For example:

                 %module example
                 struct Test {
                     enum { TEST1 = 10, TEST2 = 20 };
                     static const int ICONST = 12;
                 };

                 Now this can be used as follows:
                   print(example.Test.TEST1)
                   print(example.Test.ICONST)
                 The old way was:
                   print(example.Test_TEST1)
                   print(example.Test_ICONST)

            4. The special class metatable member ".constructor" was removed. Now SWIG generates the proxy
               function by itself and assigns it directly to the class table "__call" method.
            5. eLua should also now support inheritance.
            6. 'const' subtable in eLua is considered deprecated.

            Changes in behaviour:
            a. You can no longer assign to non-existing class members in classes without a __setitem__ method.
               It will cause a Lua error.
            b. You can no longer iterate over a module table and copy everything into the global namespace.
               Actually, this was never the case, but it is now explicitly prohibited.
            c. Now changing a base class will immediately affect all derived classes.
            d. There might be some issues with inheritance. Although the bases iteration scheme is the same
               as was used for merging base classes into derived one, some unknown issues may arise.

            The old metatable behaviour can be restored by using the -no-old-metatable-bindings option.

            *** POTENTIAL INCOMPATIBILITY  ***

2014-03-06: wsfulton
            [Python] Change in default behaviour wrapping C++ bool. Only a Python True or False
            will now work for C++ bool parameters. This fixes overloading bool with other types.
            Python 2.3 minimum is now required for wrapping bool.

            When wrapping:

              const char* overloaded(bool value) { return "bool"; }
              const char* overloaded(int value) { return "int"; }

            Previous behaviour:
              >>> overloaded(False)
              'int'
              >>> overloaded(True)
              'int'
              >>> overloaded(0)
              'int'

            Now we get the expected behaviour:
              >>> overloaded(False)
              'bool'
              >>> overloaded(0)
              'int'

            The consequence is when wrapping bool in non-overloaded functions:

              const char* boolfunction(bool value) { return value ? "true" : "false"; }

            The previous behaviour was very Pythonic:
              >>> boolfunction("")
              'false'
              >>> boolfunction("hi")
              'true'
              >>> boolfunction(12.34)
              'true'
              >>> boolfunction(0)
              'false'
              >>> boolfunction(1)
              'true'

            Now the new behaviour more along the lines of C++ due to stricter type checking. The
            above calls result in an exception and need to be explicitly converted into a bool as
            follows:
              >>> boolfunction(0)
              Traceback (most recent call last):
                File "<stdin>", line 1, in <module>
              TypeError: in method 'boolfunction', argument 1 of type 'bool'
              >>> boolfunction(bool(0))
              'false'

            The old behaviour can be resurrected by passing the -DSWIG_PYTHON_LEGACY_BOOL command line
            parameter when executing SWIG. Typemaps can of course be written to customise the behaviour
            for specific parameters.

            *** POTENTIAL INCOMPATIBILITY  ***

2014-03-06: wsfulton
	    Fix SF Bug #1363 - Problem with method overloading when some methods are added by %extend
            and others are real methods and using template default parameters with smart pointers.
            This is noticeable as a regression since 2.0.12 when using the default smart pointer
            handling for some languages when the smart pointer wraps std::map and other STL containers.

2014-03-02: wsfulton
	    [Python] SF Patch #346 from Jens Krueger. Correct exception thrown attempting to
            access a non-existent C/C++ global variable on the 'cvar' object. The exception thrown
            used to be a NameError. However, as this access is via a primary, an AttributeError
            is more correct and so the exception thrown now is an AttributeError. Reference:
            http://docs.python.org/2/reference/expressions.html#attribute-references

            *** POTENTIAL INCOMPATIBILITY  ***

2014-03-01: wsfulton
	    [Python] Patch #143 Fix type shown when using type() to include the module and package
            name when using -builtin.

2014-03-01: wsfulton
	    [Python] SF patch #347 Fix missing argument count checking with -modern.
            Fixes regression introduced when builtin changes were introduced in SWIG-2.0.3.

2014-02-21: wsfulton
	    [PHP] Fix warning suppression using %warnfilter for PHP reserved class names.

2014-02-19: olly
	    [Lua] Add keyword warnings for Lua keywords and Basic Functions.

2014-02-19: olly
	    -Wallkw now includes keywords for all languages with keyword
	    warnings (previously Go and R were missing).

2014-02-19: olly
	    [PHP] Update the lists of PHP keywords with new ones from PHP 5.4
	    and newer (and some missing ones from 5.3).  Reserved PHP constants
	    names are now checked against enum values and constants, instead
	    of against function and method names.  Built-in PHP function names
	    no longer match methods added by %extend.  Functions and methods
	    named '__sleep', '__wakeup', 'not', 'parent', or 'virtual' are no
	    longer needlessly renamed.

2014-02-15: wsfulton
	    Fix the %$ismember %rename predicates to also apply to members added via %extend.

            Add %$isextendmember for %rename of members added via %extend. This can be used to
            distinguish between normal class/struct members and %extend members. For example
            '%$ismember, %$not %$isextendmember' will now identify just class/struct members.

            *** POTENTIAL INCOMPATIBILITY  ***

2014-02-16: hfalcic
            [Python] Patch #137 - fix crashes/exceptions in exception handling in Python 3.3

2014-02-15: wsfulton
            [Java] Add support for the cdata library.

2014-02-08: vkalinin
            Nested class support added. This primarily allows SWIG to properly parse nested
            classes and keep the nested class information in the parse tree. Java and C#
            have utilised this information wrapping the C++ nested classes as Java/C#
            nested classes. The remaining target languages ignore nested classes as in
            previous versions. Help is needed by users of these remaining languages to
            design how C++ nested classes can be best wrapped. Please talk to us on the
            swig-devel mailing list if you think you can help.

            Previously, there was limited nested class support. Nested classes were treated
            as opaque pointers. However, the "nestedworkaround" feature provided a way to
            wrap a nested class as if it was a global class. This feature no longer exists
            and is replaced by the new "flatnested" feature. This effectively does the same
            thing with less manual code to be written. Please see the 'Nested classes'
            section in the documentation in SWIGPlus.html if you were previously using this
            feature.

            SWIG now parses the contents of nested classes where previously it did not. You
            may find that you will need to make adjustments to your interface file as
            effectively extra code is being wrapped.

            *** POTENTIAL INCOMPATIBILITY  ***

2014-02-06: gjanssens
            [Guile] Patch #133. Make scm to string conversion work with non-ascii strings.
            Guile 2 has a completely rewritten string implementation. SWIG made some assumptions
            that are no longer valid as to the internals of guile's string representation.

2014-01-30: wsfulton
            [C#] Add new swigtype_inout.i library containing SWIGTYPE *& OUTPUT typemaps.

            Example usage wrapping:

              void f(XXX *& x) { x = new XXX(111); }

            would be:

              XXX x = null;
              f(out x);
              // use x
              x.Dispose(); // manually clear memory or otherwise leave out and leave it to the garbage collector

2014-01-21: ianlancetaylor
	    [Go] Add %go_import directive.

2014-01-21: ianlancetaylor
	    [Go] Add support for Go 1.3, not yet released.

2014-01-20: wsfulton
            Director exceptions (Swig::DirectorException) now derive from std::exception
            and hence provide the what() method. In Python and Ruby, this replaces the now
            deprecated DirectorException::getMessage() method.

2014-01-14: diorcety
            Patch #112 - Fix symbol resolution involving scopes that have multiple levels
            of typedefs - fixes some template resolutions as well as some typemap searches.

2014-01-11: wsfulton
            Fix and document the naturalvar feature override behaviour - the naturalvar
            feature attached to a variable name has precedence over the naturalvar
            feature attached to the variable's type. The overriding was not working
            when turning the feature off on the variable's name.

            Fix so that any use of the naturalvar feature will override the global
            setting. Previously when set globally by -naturalvar or %module(naturalvar=1),
            use of the naturalvar feature was not always honoured.

2014-01-06: ianlancetaylor
	    [Go] Fix bug that broke using directors from a thread not
	    created by Go.

2013-12-24: ptomulik
            [Python] SF Bug #1297

            Resolve several issues related to python imports.
            For example, it's now possible to import modules having the same module
            names, but belonging in different packages.
            
            From the user's viewpoint, this patch gives a little bit more control on
            import statements generated by SWIG. The user may choose to use relative
            or absolute imports.
            
            Some details:
              - we (still) generate import statements in the form 'import a.b.c' which
                corresponds to absolute imports in python3 and (the only available)
                ambiguous one in python2.
              - added -relativeimport option to use explicit relative import syntax
                (python3),

            The "Python Packages" section in the documentation discusses how to work
            with importing packages including the new -relativeimport command line option.

2013-12-23: vadz
            [Octave, Perl, Python, R, Ruby, Tcl] Change the length of strings created from fixed-size char
            buffers in C code.

            This is a potential backwards compatibility break: a "char buf[5]" containing "ho\0la" was
            returned as a string of length 5 before, but is returned as a string of length 2 now. Also,
            it was possible to assign a (non-NUL-terminated) string "hello" to such a buffer before but
            now this fails and only "helo" can fit.

            Apply "char FIXSIZE[ANY]" typemaps to explicitly choose the old behaviour.

            *** POTENTIAL INCOMPATIBILITY  ***

2013-12-23: talby
            [Perl] Add support for directors.

2013-12-18: ianlancetaylor
	    [Go] Don't require that Go environment variables be set
	    when running examples or testsuite when using Go 1 or
	    later.

2013-12-17: ianlancetaylor
	    [Go] Remove -longsize option (for backward compatibility,
	    ignore it if seen).

2013-12-17: ianlancetaylor
	    [Go] Add -go-pkgpath option.

2013-12-16: ianlancetaylor
	    [Go] Update for Go 1.2 release.  Add support for linking
	    SWIG code directly into executable, rather than using a
	    shared library.

2013-12-13: ianlancetaylor
	    [Go] Add SWIG source file name as comments in generated
	    files.  This can be used by Go documentation tools.

2013-12-12: jleveque
	    [Lua] Fix typo (wchar instead of wchar_t) which made wchar.i
	    for Lua useless.

2013-12-12: vmiklos
	    [PHP] PHP's peculiar call-time pass-by-reference feature was
	    deprecated in PHP 5.3 and removed in PHP 5.4, so update the REF
	    typemaps in phppointers.i to specify pass-by-reference in the
	    function definition.  Examples/php/pointer has been updated
	    accordingly.

2013-12-12: olly
	    [PHP] The usage of $input in PHP directorout typemaps has been
	    changed to be consistent with other languages.  The typemaps
	    provided by SWIG have been updated accordingly, but if you
	    have written your own directorout typemaps, you'll need to
	    update $input to &$input (or make equivalent changes).

            *** POTENTIAL INCOMPATIBILITY  ***

2013-11-27: vadz
            [C#, Java, Python] Add std_auto_ptr.i defining typemaps for returning std::auto_ptr<>.

2013-11-09: wsfulton
            [C#] Apply patch #79 from Brant Kyser
              - Remove using directives from the generated C# code and fully qualify the use of all .NET
                framework types in order to minimize potential name collisions from input files defining
                types, namespace, etc with the same name as .NET framework members.
              - Globally qualify the use of .NET framework types in the System namespace
              - Remove .NET 1.1 support, .NET 2 is the minimum for the C# module

            This is a potential backwards compatibility break if code has been added relying on these using
            statements that used to be generated:

              using System;
              using System.Runtime.InteropServices;

            The quick fix to add these back in is to add the -DSWIG2_CSHARP command line option when
            executing SWIG. See CSharp.html documentation for more info.

            *** POTENTIAL INCOMPATIBILITY  ***

2013-11-05: wsfulton
            [Java] Fix some corner cases for the $packagepath/$javaclassname special variable substitution.

2013-11-05: wsfulton
            [Java] Apply patch #91 from Marvin Greenberg - Add director:except feature for improved
            exception handling in director methods for Java.

2013-10-15: vadz
            Allow using \l, \L, \u, \U and \E in the substitution part of %(regex:/pattern/subst/)
            inside %rename to change the case of the text being replaced.

2013-10-12: wsfulton
            [CFFI] Apply #96 - superclass not lispify

2013-10-12: wsfulton
            Merge in C++11 support from the gsoc2009-matevz branch where Matevz Jekovec first
            started the C++0x additions. Documentation of the C++11 features supported is in a
            new Chapter of the documentation, "SWIG and C++11" in Doc/Manual/CPlusPlus11.html.

2013-10-04: wsfulton
            Fix %naturalvar not having any affect on templated classes instantiated with an
            enum as the template parameter type. Problem reported by Vadim Zeitlin.

2013-09-20: wsfulton
            [Java] Fix a memory leak for the java char **STRING_ARRAY typemaps.

Version 2.0.12 (9 Feb 2014)
===========================

2014-01-16: wsfulton
            [PHP] Fix compilation error in ZTS mode (64 bit windows) due to incorrect placement
            of TSRMLS_FETCH() in SWIG_Php_GetModule() as reported by Mark Dawson-Butterworth.

2014-01-13: kwwette
            [Octave] update support to Octave version 3.8.0

            - Octave 3.8.0 no longer defines OCTAVE_API_VERSION_NUMBER, but 3.8.1
              will define OCTAVE_{MAJOR,MINOR,PATCH}_VERSION instead: see
                http://hg.savannah.gnu.org/hgweb/octave/rev/b6b6e0dc700e
              So we now use a new macro SWIG_OCTAVE_PREREQ(major,minor,patch) to
              enable features requiring Octave version major.minor.patch or later.

              For Octave versions prior to 3.8.1, we reconstruct values for
              OCTAVE_{MAJOR,MINOR,PATCH}_VERSION based on OCTAVE_API_VERSION_NUMBER,
              extracted from Octave's ChangeLogs. An additional hack is needed to
              distinguish between Octave <= 3.2.x and 3.8.0, neither of which define
              OCTAVE_API_VERSION_NUMBER.

            - Octave 3.8.0 deprecates symbol_table::varref(), so remove its use
              for this and future versions of Octave.

            - Octave 3.8.0 removes octave_value::is_real_nd_array(), used in
              octave_swig_type::dims(). Its use is not required here, so remove it.

            - Retested against Octave versions 3.0.5, 3.2.4, 3.4.3, 3.6.4, and 3.8.0.

            - Updated Octave documentation with tested Octave versions, and added a
              warning against using versions <= 3.x.x, which are no longer tested.

2013-12-22: wsfulton
            C++11 support for new versions of erase and insert in the STL containers.

            The erase and insert methods in the containers use const_iterator instead
            of iterator in C++11.  There are times when the methods wrapped must match
            the parameters exactly. Specifically when full type information for
            template types is missing or SWIG fails to look up the type correctly,
            for example:

              %include <std_vector.i>
              typedef float Real;
              %template(RealVector) std::vector<Real>;

            SWIG does not find std::vector<Real>::iterator because %template using
            typedefs does not always work and so SWIG doesn't know if the type is
            copyable and so uses SwigValueWrapper<iterator> which does
            not support conversion to another type (const_iterator). This resulted
            in compilation errors when using the C++11 version of the containers.

            Closes #73

2013-10-17: wsfulton
            [R] Fix SF #1340 - Visual Studio compile error in C++ wrappers due to #include <exception>
            within extern "C" block.

2013-10-17: wsfulton
            [Python] Fix SF #1345 - Missing #include <stddef.h> for offsetof when using -builtin.

2013-10-12: wsfulton
            [Lua] Apply #92 - missing return statements for SWIG_Lua_add_namespace_details()
            and SWIG_Lua_namespace_register().

Version 2.0.11 (15 Sep 2013)
============================

2013-09-15: wsfulton
            [R] Fix attempt to free a non-heap object in OUTPUT typemaps for:
              unsigned short *OUTPUT
              unsigned long *OUTPUT
              signed long long *OUTPUT
              char *OUTPUT
              signed char*OUTPUT
              unsigned char*OUTPUT

2013-09-12: wsfulton
            [Lua] Pull Git patch #62.
              1) Static members and static functions inside class can be accessed as
                 ModuleName.ClassName.FunctionName (MemberName respectively). Old way such as
                 ModuleName.ClassName_FunctionName still works.
              2) Same goes for enums inside classes: ModuleName.ClassName.EnumValue1 etc.

2013-09-12: wsfulton
            [UTL] Infinity is now by default an acceptable value for type 'float'. This fix makes
            the handling of type 'float' and 'double' the same. The implementation requires the
            C99 isfinite() macro, or otherwise some platform dependent equivalents, to be available.

            Users requiring the old behaviour of not accepting infinity, can define a 'check' typemap
            wherever a float is used, such as:

              %typemap(check,fragment="<float.h>") float, const float & %{
                if ($1 < -FLT_MAX || $1 > FLT_MAX) {
                  SWIG_exception_fail(SWIG_TypeError, "Overflow in type float");
                }
              %}

            *** POTENTIAL INCOMPATIBILITY  ***

2013-08-30: wsfulton
            [Lua] Pull Git patch #81: Include Lua error locus in SWIG error messages.  
            This is standard information in Lua error messages, and makes it much
            easier to find bugs.

2013-08-29: wsfulton
            Pull Git patch #75: Handle UTF-8 files with BOM at beginning of file. Was giving an
            'Illegal token' syntax error.

2013-08-29: wsfulton
            [C#] Pull Git patch #77: Allow exporting std::map using non-default comparison function.

2013-08-28: wsfulton
            [Python] %implicitconv is improved for overloaded functions. Like in C++, the methods
            with the actual types are considered before trying implicit conversions. Example:

              %implicitconv A;
              struct A {
                A(int i);
              };
              class CCC {
                public:
                  int xx(int i) { return 11; }
                  int xx(const A& i) { return 22; }
              };

            The following python code:

              CCC().xx(-1)

            will now return 11 instead of 22 - the implicit conversion is not done.

2013-08-23: olly
	    [Python] Fix clang++ warning in generated wrapper code.

2013-08-16: wsfulton
            [Python] %implicitconv will now accept None where the implicit conversion takes a C/C++ pointer.
            Problem highlighted by Bo Peng. Closes SF patch #230.

2013-08-07: wsfulton
            [Python] SF Patch #326 from Kris Thielemans - Remove SwigPyObject_print and SwigPyObject_str and
            make the generated wrapper use the default python implementations, which will fall back to repr
            (for -builtin option).

            Advantages:
            - it avoids the swig user having to jump through hoops to get print to work as expected when
              redefining repr/str slots.
            - typing the name of a variable on the python prompt now prints the result of a (possibly redefined)
              repr, without the swig user having to do any extra work.
            - when redefining repr, the swig user doesn't necessarily have to redefine str as it will call the
              redefined repr
            - the behaviour is exactly the same as without the -builtin option while requiring no extra work
              by the user (aside from adding the %feature("python:slot...) statements of course)

            Disadvantage:
            - default str() will give different (but clearer?) output on swigged classes

2013-07-30: wsfulton
            [Python, Ruby] Fix #64 #65: Missing code in std::multimap wrappers. Previously an instantiation
            of a std::map was erroneously required in addition to an instantiation of std::multimap with the
            same template parameters to prevent compilation errors for the wrappers of a std::multimap.

2013-07-14: joequant
            [R] Change types file to allow for SEXP return values

2013-07-05: wsfulton
            [Python] Add %pythonbegin directive which works like %pythoncode, except the specified code is
            added at the beginning of the generated .py file. This is primarily needed for importing from
            __future__ statements required to be at the very beginning of the file. Example:

              %pythonbegin %{
              from __future__ import print_function
              print("Loading", "Whizz", "Bang", sep=' ... ')
              %}

2013-07-01: wsfulton
            [Python] Apply SF patch #340 - Uninitialized variable fix in SWIG_Python_NonDynamicSetAttr
            when using -builtin.

2013-07-01: wsfulton
            [Python, Ruby, Ocaml] Apply SF patch #341 - fix a const_cast in generated code that was generating
            a <:: digraph when using the unary scope operator (::) (global scope) in a template type.

2013-07-01: wsfulton
            [Python] Add SF patch #342 from Christian Delbaere to fix some director classes crashing on
            object deletion when using -builtin. Fixes SF bug #1301.

2013-06-11: wsfulton
            [Python] Add SWIG_PYTHON_INTERPRETER_NO_DEBUG macro which can be defined to use the Release version
            of the Python interpreter in Debug builds of the wrappers. The Visual Studio .dsp example
            files have been modified to use this so that Debug builds will now work without having
            to install or build a Debug build of the interpreter.

2013-06-07: wsfulton
	    [Ruby] Git issue #52. Fix regression with missing rb_complex_new function for Ruby
            versions prior to 1.9 using std::complex wrappers if just using std::complex as an output type.
            Also fix the Complex helper functions external visibility (to static by default).

2013-06-04: olly
	    [PHP] Fix SWIG_ZTS_ConvertResourcePtr() not to dereference NULL
	    if the type lookup fails.

Version 2.0.10 (27 May 2013)
============================

2013-05-25: wsfulton
            [Python] Fix Python 3 inconsistency when negative numbers are passed
            where a parameter expects an unsigned C type. An OverFlow error is
            now consistently thrown instead of a TypeError.

2013-05-25: Artem Serebriyskiy
            SVN Patch ticket #338 - fixes to %attribute macros for template usage
            with %arg.

2013-05-19: wsfulton
            Fix ccache-swig internal error bug due to premature file cleanup.

            Fixes SF bug 1319 which shows up as a failure in the ccache tests on
            Debian 64 bit Wheezy, possibly because ENABLE_ZLIB is defined.

            This is a corner case which will be hit when the maximum number of files
            in the cache is set to be quite low (-F option), resulting in a cache miss.

2013-05-09: kwwette
            [Octave] Fix bugs in Octave module loading:
            - fix a memory leak in setting of global variables
            - install functions only once, to speed up module loads

2013-04-28: gjanssens
            [Guile] Updates in guile module:
            - Add support for guile 2.0
            - Drop support for guile 1.6
            - Drop support for generating wrappers using guile's gh interface.
              All generated wrappers will use the scm interface from now on.
            - Deprecate -gh and -scm options. They are no longer needed.
              A warning will be issued when these options are still used.
            - Fix all tests and examples to have a successful travis test

2013-04-18: wsfulton
            Apply Patch #36 from Jesus Lopez to add support for $descriptor() special variable macro expansion 
            in fragments. For example:

              %fragment("nameDescriptor", "header")
              %{
                static const char *nameDescriptor = "$descriptor(Name)";
              %}

            which will generate into the wrapper if the fragment is used:

              static const char *nameDescriptor = "SWIGTYPE_Name";

2013-04-18: wsfulton
            Fix SF Bug #428 - Syntax error when preprocessor macros are defined inside of enum lists, such as:

              typedef enum {
                eZero = 0
              #define ONE 1
              } EFoo;

            The macros are silently ignored.

2013-04-17: wsfulton
            [C#] Pull patch #34 from BrantKyser to fix smart pointers in conjunction with directors.

2013-04-15: kwwette
            [Octave] Fix bugs in output of cleanup code.
            - Cleanup code is now written also after the "fail:" label, so it will be called if
              a SWIG_exception is raised by the wrapping function, consistent with other modules.
            - Octave module now also recognises the "$cleanup" special variable, if needed.

2013-04-08: kwwette
            Add -MP option to SWIG for generating phony targets for all dependencies.
            - Prevents make from complaining if header files have been deleted before
              the dependency file has been updated.
            - Modelled on similar option in GCC.

2013-04-09: olly
	    [PHP] Add missing directorin typemap for char* and char[] which
	    fixes director_string testcase failure.

2013-04-05: wsfulton
            [Ruby] SF Bug #1292 - Runtime fixes for Proc changes in ruby-1.9 when using STL
            wrappers that override the default predicate, such as:

              %template(Map) std::map<swig::LANGUAGE_OBJ, swig::LANGUAGE_OBJ, swig::BinaryPredicate<> >;

2013-04-05: wsfulton
            [Ruby] SF Bug #1159 - Correctly check rb_respond_to call return values to fix some
            further 1.9 problems with functors and use of Complex wrappers.

2013-04-02: wsfulton
            [Ruby] Runtime fixes for std::complex wrappers for ruby-1.9 - new native Ruby complex numbers are used.

2013-03-30: wsfulton
            [Ruby] Fix seg fault when using STL containers of generic Ruby types, GC_VALUE or LANGUAGE_OBJECT,
            on exit of the Ruby interpreter. More frequently observed in ruby-1.9.

2013-03-29: wsfulton
            [Ruby] Fix delete_if (reject!) for the STL container wrappers which previously would
            sometimes seg fault or not work.

2013-03-25: wsfulton
            [Python] Fix some undefined behaviour deleting slices in the STL containers.

2013-03-19: wsfulton
            [C#, Java, D] Fix seg fault in SWIG using directors when class and virtual method names are
            the same except being in different namespaces when the %nspace feature is not being used.

2013-02-19: kwwette
            Fix bug in SWIG's handling of qualified (e.g. const) variables of array type. Given the typedef
              a(7).q(volatile).double myarray     // typedef volatile double[7] myarray;
            the type
              q(const).myarray                    // const myarray
            becomes
              a(7).q(const volatile).double       // const volatile double[7]
            Previously, SwigType_typedef_resolve() produces the type
              q(const).a(7).q(volatile).double    // non-sensical type
            which would never match %typemap declarations, whose types were parsed correctly.
            Add typemap_array_qualifiers.i to the test suite which checks for the correct behaviour.

2013-02-18: wsfulton
            Deprecate typedef names used as constructor and destructor names in %extend. The real
            class/struct name should be used.

              typedef struct tagEStruct {
                int ivar;
              } EStruct;

              %extend tagEStruct {
                EStruct() // illegal name, should be tagEStruct()
                {
                  EStruct *s = new EStruct();
                  s->ivar = ivar0;
                  return s;
                }
                ~EStruct() // illegal name, should be ~tagEStruct()
                {
                  delete $self;
                }
              }

            For now these trigger a warning:

              extend_constructor_destructor.i:107: Warning 522: Use of an illegal constructor name 'EStruct' in
              %extend is deprecated, the constructor name should be 'tagEStruct'.
              extend_constructor_destructor.i:111: Warning 523: Use of an illegal destructor name 'EStruct' in
              %extend is deprecated, the destructor name should be 'tagEStruct'.

            These %extend destructor and constructor names were valid up to swig-2.0.4, however swig-2.0.5 ignored
            them altogether for C code as reported in SF bug #1306. The old behaviour of using them has been
            restored for now, but is officially deprecated. This does not apply to anonymously defined typedef
            classes/structs such as:

              typedef struct {...} X;

2013-02-17: kwwette
            When generating functions provided by %extend, use "(void)" for no-argument functions
            instead of "()". This prevents warnings when compiling with "gcc -Wstrict-prototypes".

2013-02-17: kwwette
            [Octave] Minor fix to autodoc generation: get the right type for functions returning structs.

2013-02-15: wsfulton
            Deprecate typedef names used in %extend that are not the real class/struct name. For example:

              typedef struct StructBName {
                int myint;
              } StructB;

              %extend StructB {
                void method() {}
              }

            will now trigger a warning:

              swig_extend.i:19: Warning 326: Deprecated %extend name used - the struct name StructBName
              should be used instead of the typedef name StructB.

            This is only partially working anyway (the %extend only worked if placed after the class
            definition). 

2013-02-09: wsfulton
            [CFFI] Apply patch #22 - Fix missing package before &body

2013-01-29: wsfulton
            [Java] Ensure 'javapackage' typemap is used as it stopped working from version 2.0.5.

2013-01-28: wsfulton
            [Python] Apply patch SF #334 - Fix default value conversions "TRUE"->True, "FALSE"->False.

2013-01-28: wsfulton
            [Java] Apply patch SF #335 - Truly ignore constructors in directors with %ignore.

2013-01-18: Brant Kyser
            [Java] Patch #15 - Allow the use of the nspace feature without the -package commandline option.
            This works as long and the new jniclasspackage pragma is used to place the JNI intermediate class
            into a package and the nspace feature is used to place all exposed types into a package.

2013-01-15: wsfulton
            Fix Visual Studio examples to work when SWIG is unzipped into a directory containing spaces.

2013-01-15: wsfulton
            [C#] Fix cstype typemap lookup for member variables so that a fully qualified variable name
            matches. For example:
              %typemap(cstype) bool MVar::mvar "MyBool"
              struct MVar {
                bool mvar;
              };

2013-01-11: Brant Kyser
	    [Java, C#, D] SF Bug #1299 - Fix generated names for when %nspace is used on
            classes with the same name in two different namespaces.

2013-01-11: Vladimir Kalinin
	    [C#] Add support for csdirectorin 'pre', 'post' and 'terminator' attributes.

2013-01-08: olly
	    [PHP] Fix to work with a ZTS build of PHP (broken in 2.0.7).

2013-01-07: olly
	    Fix bashism in configure, introduced in 2.0.9.

2013-01-06: wsfulton
            Pull patch #4 from ptomulik to fix SF Bug #1296 - Fix incorrect warning for virtual destructors
            in templates, such as:
             Warning 521: Illegal destructor name B< A >::~B(). Ignored.

2013-01-05: wsfulton
            [Python] Pull patch #3 from ptomulik to fix SF Bug #1295 - standard exceptions as
            classes using the SWIG_STD_EXCEPTIONS_AS_CLASSES macro.

2013-01-04: wsfulton
            [Java] Pull patch #2 from BrantKyser to fix SF Bug #1283 - fix smart pointers in conjuction
            with directors.

2013-01-03: wsfulton
            [Java] Pull patch #1 from BrantKyser to fix SF Bug #1278 - fix directors and nspace feature when
            multilevel namespaces are used.

Version 2.0.9 (16 December 2012)
================================

2012-12-16: wsfulton
            Fix garbage line number / empty file name reporting for some missing
            '}' or ')' error messages.

2012-12-15: kkaempf
            [Ruby] Apply patch 3530444, Class#methods and Class#constants returns array of
            symbols in Ruby 1.9+

2012-12-14: kkaempf
            [Ruby] Apply patch 3530439 and finally replace all occurrences of the STR2CSTR() macro
            with StringValuePtr(). STR2CSTR was deprecated since years and got removed in Ruby 1.9

2012-12-14: kkaempf
            [Ruby] Applied patches #3530442 and 3530443 to adapt compile and runtime include
            paths to match Ruby 1.9+

2012-12-14: wsfulton
            [CFFI] Fix #3161614 - Some string constants are incorrect

2012-12-13: wsfulton
            [CFFI] Fix #3529690 - Fix incorrect constant names.

2012-12-12: drjoe
	    [R] add fix to finalizer that was missed earlier

2012-12-11: wsfulton
            [Python] Apply patch #3590522 - fully qualified package paths for Python 3 even if a module is in the
            same package.

2012-12-08: wsfulton
            [Python] Bug #3563647 - PyInt_FromSize_t unavailable prior to Python 2.5 for unsigned int types.

2012-12-08: wsfulton
            [Perl] Fix bug #3571361 - C++ comment in C wrappers.

2012-12-07: wsfulton
            [C#] Apply patch #3571029 which adds missing director support for const unsigned long long &.

2012-11-28: kwwette
            [Octave] Simplified module loading: now just the syntax
            $ example;
            is accepted, which loads functions globally but constants and variables relative to the current scope.
            This make module loading behaviour reliably consistent, and reduces problems when loading modules which
            depend on other modules which may not have been previously loaded.

2012-11-27: wsfulton
            [cffi] Fix junk output when wrapping single character literal constants.

2012-11-17: wsfulton
            [Tcl, Modula3] Add missing support for -outdir.

2012-11-17: wsfulton
            Fix segfaults when using filename paths greater than 1024 characters in length.

2012-11-14: wsfulton
            [ccache-swig] Apply patch #3586392 from Frederik Deweerdt to fix some error cases - incorrectly using
            memory after it has been deleted.

2012-11-09: vzeitlin
            [Python] Fix overflow when passing values greater than LONG_MAX from Python 3 for parameters with unsigned long C type.

2012-11-09: wsfulton
            Fix some feature matching issues for implicit destructors and implicit constructors and implicit
            copy constructors added with %copyctor. Previously a feature for these had to be fully qualified
            in order to match. Now the following will also match:

              %feature("xyz") ~XXX();
              struct XXX {};

2012-11-09: wsfulton
            Further consistency in named output typemap lookups for implicit constructors and destructors and
            implicit copy constructors added with %copyctor. Previously only the fully qualified name was being
            used, now the unqualified name will also be used. For example, previously:

              example.i:38: Searching for a suitable 'out' typemap for: void Space::More::~More
                Looking for: void Space::More::~More
                Looking for: void

            Now the unqualified name is also used:

              example.i:38: Searching for a suitable 'out' typemap for: void Space::More::~More
                Looking for: void Space::More::~More
                Looking for: void ~More
                Looking for: void

2012-11-02: wsfulton
            Fix some subtle named output typemap lookup misses, the fully qualified name was not always being
            used for variables, for example:

              struct Glob {
                int MyVar;
              };

            Previously the search rules (as shown by -debug-tmsearch) for the getter wrapper were:

              example.i:44: Searching for a suitable 'out' typemap for: int MyVar
                Looking for: int MyVar
                Looking for: int

            Now the scope is named correctly:

              example.i:44: Searching for a suitable 'out' typemap for: int Glob::MyVar
                Looking for: int Glob::MyVar
                Looking for: int MyVar
                Looking for: int

2012-10-26: wsfulton
            Fix director typemap searching so that a typemap specified with a name will be correctly matched. Previously
            the name was ignored during the typemap search. Applies to the following list of typemaps: 
            directorout, csdirectorout, cstype, imtype, ctype, ddirectorout, dtype, gotype, jtype, jni, javadirectorout.

2012-10-11: wsfulton
            Most of the special variables available for use in %exception are now also available for expansion in
            %extend blocks. These are: $name $symname $overname $decl $fulldecl $parentclassname $parentclasssymname, see docs
            on "Class extension" in SWIGPlus.html. Patch based on submission from Kris Thielemans.

2012-10-10: wsfulton
            Additional new special variables in %exception are expanded as follows:
              $parentclassname - The parent class name (if any) for a method.
              $parentclasssymname - The target language parent class name (if any) for a method.

2012-10-08: iant
	    [Go] Generating Go code now requires using the -intgosize option to
	    indicate the size of the 'int' type in Go.  This is because the
	    size of the type is changing from Go 1.0 to Go 1.1 for x86_64. 

2012-09-14: wsfulton
	    Add new warning if the empty template instantiation is used as a base class, for example:

              template <typename T> class Base {};
              %template() Base<int>;
              class Derived : public Base<int> {};

            gives the following warning instead of silently ignoring the base:

            cpp_inherit.i:52: Warning 401: Base class 'Base< int >' has no name as it is an empty template instantiated with '%template()'. Ignored.
            cpp_inherit.i:51: Warning 401: The %template directive must be written before 'Base< int >' is used as a base class and be declared with a name.


2012-09-11: wsfulton
	    [Java] Fix #3535304 - Direct use of a weak global reference in directors
            sometimes causing seg faults especially on Android.

2012-09-06: wsfulton
	    [Java] Fix (char *STRING, size_t LENGTH) typemaps to accept NULL string.

2012-08-26: drjoe
	    [R] make ExternalReference slot ref to contain reference

2012-08-26: drjoe
	    [R] fix Examples/Makefile to use C in $(CC) rather than $(CXX)

Version 2.0.8 (20 August 2012)
==============================

2012-08-15: wsfulton
            [Perl] Add size_type, value_type, const_reference to the STL containers.

2012-08-15: wsfulton
            [Python] Add discard and add methods to std::set wrappers so that pyabc.i can be used ensuring
            MutableSet is a valid abstract base class for std::set. As reported by Alexey Sokolov.
            Similarly for std::multiset.

2012-08-15: wsfulton
            [Python] Fix #3541744 - Missing PyInt_FromSize_t calls for Python 3.

2012-08-13: wsfulton
            [Java] Patch from David Baum to add the assumeoverride feature for Java directors to
            improve performance when all overridden methods can be assumed to be overridden.

2012-08-05: wsfulton
            [Python] #3530021 Fix unused variable warning.

2012-08-05: wsfulton
            [C#] Fix #3536360 - Invalid code sometimes being generated for director methods
            with many arguments.

2012-08-05: wsfulton
            [Perl] #3545877 - Don't undefine bool if defined by C99 stdbool.h - problem using 
            Perl 5.16 and later.

2012-08-04: wsfulton
            Remove incorrect warning (314) about target language keywords which were triggered
            by using declarations and using directives. For example 'string' is a keyword in C#:
              namespace std { class string; }
              using std::string;

2012-07-21: wsfulton
            Fix display of pointers in various places on 64 bit systems - only 32 bits were being shown.

2012-07-21: wsfulton
            Fix gdb debugger functions 'swigprint' and 'locswigprint' to display to the gdb output window
            rather than stdout. This fixes display problems in gdbtui and the ensures the output
            appears where expected in other gdb based debuggers such as Eclipse CDT.

2012-07-20: kwwette
            [Octave] segfault-on-exit prevention hack now preserves exit status, and uses C99 _Exit().

2012-07-02: wsfulton
            Fix Debian bug http://bugs.debian.org/672035, typemap copy failure - regression introduced 
            in swig-2.0.5:
              %include<stl.i>
              using std::pair;
              %template(StrPair) pair<std::string, std::string>;

2012-07-02: wsfulton
            Fix using declarations combined with using directives with forward class declarations so that
            types are correctly found in scope for templates. Example:

              namespace Outer2 {
                namespace Space2 {
                  template<typename T> class Thing2;
                }
              }
              using namespace Outer2;
              using Space2::Thing2;
              template<typename T> class Thing2 {};
              // STILL BROKEN void useit2(Thing2<int> t) {}
              void useit2a(Outer2::Space2::Thing2<int> t) {}
              void useit2b(::Outer2::Space2::Thing2<int> t) {}
              void useit2c(Space2::Thing2<int> t) {}
              namespace Outer2 {
                void useit2d(Space2::Thing2<int> t) {}
              }

              %template(Thing2Int) Thing2<int>;


2012-06-30: wsfulton
            Fix template namespace problems for symbols declared with a forward class declarations, such as:

              namespace Space1 {
                namespace Space2 {
                  template<typename T> struct YYY;
                }
                template<typename T> struct Space2::YYY {
                  T yyy(T h) {
                    return h;
                  }    
                };
                void testYYY1(Space1::Space2::YYY<int> yy) {}
                void testYYY2(Space2::YYY<int> yy) {}
                void testYYY3(::Space1::Space2::YYY<int> yy) {}
              }

              %template(YYYInt) Space1::Space2::YYY<int>;

2012-06-30: wsfulton
            Fix namespace problems for symbols declared with a forward class declarations, such as:

              namespace Space1 {
                namespace Space2 {
                  struct XXX;
                  struct YYY;
                }

                struct Space2::YYY {};
                struct Space1::Space2::XXX {};

                void testXXX2(Space2::XXX xx) {}
                void testYYY2(Space2::YYY yy) {}
              }

            where xx and yy were not recognised as the proxy classes XXX and YYY.

2012-06-30: wsfulton
            Fix using declarations combined with using directives with forward class declarations so that
            types are correctly found in scope. 

              namespace Outer2 {
                namespace Space2 {
                  class Thing2;
                }
              }
              using namespace Outer2;
              using Space2::Thing2;
              class Thing2 {};
              // None of the methods below correctly used the Thing2 proxy class
              void useit2(Thing2 t) {}
              void useit2a(Outer2::Space2::Thing2 t) {}
              void useit2b(::Outer2::Space2::Thing2 t) {}
              void useit2c(Space2::Thing2 t) {}
              namespace Outer2 {
                void useit2d(Space2::Thing2 t) {}
              }

2012-06-25: wsfulton
            Fix using declarations combined with using directives so that types are correctly found in scope.
            Example:

              namespace Outer2 {
                namespace Space2 {
                  class Thing2 {};
                }
              }
              using namespace Outer2; // using directive
              using Space2::Thing2; // using declaration
              void useit2(Thing2 t) {}

            Similarly for templated classes.

2012-05-29: wsfulton
            Fix #3529601 - seg fault when a protected method has the "director"
            feature but the parent class does not. Also fix similar problems with
            the allprotected feature.

2012-05-28: wsfulton
            Fix seg fault when attempting to warn about an illegal destructor - #3530055, 3530078 and #3530118.

Version 2.0.7 (26 May 2012)
===========================
2012-05-26: wsfulton
            std::string typemap modifications so they can be used with %apply for other string
            classes.

2012-05-25: wsfulton
            [Lua] Fixes for -external-runtime to work again.

2012-05-22: szager
	    [python] Disambiguate SWIG_From_unsigned_SS_int and SWIG_From_unsigned_SS_long.

2012-05-18: olly
	    [PHP] Fix getters for template members. (SF#3428833, SF#3528035)

2012-05-14: wsfulton
            Fix some language's std::map wrappers to recognise difference_type, size_type, key_type
            and mapped_type.

2012-05-14: kwwette (signed off by xavier98)
            [Octave] Prevent Octave from seg-faulting at exit when SWIG
            modules are loaded, due to bugs in Octave's cleanup code:
            * Wrapping functions now declared with Octave DEFUN_DLD macro,
              and loaded through Octave's dynamic module loader
            * Global variables of swigref type are now assigned a new()
              copy of the swigref class, to prevent double-free errors
            * SWIG module at-exit cleanup function now created in Octave
              through eval(), so not dependent on loaded .oct library
            * For Octave versions 3.1.* to 3.3.*, register C-level at-exit
              function which terminates Octave immediately (with correct
              status code) without performing memory cleanup. This function
              can be controlled with macros in Lib/octave/octruntime.swg

            [Octave] New syntax for determing whether SWIG module should be
            loaded globally or non-globally. To load module "example" globally,
            type the module name
            $ example;
            as before; to load module non-globally, assign it to a variable:
            $ example = example;
            or
            $ ex = example;
            for a shorter (local) module name. -global/-noglobal command-line
            options and module command line are deprecated. Added usage info
            to module, so typing
            $ help example
            or incorrect usage should display proper usage, with examples.

            *** POTENTIAL INCOMPATIBILITY  ***

2012-05-12: olly
	    [PHP] Fix memory leak in code generated for a callback.  Patch from
	    SF bug #3510806.

2012-05-12: olly
	    [PHP] Avoid using zend_error_noreturn() as it doesn't work with all
	    builds of PHP (SF bug #3166423).  Instead we now wrap it in a
	    SWIG_FAIL() function which we annotate as "noreturn" for GCC to
	    avoids warnings.  This also reduces the size of the compiled
	    wrapper (e.g. the stripped size is reduced by 6% for Xapian's PHP
	    bindings).

2012-05-11: wsfulton
            [Java] SF patch #3522855 Fix unintended uninitialised memory access in OUTPUT typemaps.

2012-05-11: wsfulton
            [Java] SF patch #3522674 Fix possible uninitialised memory access in char **STRING_OUT
            typemap.

2012-05-11: wsfulton
            [Java] SF patch #3522611 Fix uninitialised size regression in char **STRING_ARRAY
            introduced in swig-2.0.6.

2012-05-11: wsfulton
            SF bug #3525050 - Fix regression introduced in swig-2.0.5 whereby defining one typemap
            method such as an 'out' typemap may hide another typemap method such as an 'in' typemap -
            only occurs when the type is a template type where the template parameters are the same
            via a typedef.

2012-05-10: olly
	    [PHP] Fix the constant typemaps for SWIGTYPE, etc - previously
	    these used the wrong name for renamed constants.  Add
	    autodoc_runme.php to the testsuite as a regression test for this.

2012-05-02: ianlancetaylor
	    [Go] Remove compatibility support for gccgo 4.6.  Using
	    SWIG with gccgo will now require gccgo 4.7.  Using SWIG
	    with the more commonly used gc compiler is unaffected.

2012-05-01: wsfulton
            Fix generated code for C forward enum declarations in some languages.

Version 2.0.6 (30 April 2012)
=============================

2012-04-25: wsfulton
            [Lua] Fix uninitialised variable in SWIGTYPE **OUTPUT typemaps as reported by Jim Anderson.

2012-04-28: wsfulton
            [Python] Fix compilation errors when wrapping STL containers on Mac OS X and possibly other systems.

2012-04-28: wsfulton
            [Java] Patch 3521811 from Leo Davis - char **STRING_ARRAY typemaps fixed to handle
            null pointers.

Version 2.0.5 (19 April 2012)
=============================

2012-04-14: wsfulton
            [Lua] Apply patch #3517435 from Miles Bader - prefer to use Lua_pushglobaltable

2012-04-14: wsfulton
            [Ruby] Apply patch #3517769 from Robin Stocker to fix compile error on MacRuby using RSTRING_PTR.

2012-04-13: wsfulton
            Apply patch #3511009 from Leif Middelschulte for slightly optimised char * variable wrappers.

2012-04-13: wsfulton
            [Lua] Apply #3219676 from Shane Liesegang which adds:
            - support for %factory
            - a __tostring method
            - a __disown method

2012-04-13: wsfulton
            [Xml] Apply #3513569 which adds a catchlist to the xml output.

2012-04-05: olly
	    [Lua] Add support for Lua 5.2 (patch SF#3514593 from Miles Bader)

2012-03-26: xavier98
	    [octave] Apply patch #3425993 from jgillis: add extra logic to the octave_swig_type::dims(void) method: it checks if the user has defined a __dims__ method and uses this in stead of returning (1,1)
	    [octave] Apply patch #3424833 from jgillis: make is_object return true for swig types

2012-03-24: wsfulton
            [D] Apply #3502431 to fix duplicate symbols in multiple modules.

2012-03-21: wsfulton
            Fix #3494791 - %$isglobal for %rename matching.

2012-03-20: wsfulton
            Fix #3487706 and #3391906 - missing stddef.h include for ptrdiff_t when using %import
            for STL containers and compiling with g++-4.6. An include of stddef.h is now only
            generated when SWIG generates STL helper templates which require ptrdiff_t. If you 
            were previously relying on "#include <stddef.h>" always being generated when using a
            %include of an STL header, you may now need to add this in manually.

2012-03-16: wsfulton
            Apply patch #3392264 from Sebastien Bine to parse (unsigned) long long types in enum value assignment.

2012-03-16: wsfulton
            Apply patch #3505530 from Karl Wette to allow custom allocators in STL string classes for the UTL languages.

2012-03-13: wsfulton
            Apply patch #3468362 from Karl Wette to fix %include inside %define.

2012-03-13: wsfulton
            [Python, Ruby, Octave, R] Fix #3475492 - iterating through std::vector wrappers of enumerations.

2012-02-27: xavier98 (patches from Karl Wette)
	    [Octave] Use -globals . to load global variables in module namespace
	    [Octave] Comment declaration of unimplemented function swig_register_director
	    [Octave] Fix OCTAVE_PATH in octave Makefiles
	    [Octave] Add support for std::list - fix li_std_containers_int test
	    [Octave] Fix imports test

2012-02-16: wsfulton
            [Java] Make generated support functions in arrays_java.i static so that generated code
            from multiple instances of SWIG can be compiled and linked together - problem reported by
            Evan Krause.

2012-01-24: wsfulton
            Fix crash with bad regex - bug #3474250.

2012-01-24: wsfulton
            [Python] Add Python stepped slicing support to the STL wrappers (std::vector, std::list).
            Assigning to a slice, reading a slice and deleting a slice with steps now work.
            For example:

            %template(vector_i) std::vector<int>

              vi = vector_i(range(10))
              print list(vi)
              vi[1:4:2] = [111, 333]
              print list(vi)
              del vi[3:10:3]
              print list(vi)
              print list(vi[::-1])

            gives (same behaviour as native Python sequences such as list):

              [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]
              [0, 111, 2, 333, 4, 5, 6, 7, 8, 9]
              [0, 111, 2, 4, 5, 7, 8]
              [8, 7, 5, 4, 2, 111, 0]

2012-01-23: klickverbot
            [D] Correctly annotate function pointers with C linkage.
            [D] Exception and Error have become blessed names; removed d_exception_name test case.

2012-01-20: wsfulton
            [Python] Fix some indexing bugs in Python STL wrappers when the index is negative, eg:

            %template(vector_i) std::vector<int>

              iv=vector_i([0,1,2,3,4,5])
              iv[-7:]

            now returns [0, 1, 2, 3, 4, 5] instead of [5].

              vv[7:9] = [22,33]

            now returns [0, 1, 2, 3, 4, 5, 22, 33] instead of "index out range" error.

            Also fix some segfaults when replacing ranges, eg when il is a std::list wrapper:

              il[0:2] = [11]

2012-01-17: wsfulton
            [Go] Fix forward class declaration within a class when used as a base.

2012-01-07: wsfulton
            [C#] Add support for %nspace when using directors.

2012-01-06: wsfulton
            [Java] Patch #3452560 from Brant Kyser - add support for %nspace when using directors.

2011-12-21: wsfulton
            The 'directorin' typemap now accepts $1, $2 etc expansions instead of having to use workarounds -
            $1_name, $2_name etc.

2011-12-20: wsfulton
            [Java] Add (char *STRING, size_t LENGTH) director typemaps.

2011-12-20: wsfulton
            [C#, Go, Java, D] Add support for the 'directorargout' typemap.

2011-12-20: wsfulton
            [Ocaml, Octave, PHP, Python, Ruby] Correct special variables in 'directorargout' typemap.
            This change will break any 'directorargout' typemaps you may have written. Please change:
              $result to $1
              $input to $result

            Also fix the named 'directorargout' DIRECTOROUT typemaps for these languages which didn't
            previously compile and add in $1, $2 etc expansion.

            *** POTENTIAL INCOMPATIBILITY  ***

2011-12-10: talby
            [perl5] SWIG_error() now gets decorated with perl source file/line number.
            [perl5] error handling now conforms to public XS api (fixes perl v5.14 issue).

2011-12-10: wsfulton
            [Android/Java] Fix directors to compile on Android.

            Added documentation and examples for Android.

2011-12-08: vadz
	    Bug fix: Handle methods renamed or ignored in the base class correctly in the derived classes
	    (they could be sometimes mysteriously not renamed or ignored there before).

2011-12-03: klickverbot
            [D] Fix exception glue code for newer DMD 2 versions.
            [D] Do not default to 32 bit glue code for DMD anymore.
            [D] Use stdc.config.c_long/c_ulong to represent C long types.

2011-12-01: szager
	    [python] Fixed bug 3447426: memory leak in vector.__getitem__.

2011-11-30: wsfulton
            [R] Remove C++ comments from generated C code.

2011-11-27: olly
	    [Python] Fix some warnings when compiling generated wrappers with
	    certain GCC warning options (Debian bug #650246).

2011-11-28: wsfulton
            Fix #3433541 %typemap(in, numinputs=0) with 10+ arguments.

2011-11-28: olly
	    [Perl] Fix warnings when compiling generated wrappers with certain
	    GCC warning options (Debian bug #436711).

2011-11-28: olly
	    [PHP] Update keyword list to include keywords added in PHP releases up to 5.3.

2011-11-25: wsfulton
            [C#] Provide an easy way to override the default visibility for the proxy class pointer
            constructors and getCPtr() method. The visibility is 'internal' by default and if multiple
            SWIG modules are being used and compiled into different assemblies, then they need to be 
            'public' in order to use the constructor or getCPtr() method from a different assembly.
            Use the following macros to change the visibilities in the proxy and type wrapper class:

              SWIG_CSBODY_PROXY(public, public, SWIGTYPE)
              SWIG_CSBODY_TYPEWRAPPER(public, public, public, SWIGTYPE)

            [Java] Provide an easy way to override the default visibility for the proxy class pointer
            constructors and getCPtr() method. The visibility is 'protected' by default and if multiple
            SWIG modules are being used and compiled into different packages, then they need to be 
            'public' in order to use the constructor or getCPtr() method from a different package.
            Use the following macros to change the visibilities in the proxy and type wrapper class:

              SWIG_JAVABODY_PROXY(public, public, SWIGTYPE)
              SWIG_JAVABODY_TYPEWRAPPER(public, public, public, SWIGTYPE)

            The default for Java has changed from public to protected for the proxy classes. Use the
            SWIG_JAVABODY_PROXY macro above to restore to the previous visibilities.

            *** POTENTIAL INCOMPATIBILITY  ***

2011-11-22: szager
	    [python] Bug 3440044: #ifdef out SWIG_Python_NonDynamicSetAttr if -builtin
	    isn't being used, to avoid unnecessary binary incompatibilities between
	    python installations.

2011-11-17: wsfulton
            Bug fix: Remove root directory from directory search list in Windows.

2011-11-13: wsfulton
            [Ruby] Apply patch #3421876 from Robin Stocker to fix #3416818 - same class name in 
            different namespaces confusion when using multiple modules.

2011-11-11: wsfulton
            Fix pcre-build.sh to work with non-compressed tarballs - problem reported by Adrian Blakely.

2011-11-03: wsfulton
            Expand special variables in typemap warnings, eg:

              %typemap(in, warning="1000:Test warning for 'in' typemap for $1_type $1_name") int "..."

2011-11-01: wsfulton
            Fix named output typemaps not being used when the symbol uses a qualifier and contains
            a number, eg:

              %typemap(out) double ABC::m1 "..."

2011-10-24: talby
            [perl5] SF bug #3423119 - overload dispatch stack corruption fix.  Better, but more research
            is needed on a stable path for tail calls in XS.

            Also, fix for large long longs in 32 bit perl.

2011-10-13: xavier98
	    [octave] Allow Octave modules to be re-loaded after a "clear all".

2011-09-19: wsfulton
            Fix regression introduced in swig-2.0.1 reported by Teemu Ikonone leading to uncompilable code
            when using typedef and function pointer references, for example: 

              typedef int FN(const int &a, int b);
              void *typedef_call1(FN *& precallback, FN * postcallback);

2011-09-14: wsfulton
            [Lua] Patch #3408012 from Raman Gopalan - add support for embedded Lua (eLua)
            including options for targeting Lua Tiny RAM (LTR).

2011-09-14: wsfulton
            [C#] Add boost_intrusive_ptr.i library contribution from patch #3401571.

2011-09-13: wsfulton
            Add warnings for badly named destructors, eg:

              struct KStruct {
                ~NOT_KStruct() {}
              };

            cpp_extend_destructors.i:92: Warning 521: Illegal destructor name ~NOT_KStruct. Ignored.

2011-09-13: wsfulton
            Fix %extend and destructors for templates. The destructor in %extend was not always wrapped,
            for example:

              %extend FooT {
                ~FooT() { delete $self; } // was not wrapped as expected
              };
              template<class T> class FooT {};
              %template(FooTi) FooT<int>;

2011-09-13: wsfulton
            Fix special variables such as "$decl" and "$fulldecl" in destructors to include the ~ character.

2011-09-10: talby
            [perl5] SF bug #1481958 - Improve range checking for integer types.
            Enhance li_typemaps_runme.pl

2011-09-08: wsfulton
            Fix %extend on typedef classes in a namespace using the typedef name, for example:
            namespace Space {
              %extend CStruct {
                ...
              }
              typedef struct tagCStruct { ... } CStruct;
            }

2011-08-31: xavier98
	    [octave] patches from Karl Wette: improvements to module loading behavior;
	    added example of friend operator to operator example; fixed octave panic/crash in 3.0.5;
	    documentation improvements

2011-08-30: szager
	    [python] Bug 3400486, fix error signalling for built-in constructors.

2011-08-26: wsfulton
            [Go] Fix file/line number display for "gotype" when using typemap debugging options
            -tmsearch and -tmused.

2011-08-26: wsfulton
            [C#, D] Fix %callback which was generating uncompilable code.

2011-08-25: wsfulton
            Fix constructors in named typedef class declarations as reported by Gregory Bronner:

            typedef struct A {
              A(){} // Constructor which was not accepted by SWIG
              B(){} // NOT a constructor --illegal, but was accepted by SWIG
            } B;

            For C code, the fix now results in the use of 'struct A *' instead of just 'B *' in
            the generated code when wrapping members in A, but ultimately this does not matter, as
            they are the same thing.

2011-08-23: wsfulton
            Fix %newobject when used in conjunction with %feature("ref") as reported by Jan Becker. The
            code from the "ref" feature was not always being generated for the function specified by %newobject.
            Documentation for "ref" and "unref" moved from Python to the C++ chapter.

2011-08-22: szager
	    [python] Fixed memory leak with --builtin option (bug 3385089).

2011-08-22: wsfulton
            [Lua] SF patch #3394339 from Torsten Landschoff - new option -nomoduleglobal to disable installing 
            the module table into the global namespace. Require call also returns the module table instead 
            of a string.

2011-08-09: xavier98
            Fix bug 3387394; Octave patches for 3.4.0 compatibility, etc. (from Karl Wette)

2011-08-04: wsfulton
            Add in $symname expansion for director methods.

2011-07-29: olly
	    [PHP] Don't generate "return $r;" in cases where $r hasn't been set.
	    This was basically harmless, except it generated a PHP E_NOTICE if
	    the calling code had enabled them.

2011-07-26: wsfulton
            Fix scoping of forward class declarations nested within a class (for C++). Previously the symbol
            was incorrectly put into the outer namespace, eg

            namespace std {
              template<class Key, class T> struct map {
                class iterator;
              };
            }

            iterator was scoped as std::iterator, but now it is correctly std::map<Key, T>::iterator;

            Also fixed is %template and template parameters that are a typedef when the template contains
            default template parameters, eg:

            namespace Std {
              template<class Key, class T, class C = int> struct Map {
                typedef Key key_type;
                typedef T mapped_type;
              };
            }
            typedef double DOUBLE;
            %template(MM) Std::Map<int, DOUBLE>;

            All symbols within Map will be resolved correctly, eg key_type and mapped_type no matter if the
            wrapped code uses Std::Map<int, double> or std::Map<int, DOUBLE> or Std::Map<int, double, int>

            Also fixes bug #3378145 - regression introduced in 2.0.4 - %template using traits.

2011-07-20  szager
	    [python] Fix closure for tp_call slot.

2011-07-16: wsfulton
	    [python] Fix director typemap using PyObject *.

2011-07-13: szager
	    [python] SF patch #3365908 - Add all template parameters to map support code in std_map.i

2011-07-13: szager
	    [python] Fix for bug 3324753: %rename member variables with -builtin.

2011-07-01: wsfulton
	    Fix some scope and symbol lookup problems when template default parameters are being
            used with typedef. For example:

            template<typename XX, typename TT = SomeType> struct Foo {
              typedef XX X;
              typedef TT T;
            };
            template<typename TT> struct UsesFoo {
              void x(typename Foo<TT>::T, typename Foo<TT>::X);
            };

            Also fixes use of std::vector<int>::size_type for Python as reported by Aubrey Barnard.

2011-06-23: olly
	    [PHP] Fix director code to work when PHP is built with ZTS enabled,
	    which is the standard configuration on Microsoft Windows.

2011-06-21: mutandiz
	    [allegrocl]
	    - various small tweaks and bug fixes.
	    - Avoid name conflicts between smart pointer wrappers and the wrappers for
	    the actual class.
	    - Fix default typemaps for C bindings, which were incorrectly attempting to
	    call non-existent destructors on user-defined types.
	    - New feature, feature:aclmixins, for adding superclass to the foreign class
	    wrappers.
	    - Improve longlong typemaps.

2011-06-19: wsfulton
	    Fix incorrect typemaps being used for a symbol within a templated type, eg:
            A<int>::value_type would incorrectly use a typemap for type A.

2011-06-18: olly
	    [Tcl] Fix variable declarations in middle of blocks which isn't
	    permitted in C90 (issue probably introduced in 2.0.3 by patch #3224663).
	    Reported by Paul Obermeier in SF#3288586.

2011-06-17: wsfulton
	    [Java] SF #3312505 - slightly easier to wrap char[] or char[ANY] with a Java byte[]
            using arrays_java.i.

2011-06-13: wsfulton
	    [Ruby, Octave] SF #3310528 Autodoc fixes similar to those described below for Python.

2011-06-10: wsfulton
	    [Python] Few subtle bugfixes in autodoc documentation generation,
            - Unnamed argument names fix for autodoc levels > 0.
            - Display of template types fixed for autodoc levels > 1.
            - Fix SF #3310528 - display of typedef structs for autodoc levels > 1.
            - Add missing type for self for autodoc levels 1 and 3.
            - autodoc levels 2 and 3 documented.
            - Minor tweaks to autodoc style to conform with PEP8.

2011-05-30: olly
	    [PHP] Fix handling of directors when -prefix is used.

2011-05-24: olly
	    [PHP] Fix handling of methods of classes with a virtual base class (SF#3124665).

Version 2.0.4 (21 May 2011)
===========================

2011-05-19: wsfulton
	    [Guile] Patch #3191625 fixing overloading of integer types.

2011-05-19: wsfulton
	    [Perl] Patch #3260265 fixing overloading of non-primitive types and integers in 
            Perl 5.12 and later.

2011-05-19: wsfulton
	    [Ruby] Fix %import where one of the imported files %include one of the STL include
            files such as std_vector.i.

2011-05-17: wsfulton
	    [Java] Apply #3289851 from Alan Harder to fix memory leak in directors when checking
            for pending exceptions.

2011-05-17: wsfulton
	    [Tcl] Apply #3300072 from Christian Delbaere to fix multiple module loading not
            always sharing variables across modules.

2011-05-16: xavier98
	    [octave] Fix an incompatibility with never versions of Octave. Case on Octave
	    API >= 40 to handle rename of Octave_map to octave_map.
	    [octave] Add support for y.__rop__(x) operators when x.__op__(y) doesn't exist.
	    [octave] Allow global operators to be defined by SWIG-wrapped functions.
	    [octave] Fix several bugs around module namespaces; add -global, -noglobal,
	    -globals <name> command line options to the module.

2011-05-14: wsfulton
	    %varargs when used with a numeric argument used to create an additional argument 
            which was intended to provide a guaranteed sentinel value. This never worked and now
            the additional argument is not generated.

2011-05-13: wsfulton
	    [python] Additional fixes for python3.2 support.

2011-05-07: szager
	    [python] Fixed PyGetSetDescr for python3.2.

2011-05-05: wsfulton
            [Lua, Python, Tcl] C/C++ prototypes shown in error message when calling an overloaded
            method with incorrect arguments improved to show always show fully qualified name
            and if a const method. 

            Also fixed other Lua error messages in generated code which weren't consistently
            using the fully qualified C++ name - requested by Gedalia Pasternak.

2011-04-29: szager
	    Bug 2635919: Convenience method to convert std::map to a python dict.

2011-04-29: szager
	    [Python] Fixed bug 2811549: return non-const iterators from STL
	    methods begin(), end(), rbegin(), rend().

2011-04-25: szager
	    [Python] Fixed bug 1498929: Access to member fields in map elements

2011-04-23: klickverbot
            [D] nspace: Correctly generate identifiers for base classes when
            not in split proxy mode.

2011-04-13: szager
	    Fixed bug 3286333: infinite recursion with mutual 'using namespace' clauses.

2011-04-12: szager
	    Fixed bug 1163440: vararg typemaps.

2011-04-12: szager
	    Fixed bug #3285386: parse error from 'operator T*&()'.  Added operator_pointer_ref
	    test case to demonstrate.

2011-04-11: szager
	    [Python] Fixed PyVarObject_HEAD_INIT to eliminate VC++ compiler errors about
	    static initialization of struct members with pointers.

2011-04-11: wsfulton
            [Tcl] Apply patch #3284326 from Colin McDonald to fix some compiler warnings.

2011-04-11: szager
	    [Python] Fixed PyVarObject_HEAD_INIT to eliminate VC++ compiler errors about
	    static initialization of struct members with pointers.

2011-04-10: klickverbot
            [D] Fixed wrapping of enums that are type char, for example:
            enum { X = 'X'; } (this was already in 2.0.3 for C# and Java)

2011-04-10: klickverbot
            [D] nspace: Fixed referencing types in the root namespace when
            not in split proxy mode.

2011-04-09: szager
	    [Python] Applied patch #1932484: migrate PyCObject to PyCapsule.

2011-04-09: szager
	    [Python] Added preprocessor guards for python functions PyUnicode_AsWideChar and
	    PySlice_GetIndices, which changed signatures in python3.2.

2011-04-07: wsfulton
            Fix wrapping of const array typedefs which were generating uncompilable code as
            reported by Karl Wette.

2011-04-03: szager
	    [Python] Fixed the behavior of %pythonnondynamic to conform to the spec in Lib/pyuserdir.swg.

2011-04-03: szager
	    [Python] Merged in the szager-python-builtin branch, adding the -builtin feature
	    for python.  The -builtin option may provide a significant performance gain
	    in python wrappers.  For full details and limitations, refer to Doc/Manual/Python.html.
	    A small test suite designed to demonstrate the performance gain is in
	    Examples/python/performance.

2011-04-01: wsfulton
            Add in missing wrappers for friend functions for some target languages, mostly
            the non-scripting languages like Java and C#.

Version 2.0.3 (29 March 2011)
=============================

2011-03-29: wsfulton
            [R] Apply patch #3239076 from Marie White fixing strings for R >= 2.7.0

2011-03-29: wsfulton
            [Tcl] Apply patch #3248280 from Christian Delbaere which adds better error messages when
            the incorrect number or type of arguments are passed to overloaded methods.

2011-03-29: wsfulton
            [Tcl] Apply patch #3224663 from Christian Delbaere.
            1. Fix when function returns a NULL value, a "NULL" command will be created in the Tcl interpreter
            and calling this command will cause a segmentation fault. 

            2. Previous implementation searches for class methods using a linear search causing performance issues
            in wrappers for classes with many member functions. The patch adds a method hash table to classes and
            changes method name lookup to use the hash table instead of doing a linear search.

2011-03-26: wsfulton
	    [C#, Java] SF bug #3195112 - fix wrapping of enums that are type char, for example:
              enum { X = 'X'; }

2011-03-21: vadz
	    Allow setting PCRE_CFLAGS and PCRE_LIBS during configuration to override the values returned by
	    pcre-config, e.g. to allow using a static version of PCRE library.

2011-03-17: wsfulton
	    [UTL] Add missing headers in generated STL wrappers to fix compilation with gcc-4.6.

2011-03-17: wsfulton
	    Fix regression introduced in swig-2.0.2 where filenames with spaces were not found
	    when used with %include and %import. Reported by Shane Liesegang.

2011-03-15: wsfulton
	    [UTL] Fix overloading when using const char[], problem reported by David Maxwell.
            Similarly for char[ANY] and const char[ANY].

2011-03-15: wsfulton
	    [C#] Apply patch #3212624 fixing std::map Keys property.

2011-03-14: olly
	    [PHP] Fix handling of overloaded methods/functions where some
	    return void and others don't - whether this worked or not depended
	    on the order they were encountered in (SF#3208299).
	
2011-03-13: klickverbot
            [D] Extended support for C++ namespaces (nspace feature).

2011-03-12: olly
	    [PHP] Fix sharing of type information between multiple SWIG-wrapped
	    modules (SF#3202463).

2011-03-09: wsfulton
	    [Python] Fix SF #3194294 - corner case bug when 'NULL' is used as the default value
            for a primitive type parameter in a method declaration.

2011-03-07: olly
	    [PHP] Don't use zend_error_noreturn() for cases where the function
	    returns void - now this issue can only matter if you have a function
	    or method which is directed and returns non-void.

2011-03-06: olly
	    [PHP] Add casts to the typemaps for long long and unsigned long
	    long to avoid issues when they are used with shorter types via
	    %apply.

2011-03-02: wsfulton
	    Templated smart pointers overloaded with both const and non const operator-> generated uncompilable
	    code when the pointee was a class with either public member variables or static methods.
	    Regression in 2.0.x reported as working in 1.3.40 by xantares on swig-user mailing list.

Version 2.0.2 (20 February 2011)
================================

2011-02-19: wsfulton
	    [PHP] Add missing INPUT, OUTPUT and INOUT typemaps in the typemaps.i library
            for primitive reference types as well as signed char * and bool *.

2011-02-19: olly
	    [PHP] Address bug in PHP on some platforms/architectures which
	    results in zend_error_noreturn() not being available using
	    SWIG_ZEND_ERROR_NORETURN which defaults to zend_error_noreturn but
	    can be overridden when building the module by passing
	    -DSWIG_ZEND_ERROR_NORETURN=zend_error to the compiler.  This may
	    result in compiler warnings, but should at least allow a module
	    to be built on those platforms/architectures (SF#3166423).

2011-02-18: wsfulton
            Fix #3184549 - vararg functions and function overloading when using the -fastdispatch option.

2011-02-18: olly
	    [PHP] An overloaded method which can return an object or a
	    primitive type no longer causes SWIG to segfault.  Reported by Paul
	    Colby in SF#3168531.

2011-02-18: olly
	    [PHP] Fix invalid erase during iteration of std::map in generated
	    director code.  Reported by Cory Bennett in SF#3175820.

2011-02-17: wsfulton
            Preprocessing now warns if extra tokens appear after #else and #end.

2011-02-16: wsfulton
            Fix #1653092 Preprocessor does not error out when #elif is missing an expression.
            This and other cases of missing preprocessor expressions now result in an error.

2011-02-14: wsfulton
            [Ocaml] Apply patch #3151788 from Joel Reymont. Brings Ocaml support up to date 
            (ver 3.11 and 3.12), including std::string.

2011-02-13: wsfulton
            [Ruby] Apply patch #3176274 from James Masters - typecheck typemap for time_t.

2011-02-13: wsfulton
            Apply patch #3171793 from szager - protected director methods failing when -fvirtual is used.

2011-02-13: wsfulton
            Fix #1927852 - #include directives don't preprocess the file passed to it. The fix is for
            #include with -importall or -includeall, %include and %import, for example:
              #define FILENAME "abc.h"
              %include FILENAME

2011-02-12: wsfulton
            Fix #1940536, overactive preprocessor which was expanding defined(...) outside of #if and #elif
            preprocessor directives.

2011-02-05: wsfulton
            [MzScheme] SF #2942899 Add user supplied documentation to help getting started with MzScheme.
            Update chapter name to MzScheme/Racket accounting for the rename of MzScheme to Racket.

2011-02-05: wsfulton
            [C#] SF #3085906 - Possible fix running test-suite on Mac OS X.

2011-02-05: wsfulton
            SF #3173367 Better information during configure about Boost prerequisite for running
            the test-suite.

2011-02-05: wsfulton
            SF #3127633 Fix infinite loop in recursive typedef resolution.

2011-02-04: wsfulton
            [R] SF #3168676 Fix %rename not working for member variables and methods.

2011-02-04: wsfulton
            [clisp] SF #3148200 Fix segfault parsing nested unions.

2011-02-01: wsfulton
            [C#] Directors - a call to a method being defined in the base class, not
            overridden in a subclass, but again overridden in a class derived from
            the first subclass was not being dispatched correctly to the most derived class.
            See director_alternating.i for an example.

2011-02-01: wsfulton
            [C#, Java] Any 'using' statements in the protected section of a class were previously
            ignored with director protected (dirprot) mode.

2011-01-30: wsfulton
            Fix overloading with const pointer reference (SWIGTYPE *const&) parameters for a
            number of scripting languages.

2011-01-17: wsfulton
            New warning for smart pointers if only some of the classes in the inheritance
            chain are marked as smart pointer, eg, %shared_ptr should be used for all classes
            in an inheritance hierarchy, so this new warning highlights code where this is
            not the case.

              example.i:12: Warning 520: Base class 'A' of 'B' is not similarly marked as a smart pointer.
              example.i:16: Warning 520: Derived class 'C' of 'B' is not similarly marked as a smart pointer.

2011-01-14: wsfulton
            Added some missing multi-argument typemaps: (char *STRING, size_t LENGTH) and 
            (char *STRING, int LENGTH). Documentation for this updated. Java patch from
            Volker Grabsch.

2011-01-11: iant
	    Require Go version 7077 or later.

2010-12-30: klickverbot
            [C#, D, Java] Check for collision of parameter names with target
            language keywords when generating the director glue code.
            
            The situation in which the generated could would previously be
            invalid is illustrated in the new 'director_keywords' test case.

